commit 6a3beab6137b262fc847093ed5fa51ff70df6a21
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jan 8 15:11:59 2016 +1000

    evdev 2.10.1
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d7e61a7074b802b49f57549530b289bbaa0a4855
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Nov 10 14:35:51 2015 +1000

    Only map x and y to axes 0 and 1
    
    The Logitech G600 has one device with all axes north of ABS_MISC. The current
    code assigns ABS_MISC as first axis to map to axis 0, i.e. x. On button press,
    one node sends the BTN_LEFT but the other node sends an ABS_MISC with a 1 0
    value. ABS_MISC is mapped to axis 0, this moves the pointer to (0, y) on
    every button click.
    
    Avoid this by simply mapping any axis other than x/y to at least axis 3, and
    make sure we only override the MT 0/1 axes when we actually have MT axes.
    
    https://bugs.freedesktop.org/show_bug.cgi?id=92856
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Keith Packard <keithp@keithp.com>

commit 01e7ac48546d4534fa420ea1873214e738ea125d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Oct 28 14:28:20 2015 +1000

    evdev 2.10.0
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 034be31159f22ce28d84994d541a45ee44963fd8
Author: Thomas Hindoe Paaboel Andersen <phomes@gmail.com>
Date:   Tue Jan 20 00:44:40 2015 +0100

    Add "Resolution" option for mice to the evdev driver
    
    It can be used to scale the resolution of a mouse to that of a 1000 DPI
    mouse. This can be useful to make high resolution mice less sensitive
    without turning off acceleration. The target of 1000 DPI is used as the
    same default is used in libinput. If the option is not set no scaling
    will be done.
    
    https://bugs.freedesktop.org/show_bug.cgi?id=88134
    Signed-off-by: Thomas Hindoe Paaboel Andersen <phomes@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 66c997886424a20e92ce30fcfda46cbb5c7352ab
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue May 5 15:34:07 2015 +1000

    Add the default evdev config
    
    This used to be part of the server but now that we have two drivers doing the
    same thing (libinput, evdev) shift the configuration defaults to the driver.
    This way you get what you install.
    
    https://bugs.freedesktop.org/show_bug.cgi?id=89023
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>

commit 0d3494eadfde7e8d30e1bae97cfa6b36e5128a11
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 27 11:41:50 2015 +1000

    Bump to 2.9.99
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 56a5e6716204916691a67082e3e6a1698df2061b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 16 07:55:34 2015 +1000

    Unconditionally require mtdev
    
    Missing from 2c9f4f0380d
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 74433f788acf41a43da54269eb1b73c407f3ceba
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 13 11:05:03 2015 +1000

    Always check for a return value on creating a property
    
    Mostly to make static analyzers happy
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit fdc33809de2751c164183df2310a71732be579f3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 13 10:58:01 2015 +1000

    Invert a condition to reduce nesting
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 38e107a39fb4a0b630ee5adb5870c91dbc27abde
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 11 14:58:04 2015 +1000

    Disable axis faking and MT event processing on fake MT devices
    
    This effectively disables all axes >= ABS_MT_SLOT on those devices. But at
    least the device comes up without an error and it didn't work correctly
    beforehand anyway.
    
    https://bugs.freedesktop.org/show_bug.cgi?id=89473
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>

commit b6176cff5a3fbccc3708721958e9fb346518f57e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 11 13:44:28 2015 +1000

    Invert two conditions to reduce nesting
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>

commit 37afebfb67609f04f9c1cdea983e7006ee2d59e5
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 11 13:47:32 2015 +1000

    Factor out MT axis counting into a separate function
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>

commit 5b5ae1786cb4b2ea35720bacf18f252223b2b2ec
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 11 13:29:19 2015 +1000

    Split android axis simulation into a helper function
    
    No functional changes
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>

commit 2c9f4f0380dd5bb5966a6eee34c8e0ec0c98ed17
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 11 13:22:19 2015 +1000

    Require multitouch/smooth scrolling dependencies
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>

commit 39ef4444a231d3b0296ba421b78f0417f18955f9
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Feb 13 08:12:38 2015 +1000

    Drop evdev-specific XKB defaults
    
    Just use the server defaults instead. This has very little effect, on most
    systems there was some sort of default configuration applied anyway.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit abc4a8b60387c3c9ae8b0199bf61acede4f6dba2
Author: Tobias Himmer <provisorisch@online.de>
Date:   Fri Jan 23 02:13:17 2015 +0100

    Check for incoming MT slot indices exceeding the allocated number of slots.
    
    Fixes: https://bugs.freedesktop.org/show_bug.cgi?id=88715
    
    Signed-off-by: Tobias Himmer <provisorisch@online.de>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b370ccdff8f721de75d3d91486cc4807668d040c
Author: Colin B. Macdonald <macdonald@maths.ox.ac.uk>
Date:   Thu Jun 26 12:17:59 2014 +0100

    Workaround lack of ABS_X on MT devices (#80470)
    
    Often on Android, we have ABS_MT_POSITION_X without ABS_X (which is contrary
    to spec). We add fake ABS_X axis in that case.
    
    X.Org Bug 80470 <http://bugs.freedesktop.org/show_bug.cgi?id=80470>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 511498478b49aa39629615c110c9d0129fa6bbef
Author: Éric Brunet <Eric.Brunet@lps.ens.fr>
Date:   Tue Sep 30 23:04:55 2014 +0200

    Move EVDEV_RELATIVE_MODE logic earlier
    
    When in EVDEV_RELATIVE_MODE, after converting the absolute valuators, the
    code unsets pEvdev->abs_queued. This is wrong if there are some absolute
    valuators which are not positions, such as a pressure valuators, because
    events on these valuators would be lost.
    
    This patch fixes the problem by doing the absolute->relative translation
    early. This way, abs_queued is not set and then unset when receiving
    absolute valuators representing positions. Other absolute events now set abs_queued
    and will be processed.
    
    Signed-off-by: Éric Brunet <Eric.Brunet@lps.ens.fr>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3dcf6f123c54fd3104bcb79677cd347972abea4c
Author: Éric Brunet <Eric.Brunet@lps.ens.fr>
Date:   Tue Sep 30 22:32:51 2014 +0200

    Don't update old_vals when not in EVDEV_RELATIVE_MODE
    
    When not in EVDEV_RELATIVE_MODE, absolute position is stored in old_vals. This serves
    no purpose except that old_vals is ready when the device is switched to
    EVDEV_RELATIVE_MODE. It is however better to make the copy between old_vals
    and abs_vals at the time of the switch rather than all the time.
    
    Signed-off-by: Éric Brunet <Eric.Brunet@lps.ens.fr>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f59585b36709c8a529da6e08662ed6c62b73ebd5
Author: Éric Brunet <Eric.Brunet@lps.ens.fr>
Date:   Tue Sep 30 22:15:45 2014 +0200

    Change the logic concerning EVDEV_RELATIVE_MODE and in_proximity
    
    When not in_proximity, we don't really trust data, even though a valuator
    sent just before a in_proximity event might actually be important. The
    present code for EVDEV_RELATIVE_MODE throws away all data if not
    in_proximity, which is a little bit too much. This patch allows for
    relative values to be calculated and old_vals to be updated even if not
    in_proximity, but will prevent evdev to sending (presumably) wrong
    information to the X server. But at least, old_vals will be correctly
    filled when the device comes into proximity again.
    
    Signed-off-by: Éric Brunet <Eric.Brunet@lps.ens.fr>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 593bbc6390aa6f9feec0e2b081e1bfe6ab03595a
Author: Éric Brunet <Eric.Brunet@lps.ens.fr>
Date:   Tue Sep 30 20:49:46 2014 +0200

    drop the pEvdev->delta array
    
    Now that relative events have their own valuator mask, use it instead of
    delta
    
    Signed-off-by: Éric Brunet <Eric.Brunet@lps.ens.fr>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e0e2587a95afaeb25ad73bb8b27488e79d1fe02e
Author: Éric Brunet <Eric.Brunet@lps.ens.fr>
Date:   Tue Sep 30 14:27:20 2014 +0200

    Split pEvdev->vals into pEvdev->abs_vals and pEvdev->rel_vals
    
    This should hopefully fix bug 84445.
    
    Signed-off-by: Éric Brunet <Eric.Brunet@lps.ens.fr>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit cb3b023783fe73d9bbb7c9c6ba6c73048b8303ef
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Nov 26 09:23:39 2014 +1000

    evdev 2.9.1
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 124eff9ba20c5ae777a6a5aa36f32112ad31b931
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Nov 7 13:41:06 2014 +1000

    Remove three unused #defines
    
    Obsolete since 768c25a99b2f4ec07993eb15a0f05a5e22b5c695
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 605047613c534babf723f25597e8cc4be6758db0
Author: Éric Brunet <Eric.Brunet@lps.ens.fr>
Date:   Sat Sep 27 22:06:36 2014 +0200

    Don't pass superfluous arguments to EvdevPost*Events
    
    The functions EvdevPostProximityEvents, EvdevPostRelativeMotionEvents,
    EvdevPostAbsoluteMotionEvents and EvdevPostQueuedEvents are only called
    by EvdevProcessSyncEvent. These functions take as arguments an array of
    valuators which is set by EvdevProcessSyncEvent to contain ... nothing.
    This patch changes the prototype of the four functions, their definitions
    and the way they are called  to remove the useless array of valuators.
    
    Signed-off-by: Éric Brunet <Eric.Brunet@lps.ens.fr>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3ee98d0b7f7c266b8c7954b7710f9724a9c9cddd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Aug 29 13:14:56 2014 +1000

    Drop some unused #defines
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 977588d24a6bc511454c7bd616e8b24a8bc3f58e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Aug 14 11:56:03 2014 +1000

    If only IgnoreRelativeAxes is set, init like a normal relative device
    
    In the current code, if only IgnoreRelativeAxes is set, the code would go on
    and force absolute axes to initialize even if the relative axes were
    successfully initialized.
    
    Evdev gives precedence to relative axes anyway, initializing absolute axes if
    the relative axes failed. Thus, if we explicitely want relative axes but leave
    the abs axes as-is, proceed as normal.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 291b60172d25446d2cabe61ed93e56db6570baa3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Aug 14 10:48:52 2014 +1000

    Fix axis initialization for devices with abs x/y and rel scrollwheels
    
    The Xen Virtual Pointer device has ABS_X, ABS_Y and REL_WHEEL. If smooth
    scrolling is detected, the current code would first initialize relative axes
    for scrolling and immediately overwrite those axes when the abs valuators are
    written out.
    
    This patch fixes the default case only, in the case of a device setting the
    two Ignore*Axis options both to "off", the axes are still overwritten. The
    wheels will work, other axes only if the same number of abs axes exists. And
    it keeps the current memory leak too, but it's marked with a FIXME now.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8ce06c96e469139bb12065d80fe4abb6173e2855
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Aug 5 15:59:17 2014 +1000

    Make the slot-state per slot
    
    The previous approach only had the slot state for the current slot. If we
    changed slots, that means we lost the information if the slot was ever
    initialized. If the ABS_MT_TRACKING_ID was never received, the slot would
    still update and try to send events (which the server refused with a warning).
    
    Avoid this by having a per-slot state and a dirty bit that tells us if the
    current slot updated at all. If we don't get the tracking ID, leave the slot
    empty and refuse any further events from that touch.
    
    This quashes the various "unable to find touch point 0" warnings caused if a
    touchpoint starts before the device is enabled.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Walter Harms <wharms@bfs.de>

commit 5d239ceb260cd554245e8f0dc3627990726ea9b9
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 15 08:41:06 2014 +1000

    evdev 2.9.0
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 13dea90bc8ef2a2e6f55fb5ff5f54afe41d22f95
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue May 6 09:20:05 2014 +1000

    Use the server's device list for duplicate detection (#78309)
    
    EvdevAddDevice/EvdevRemoveDevice keep a reference to the device to detect
    duplicate devices based on the dev_t.
    
    EvdevAddDevices was called during PreInit, EvdevRemoveDevice was called during
    DEVICE_CLOSE. That makes it imbalanced if the device succeeds PreInit but the
    server skips everything else because MAX_DEVICES is exceeded. So for all
    devices after MAX_DEVICES, we'd add a reference but never remove it,
    eventually reading/writing past evdev_devices.
    
    The server keeps the list of devices for us anyway, so remove the copy of all
    the pointers and instead run through the device list the server gives us.
    
    X.Org Bug 78309 <http://bugs.freedesktop.org/show_bug.cgi?id=78309>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>

commit b25d71616557b0f3fc5e1ca65ba9e62809d14139
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Apr 29 10:20:42 2014 +1000

    evdev 2.8.99.1
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 41cf9212d02c1d2adca0e85702a1f0faba9e6b37
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 28 12:23:18 2014 +1000

    Map REL_DIAL to horizontal scrolling (#73105)
    
    This was the original behavior introduced in
    f77410e1f97d394e98c854fd174f712666b0544c and stayed that way until smooth
    scrolling erroneously added it as vertical axis in
    b450efdf95999cad08de23ce069f04a66bdae24b. Revert to horizontal scrolling to
    restore the previous behaviour - which unbreaks scrolling on Microsoft mice.
    
    This effectively reverts 54a3120e339e55fc4721543abb15692c3e9ede09 too.
    
    X.Org Bug 73105 <http://bugs.freedesktop.org/show_bug.cgi?id=73105>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 75368052b57aa07252e26642315bcf9a0b2e78eb
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Apr 29 09:50:21 2014 +1000

    Revert "Map REL_DIAL to horizontal scrolling (#73105)"
    
    Whoops, the vertical axis is swapped, so when changing the axis we also need
    to change the direction.
    
    This reverts commit 16c85cbeacb721ed365c6240aabaad921b811fe0.

commit 16c85cbeacb721ed365c6240aabaad921b811fe0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 28 12:23:18 2014 +1000

    Map REL_DIAL to horizontal scrolling (#73105)
    
    This was the original behavior introduced in
    f77410e1f97d394e98c854fd174f712666b0544c and stayed that way until smooth
    scrolling erroneously added it as vertical axis in
    b450efdf95999cad08de23ce069f04a66bdae24b. Revert to horizontal scrolling to
    restore the previous behaviour - which unbreaks scrolling on Microsoft mice.
    
    This effectively reverts 54a3120e339e55fc4721543abb15692c3e9ede09 too.
    
    X.Org Bug 73105 <http://bugs.freedesktop.org/show_bug.cgi?id=73105>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>

commit ae67f64f02434171e1828b00fbf4277c8166966e
Author: Hans de Goede <hdegoede@redhat.com>
Date:   Sat Mar 8 10:28:00 2014 +0100

    evdev: Add support for server managed fds
    
    Signed-off-by: Hans de Goede <hdegoede@redhat.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f6fcad8b107e834e26fb3da2c89e05294ff0a74c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Aug 26 14:56:07 2013 +1000

    Fix wheel emulation for absolute device (#68415)
    
    wheel emulation, for some reasons beyond time, got the value from
    pEvdev->vals, then set the value back into pEvdev->vals. Alas, that value is
    always 0, hence oldValue is zero and the delta is nil.
    
    If we're not in relative (touchpad) mode, store the current value in
    old_vals, so they're retrievable for the next event.
    
    X.Org Bug 68415 <http://bugs.freedesktop.org/show_bug.cgi?id=68415>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d171b3d9194581cb6ed59dbe45d6cbf009dc0eaa
Author: Peter De Wachter <pdewacht@gmail.com>
Date:   Wed Oct 3 22:08:12 2012 +0200

    Export smooth scroll settings as an XInput property.
    
    A new property "Evdev Scrolling Distance" is created that holds three values
    (vertical, horizontal and dial).
    
    Signed-off-by: Peter De Wachter <pdewacht@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c3251deb4b988610c3766081345e49f538fca865
Author: Peter De Wachter <pdewacht@gmail.com>
Date:   Wed Oct 3 20:48:24 2012 +0200

    Add configuration options for smooth scrolling.
    
    This patch creates three new xorg.conf options, VertScrollDelta,
    HorizScrollDelta and DialDelta, which adjust the sensitivity of
    smooth scrolling. These options take a positive integer, default
    value is 1.
    
    Signed-off-by: Peter De Wachter <pdewacht@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit cabed4bbb6757e55f067126965f26bb0f716fb55
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Oct 14 11:48:30 2013 +1000

    Use num_slots where appropriate
    
    This was supposed to be added in 43e270fb7a10da20ab89dd699839c1cb6df119b4, but
    got lost somehow.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a75c43830ef2f1b9ba0e265baf614cdfea617beb
Merge: d9aadfd 164c62a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Oct 7 09:22:09 2013 +1100

    Merge branch 'libevdev'

commit d9aadfd5f05abd9a65977d9d36cbe159d6e05386
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Oct 7 09:21:57 2013 +1100

    bump to 2.8.99
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 54a3120e339e55fc4721543abb15692c3e9ede09
Author: Peter De Wachter <pdewacht@gmail.com>
Date:   Wed Mar 20 00:35:45 2013 +0100

    Map REL_DIAL to vertical scrolling
    
    This makes the absolute axis codepath behave the same as the relative axis
    path.
    
    Signed-off-by: Peter De Wachter <pdewacht@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 164c62a97591d4c9b649460e7442977ea82ac02b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 29 07:17:41 2013 +1000

    Use libevdev as backend
    
    Removes the need to ioctl manually and check bits, with all the dangers that
    come with that. libevdev is much better prepared for invalid values, OOB
    checks, etc.
    
    Plus, we get almost free SYN_DROPPED handling as well which we didn't have
    before.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit 43e270fb7a10da20ab89dd699839c1cb6df119b4
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Sep 10 15:05:58 2013 +1000

    Use helper function for counting slots
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit 4ca57716ca4d0bea7bcd9a52e88e5cf7064a9ad9
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Sep 10 15:04:40 2013 +1000

    Drop ABS_MT_SLOT minimum - the kernel guarantees a minimum of 0
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit 0f16065b00436c5df48af6e1d6a18e2ed27a12fd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Aug 28 14:23:49 2013 +1000

    Remove a comment
    
    This comment is now in the wrong place. It was moved when abs support for
    wheel emulation was added but is now only confusing. Remove it altogether,
    the code is quite obvious what it does.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit cae14787815c452a618c8bd684e2df4892dc93cb
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Aug 1 10:43:32 2013 +1000

    Don't use mtdev for protocol B devices
    
    If a device has ABS_MT_SLOT, mtdev merely reads the events and returns them
    to the caller as-is. For this we don't need mtdev, we can just handle those
    events ourselves.
    
    This patch switches to the mtdev plumbing layer that takes events and
    converts them instead of reading them off the fd.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 27926b3763e525470ec8e4ac9a97aa0e02f1dd95
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Aug 13 14:44:26 2013 +1000

    Write a SYN_REPORT after the last LED
    
    When writing LED values to the device, append a SYN_REPORT to the list to
    ensure other clients are updated immediately. Otherwise, the LED events
    will be queued and not sent to other clients until the next input event
    arrives.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Daniel Stone <daniel@fooishbar.org>

commit 8a9b1ec6b58a36910a03f3e8b1f9bc8d91f87204
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jul 11 11:09:24 2013 +1000

    evdev 2.8.1
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 356565111a6bb98f15fbaaf4f527aed8c87b477b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jun 27 05:47:38 2013 +1000

    Don't allow a wheel emulation inertia of 0 (#66125)
    
    Inertia of 0 results in an infinite loop of events being sent to the server.
    
    X.Org Bug 66125 <http://bugs.freedesktop.org/show_bug.cgi?id=66125>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit fff3a60fbf5c81b337ae4eaf160feacdfc8c2465
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 29 13:26:57 2013 +1000

    Use EvdevBitIsSet, not the server's BitIsOn
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8f209ac60d10ba61aa6ea2bec02dbfa54ebe8f17
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 29 07:18:19 2013 +1000

    Drop cached name and led_bitmask - nothing reads this
    
    Both fields are write-only as of xf86-input-evdev-2.5.99.902-1-g1ced7ec
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a0d41af8969b91ec51ebdfb966ccc47e5c40329a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon May 27 10:19:15 2013 +1000

    Switch default model to pc104.
    
    As of xkeyboard-config 1.9, the evdev model is hidden (c887d2876)
    The server switched to pc105 with version 1.8 (1df4bd601).
    
    The evdev model resolves to pc104 anyway, so this commit has no real effect
    other than to switch from a catch-all rule to explicit.
    Use pc104 so this is easy to find for those investigating the code and
    wondering why. pc104 is the 'correct' geometry for the us layout, which is
    the default after all. Switching to pc105 would show keys missing if no
    model is set (e.g. on uk/de layouts) but it would be the wrong layout for
    the default.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Daniel Stone <daniel@fooishbar.org>

commit dea1d1a3906b98b491e9760b3304f881c6afec5e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 29 11:48:12 2013 +1000

    Fail to set up axes for devices that only have MT axes but no ABS_X/Y equivalents (#64029)
    
    The kernel should give us ABS_X/Y for backwards compat but some devices
    don't. For now, ignore these devices as evdev is not suited to handle this
    yet and will crash if a device is set up without axes (i.e.
    pEvdev->vals == NULL) and later receives an event from an MT axis.
    
    X.Org Bug 64029 <http://bugs.freedesktop.org/show_bug.cgi?id=64029>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Benjamin Tissoires <benjamin.tissoires@gmail.com>

commit b59a1a25dad4437e013ce8d3d65d4591c6f4ee4a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Apr 2 14:12:26 2013 +1000

    Add option TypeName (#62831)
    
    evdev tries to assign the right XI 1.x type-name based on various device
    capabilities. In some cases, that fails. e.g. the Mionix Naos 5000 mouse
    looks like a keyboard. And we assign a keyboard type in that case since
    there are plenty of keyboards that also advertise some axes or others.
    
    Add a new option TypeName to allow for system-wide configuration of such
    devices in a quirks file.
    
    This can also be used to address #55867
    
    X.Org Bug 62831 <http://bugs.freedesktop.org/show_bug.cgi?id=62831>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5138cd2ff47a1a28db82688b932cb1ecd618778f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Mar 26 16:01:39 2013 +1000

    evdev 2.8.0
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c085c8b6c1f8e95f6f4d91bc65268fe57154018c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 12 12:58:08 2013 +1000

    Return BadValue if EvdevOpenMTDev fails
    
    FALSE == Success, so if we fail during EvdevOpenMTDev, the caller thinks
    that everything worked fine, proceeds to set up the fd, etc.
    
    This may later cause a crash, when a device comes back later as different
    device and posts axis events where we didn't configure axes in the first
    place.
    
    Note: Unclear why there was no udev event received for the device being
    removed and coming back as different device though.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2b675f85aef6df3bb3fb5e68648982e11b752764
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 12 12:48:38 2013 +1000

    Make errors on EVIOCGBIT more obvious
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2b8b0df62ec554952784f2820fb4143c495232b0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jan 24 16:18:48 2013 +1000

    Always init axis mapping for the first two rel axes (#59784)
    
    Fixes regression introduced in 2f67509b53b27dd7f51ca2aadd19605aee613a61.
    
    If evdev is used for touchpads, the abs axis movement is converted to a rel
    movement. Without the two relative axes initialized, the events are
    discarded.
    
    Axes 0 and 1 are always x/y anyway unless specifically configured otherwise.
    
    X.Org Bug 59784 <http://bugs.freedesktop.org/show_bug.cgi?id=59784>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit bb9b4146cb828bd366675e8736fc145e92c9269a
Merge: f5fe533 67e5376
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jan 25 11:12:05 2013 +1000

    Merge branch 'touch-axis-swap'

commit f5fe533f1bef0c636b98658aaf40748c219c9879
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Mar 27 12:18:46 2012 +1000

    Allow relative scroll valuators on absolute devices (#54387)
    
    Special-case RHEL_WHEEL, RHEL_HWHEEL and REL_DIAL to add scroll valuators
    for those axes in addition to the absolute axes.
    
    X.Org Bug 54387 <http://bugs.freedesktop.org/show_bug.cgi?id=54387>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2f67509b53b27dd7f51ca2aadd19605aee613a61
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jan 16 08:38:52 2013 +1000

    Split rel and abs axis mapping into two separate arrays
    
    This will enable a device to have relative scrolling axes in addition to
    absolute axes (required by the QEMU tablet).
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ffc0a34642d5ab573c2ae63c873a5befd8688493
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jan 15 16:15:47 2013 +1000

    Move some stuff into the new alloc function
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 93de7b0b73d4c5f6f68e3a2ffe8f76b5212ee016
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jan 15 16:11:16 2013 +1000

    Move allocation of EvdevRec into a helper function
    
    Makes it easier to initialise everything to the right values.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9ec9d214d072ef4aaffb65b5575eff58edcb62ed
Author: Colin Walters <walters@verbum.org>
Date:   Wed Jan 4 17:37:06 2012 -0500

    autogen.sh: Implement GNOME Build API
    
    http://people.gnome.org/~walters/docs/build-api.txt
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit 94e6df8f5f6048b8d0c7aa34efe1c0dc70b997d1
Author: Adam Jackson <ajax@redhat.com>
Date:   Wed Jan 16 13:11:11 2013 -0500

    configure: Drop AM_MAINTAINER_MODE
    
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit 67e5376aaa62a1586fee37d610b3ad7e3b8bbcab
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jan 14 14:45:58 2013 +1000

    Handle axis swap, calibration, and inversion for touch events (#59340)
    
    X.Org Bug 59340 <http://bugs.freedesktop.org/show_bug.cgi?id=59340>
    
    Reported-by: Bastien Nocera <hadess@hadess.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2432626b70b7f55a337bcfdc9ba415811634c062
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jan 14 14:10:14 2013 +1000

    Move calibration adjustments to helper function
    
    No functional changes.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 069c035ab0787e6841159929199ae58502d89c4b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jan 14 14:07:26 2013 +1000

    Move valuator swapping into a helper function
    
    No functional changes.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3b7ba39fcaf261f800205fd6cf45fea9998529e5
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jan 14 14:03:54 2013 +1000

    Localise tmp variable
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 454194f4b530af5d7f92a3b28c28495b4faac547
Author: Mauro Carvalho Chehab <mchehab@redhat.com>
Date:   Tue Jan 8 15:04:07 2013 +1000

    Force a button if MT axes are present and it is not a gamepad
    
    We expect at least BTN_TOUCH for anything with MT axes, but devices that
    don't have that need a button class regardless. Some gamepads define
    MT axes but no buttons, causing a bug in the server when they post a
    TouchBegin.
    
    [ 97436.293] (EE) BUG: triggered 'if (!b || !v)'
    [ 97436.293] (EE) BUG: exevents.c:929 in UpdateDeviceState()
    
    So, ignore it, if it is a joystick (e. g. if it have BTN_JOYSTICK defined).
    Otherwise, fake a button.
    
    This patch basically merges two patches written by Peter Hutterer
    <peter.hutterer@who-t.net>.
    
    Signed-off-by: Mauro Carvalho Chehab <mchehab@redhat.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 00341e632c89e14a83a55e3578b8bb2684ce4ae2
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jan 7 10:20:52 2013 +1000

    Drop special XKB option handling
    
    This isn't actually needed at all.
    
    xf86nameCompare() will skip over underscores and is case-independent. So
    xf86SetStrOption("foo_bar") will return an Option "FooBar" and vice versa.
    
    The server won't return a zero-length string either, it'll return
    NULL and spit a warning to the log.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f2d2b65343a902c5eedaf50b6f6bcb5ba1ef9c4a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jan 7 09:14:42 2013 +1000

    Localise XKB initialization
    
    No need to store this in the evdev struct.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0d6c6b59c153cb53b53d6860387b4fe40d245628
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Nov 30 10:32:47 2012 +1000

    If stat fails, pretend it's not a virtual device
    
    If stat fails while checking if the device is virtual, just say "no, it's
    not virtual" and continue. If the device really went away, it'll be removed
    through other means.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c263d6e46d76b3e54570da637b1e7352437bb59d
Author: Benjamin Tissoires <benjamin.tissoires@gmail.com>
Date:   Fri Oct 26 16:27:35 2012 +0200

    Add missing mt axis labels
    
    update evdev according to latest changes in input.h
    
    Signed-off-by: Benjamin Tissoires <benjamin.tissoires@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5af11b675242b2971f47c42a57b892dc24eb1917
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri May 25 13:39:32 2012 +1000

    Use LogMessageVerbSigSafe if available
    
    Messages logged during the signal handler should use LogMessageVerbSigSafe
    as of ABI 18.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit 33e7831b5fabc5c9dcc0224800a04761086952a7
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Aug 7 14:32:17 2012 +1000

    Fix broken ButtonMapping option (#53168)
    
    Regression introduced in 8af0e6f1ebaf327f735bca507134b34bb24b26c6.
    s is now initialized to NULL, so we never entered the loop.
    
    X.Org Bug 53168 <http://bugs.freedesktop.org/show_bug.cgi?id=53168>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit bc8997e8120cc8d4f33f44e0734fa488f9fef3b0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Sun Aug 5 12:26:38 2012 +1000

    Link against libudev
    
    Fixes /usr/bin/Xorg: symbol lookup error:
    /usr/lib64/xorg/modules/input/evdev_drv.so: undefined symbol: udev_new
    
    This doesn't appear in the default configuration as Xorg links against
    libudev and the symbol is defined when evdev is loaded. It can be reproduced
    with a HAL-enabled server.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit 1cb8f074df8d16879ec80d778d26fb5b9af05a3b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jul 31 16:39:00 2012 +1000

    Don't delete the device on ENODEV
    
    This is signal handler code and we cannot clean up properly while in the
    signal handler. So reduce the code to removing the signal handler and let
    the device be cleaned up later.
    
    If hotplugging is on, the server will remove it when the config backend says
    so and if it is off, the server will remove it on shutdown.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit 4eacb581fb71eaf515ec67af0f206126d8328043
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jul 4 10:12:10 2012 +1000

    Only use mtdev for multitouch devices
    
    mtdev uses a chunk of memory per device (~41kB), mainly for for its
    internal event buffers. The average box these days can easily have 10
    devices, but only few of those are multitouch. So check if we have
    ABS_MT_POSITION axes and only create an mtdev instance if we do.
    
    If a device has multitouch axes but not x/y, we will ignore events from this
    device now.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit 98af2003d48530b2e102cf667a9d40dcb94cb0fe
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jul 4 09:14:41 2012 +1000

    Don't re-open mtdev after PreInit
    
    ==16557== 388,240 (3,520 direct, 384,720 indirect) bytes in 10 blocks are definitely lost in loss record 1,669 of 1,671
    ==16557==    at 0x4A06F18: calloc (vg_replace_malloc.c:566)
    ==16557==    by 0xC3EAD4D: mtdev_new (core.c:345)
    ==16557==    by 0xC3EAE6B: mtdev_new_open (core.c:383)
    ==16557==    by 0xC1E0452: EvdevOpenDevice (evdev.c:2365)
    ==16557==    by 0xC1E068C: EvdevPreInit (evdev.c:2431)
    ==16557==    by 0x4B8304: xf86NewInputDevice (xf86Xinput.c:846)
    ==16557==    by 0x4B8857: NewInputDeviceRequest (xf86Xinput.c:989)
    ==16557==    by 0x4CCB4C: device_added (udev.c:211)
    ==16557==    by 0x4CCFA6: config_udev_init (udev.c:342)
    ==16557==    by 0x4CBE81: config_init (config.c:48)
    ==16557==    by 0x4A8A9A: InitInput (xf86Init.c:918)
    ==16557==    by 0x4921EE: main (main.c:258)
    
    After PreInit, the fd and mtdev pointer are still valid. We check for the
    fd, but unconditionally allocated another mtdev struct for each device.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit f5ede98085688b59dc56a9cc6592f75552a4e7ed
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Tue Jul 10 00:34:56 2012 +0100

    Fix compilation warnings for non-multitouch builds
    
    Signed-off-by: Daniel Stone <daniel@fooishbar.org>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ff926d15b8176c5e90fced23bb1aa041c3dca20e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 30 11:21:23 2012 +1000

    Move axis labels into a separate header file
    
    Just to unclutter the code
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b0e3c8f97809c8e323783ded0d308c6f0b7729ff
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 29 09:25:43 2012 +1000

    Split initializing one axis label out into a helper function
    
    We need this for mixed axis devices. No functional changes.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit 9624f4e2ba7d1973813de066806eed108748a53a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon May 28 10:08:23 2012 +1000

    Constify InputDriverRec->default_options
    
    Removes a warning, and with the input ABI 18 this is forced to const in the
    server.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit 047955f51e013c190bb09ba0c03ca2c160f34997
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon May 28 09:50:57 2012 +1000

    Move duplicate check up before mtdev allocation
    
    No need to alloc mtdev if we then find out the fd is a duplicate one anyway.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit 8251d7a8ec00b4160b6601a6f2f4f0f5d461cbee
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon May 28 09:50:15 2012 +1000

    Close the fd when mtdev open fails
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit ac5173163d7d1e18d47630a397ece0f26b2568c8
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon May 28 09:08:43 2012 +1000

    Release mtdev data whenever we close the fd
    
    Add a new EvdevCloseDevice() function to unify this.
    We used to leak data
    - PreInit allocates mtdev, but nothing except one error path released it.
    - each DEVICE_ON re-allocates mtdev but it is never released
    
    Reported-by: Zdenek Kabelac <zdenek.kabelac@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit 61faf2e6e70a4c9ecffe638d46829738dc2e3452
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri May 25 14:04:22 2012 +1000

    strtol doesn't need a empty string, NULL is good enough.
    
    Fixes:
    evdev.c: In function 'EvdevInitButtonMapping':
    evdev.c:1659:25: warning: initialization discards 'const' qualifier from
    pointer target type [enabled by default]
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit 7f3f98be7f6585de3051ade6d5447acd378b572f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri May 25 13:42:05 2012 +1000

    Use xf86IDrvMsg in emuMB.c instead of ErrorF
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit 4145fe1c087708bf5d6608e328342282ecb93ab0
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Wed Jun 6 12:07:12 2012 -0700

    Fix buffer overrun when populating axis label property array
    
    The axis label property array currently only has enough elements for the
    non-multitouch axes. This change allocates enough space for all axes,
    which prevents an array overrun write. This may manifest as stack
    corruption on some platforms.
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9ce068e760e1282183c7aa1b4cc6b0fcb6b494dd
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Thu May 24 10:48:38 2012 -0700

    Report the correct number of touches for MT protocol B devices
    
    Protocol B devices report the number of touches by giving a maximum and
    minimum slot value. The current code ignores the minimum value, which is
    usually 0, and underreports the number of touches by 1.
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2c8da280b3ab635d049784345d025d289348687b
Author: Marcin Slusarz <marcin.slusarz@gmail.com>
Date:   Mon May 21 01:22:33 2012 +0200

    Fix some obvious constness-related compile warnings.
    
    Signed-off-by: Marcin Slusarz <marcin.slusarz@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f28507e8ce2bd45b51c28f024baebd9711c28fc3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Apr 27 15:42:17 2012 +1000

    Devices configured as mice need REL_X/Y
    
    Some keyboards export scroll axes and any absolute axis possible in 11
    dimensions. All these axes are mute, except possibly for the scroll wheels.
    
    So if a device has a scroll axis, and we're configuring it as mouse, force
    the x/y axes into existence. This stops the logspam complaining about not
    enough axes on pointer movement after a xrandr change.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit 99340147b9092a5aaec997eca407282a51e1f063
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 15 15:46:32 2012 +1000

    Fix inverted horizontal scroll (#46205)
    
    REL_HWHEEL has a positive increment, not a negative one like REL_WHEEL.
    
    X.Org Bug 46205 <http://bugs.freedesktop.org/show_bug.cgi?id=46205>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit 76b1d58a9791257fa8b4e6d3322fcb082c86b18a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 7 20:39:09 2012 +1000

    evdev 2.7.0
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 224a28de25fda654040a9fd4e5c4d748c9e29809
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jan 25 16:03:34 2012 +1000

    Only force REL_X/Y if no ABS_X/Y exists
    
    5c5b2c8db851df7921cedd888222a6630a007fd8 added forced x/y axes if a device
    has any axes of the same mode. This was too broad a brush, some devices have
    a relative wheel but absolute x/y axes and would now get misdetected as
    purely relative device.
    
    Only force relative axes if a device no rel x/y _and_ no abs x/y.
    
    Reproducible: virtual machine with QEMU USB Tablet will stop working
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit bc2f01ab838119a962f5e5eabb36e33d4c084f2c
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Thu Jan 19 14:17:34 2012 -0800

    Copy last valuator values into new touch valuator masks
    
    Evdev is a 100% stateful protocol. The following represents three
    touches. Two touches begin and end at the same time at (500, 500) and
    (1000, 1000). The third touch begins after the first two end, and is at
    (500, 500).
    
    ABS_MT_SLOT		0	/* Set touch slot */
    ABS_MT_TRACKING_ID	0	/* New touch with ID 0 in slot 0 */
    ABS_MT_POSITION_X	500	/* Initial X position */
    ABS_MT_POSITION_Y	500	/* Initial Y position */
    ABS_MT_SLOT		1	/* Set touch slot */
    ABS_MT_TRACKING_ID	1	/* New touch with ID 1 in slot 1 */
    ABS_MT_POSITION_X	1000	/* Initial X position */
    ABS_MT_POSITION_Y	1000	/* Initial Y position */
    SYNC				/* End of frame */
    ABS_MT_SLOT		0	/* Go back to slot 0 */
    ABS_MT_TRACKING_ID	-1	/* Touch in slot 0 ended */
    ABS_MT_SLOT		1	/* Go to slot 1 */
    ABS_MT_TRACKING_ID	-1	/* Touch in slot 1 ended */
    SYNC				/* End of frame */
    ABS_MT_SLOT		0	/* Go back to slot 0 */
    ABS_MT_TRACKING_ID	2	/* New touch in slot 0 with ID 2 */
    SYNC				/* End of frame */
    ABS_MT_TRACKING_ID	-1	/* Touch in last slot (0) ended */
    SYNC				/* End of frame */
    
    Note that touch 2 has the same X and Y position as touch 0. This is
    implied because no new value was emitted for slot 0. In fact, Linux will
    not emit an event in the same slot with the same event type and code
    unless the value has changed. Thus, we can only assume that all the MT
    valuators have the same values as they were when they were last sent for
    the given slot.
    
    This change adds an array of valuator mask to hold all the last valuator
    values that came from evdev for each slot. When a new touch begins, all
    the last values are copied into it.
    
    This patch assumes initial axis values of 0 in each slot. Linux and
    mtdev do not provide a facility to query the current values of axes in
    each slot yet. This may cause spurious incorrect touch valuator values
    at the beginning of an X session, but there's nothing we can do about it
    right now.
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9d9c9870c88f2c636799a68cde8efcab59a4a2a5
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jan 13 09:51:36 2012 +1000

    Prefere relative axis labelling over absolute axis labelling
    
    If a device has both relative and absolute axes, we'd initialise the
    relative axes but label them with the absolute labels.
    
    The current code is broken for mixed mode devices. Most of these devices
    operate primarily in relative mode, but have some absolute axes available
    for secondary functionality. For now, label the relative axes properly. We
    can fix the absolute axes later.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit 5c5b2c8db851df7921cedd888222a6630a007fd8
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jan 12 11:03:30 2012 +1000

    Force x/y axes to exist on devices with any other axes (#44655)
    
    Too much in the server relies on x/y to exist and to be axes 0 and 1. So if
    any relative axes exist, initialize REL_X/Y or ABS_X/Y as well.
    
    For servers up to 1.11: a scrollwheel-only device now has relative axes
    where it only had buttons before.
    
    For servers 1.12 or later: the device now has x/y in addition to the scroll
    axes.
    
    X.Org Bug 44655 <http://bugs.freedesktop.org/show_bug.cgi?id=44655>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>
    Reviewed-by: Daniel Stone <daniel@fooishbar.org>

commit 854df75f4908bee66e1057f6f04817a1c47124bc
Author: Pete Beardmore <pete.beardmore@msn.com>
Date:   Mon Jan 9 23:47:45 2012 +0000

    missing multitouch related define tests
    
    addition of two missing define tests required when no multitouch related
    symbols are available in user-space
    
    Fixes X.Org Bug 44578 <https://bugs.freedesktop.org/show_bug.cgi?id=44578>
    
    Signed-off-by: Pete Beardmore <pete.beardmore@msn.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8c55e94a6ac91fa856d37206c8a7eda1adcc6b9d
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Tue Jan 3 15:31:43 2012 -0800

    Set the default resolution to 0
    
    If we don't know the resolution, set it to 0. This is invalid, and tells
    the X client that we don't know the resolution, rather than reporting an
    incorrect value.
    
    This value was originally from commit
    6271494faa4c45f4fa10509f72e0515f2cef36c6, which is the initial commit
    from Adam Jackson adding absolute axis support.
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 965338e9d0ee5e2a6135a930347e9dab4b8db0dd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jan 3 08:44:27 2012 +1000

    Remove unused udev.c
    
    Added in 683a55e504f4fc2d1c847c54986439a0c61b2f20 due to a botched up
    rebase -i. The contents of udev.c and EvdevIsVirtual are identical, there is
    no need for an extra file for this one function.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0075da20d691e451f32bdf3c8ba0f270a6c8b0e1
Author: Cyril Brulebois <kibi@debian.org>
Date:   Sat Dec 31 19:46:08 2011 +0100

    configure.ac: Fix udev/libudev dependency.
    
    In 683a55e504f4fc2d1c847c54986439a0c61b2f20, a dependency on libudev was
    added, but documented in configure.ac as a dependency on udev (which
    also happens to ship a pkg-config file).
    
    Signed-off-by: Cyril Brulebois <kibi@debian.org>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 009ac94a8e6d084c13f15ed8b2e1b22f86530c9f
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Sat Dec 31 21:28:53 2011 -0500

    Remove redundant redeclaration of Evdev3BEmuPreInit
    
    Found-by: Tinderbox
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>

commit 4b76d80e934f5503c712289ce73d4e10cc79bba6
Author: Cyril Brulebois <kibi@debian.org>
Date:   Sat Dec 31 18:38:30 2011 +0100

    evdev 2.6.99.901
    
    Signed-off-by: Cyril Brulebois <kibi@debian.org>

commit 6dd6f2d3c6b2fee5f78b01618643c7f3ed0819c3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Dec 29 10:37:38 2011 +1000

    Require xserver 1.12 RC1
    
    Remove the ABI check hack, just check for the server version directly now
    that we have one that definitely has the multitouch APIs.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0c7c087f77132657dd8ee342963bb1b51d659571
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Dec 29 10:19:48 2011 +1000

    Test for mtdev before assuming multitouch
    
    If the XI2.2 headers are present but mtdev isn't, build without MULTITOUCH
    defined.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ba9377c6d9e6d0d2813e471b516bb36902dae2ce
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Sat Dec 24 12:19:40 2011 +1000

    Remove need for --enable-multitouch
    
    If we spot inputproto 2.1.99.3, we assume we have a capable X server. This
    should really be a server version check, but the server version hasn't been
    bumped yet.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7f7606fc461dca1f087a756c85e22f2cc773d008
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Sat Dec 24 12:31:34 2011 +1000

    Include config.h from evdev.h
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0ba58f483e564bd815bae36f6272029693c1fd5c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Sat Dec 24 12:18:16 2011 +1000

    Always include mt_mask in the evdev struct
    
    Even if MT support isn't available, include it in the build. The checks in
    the code check whether mt_mask is non-NULL but they would all need ifdef
    escaping otherwise.
    
    Leave the mtdev part inside the ifdef however, so that we don't need the
    mtdev header if we don't build with multitouch.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5fb48757477b2effd69c8fe8722ad95b21dbf7f5
Merge: 7909975 e99ab23
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Dec 23 08:16:54 2011 +1000

    Merge branch 'multitouch'

commit e99ab2314f712df8dd705b16008755f8b3095707
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Dec 20 15:08:06 2011 +1000

    Don't count legacy and MT axes twice
    
    The kernel exports both ABS_X and ABS_MT_POSITION_X (and a couple others)
    for a multi-touch capable device. For such devices, only count the axis once
    since we submit ABS_MT_POSITION_X through ABS_X.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 191660189a01b9c96bb4c0fa1a2e5008ae666238
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Dec 20 14:14:16 2011 +1000

    Add is_blacklisted_axis() helper
    
    The kernel exports a bunch of information as axis that shouldn't be an axis
    and we don't treat it as axis in the server. Add this helper instead of
    checking for the axis codes manually.
    
    No function change.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a1c3f8efbbff7f93e216ccdb32bd176a8ba33b09
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Dec 20 13:32:06 2011 +1000

    Drop now-unnecessary XI 2.1 and XI 2.2 error suppression defines
    
    Gone since inputproto 2.1.99.3
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f3c628acc4f7399325756590cdc72e769341243c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Dec 20 10:56:22 2011 +1000

    Map ABS_MT_POSITION_X/Y into ABS_X/Y
    
    MT axes are the same as traditional axes, so one into the other so we get
    x/y coordinates regardless wich axes it comes from.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7909975b0b965fbf0935bf012987a5368ea0e67a
Author: Paulo Zanoni <paulo.r.zanoni@intel.com>
Date:   Thu Dec 15 12:26:37 2011 -0200

    Fix relative events with swapped axes
    
    After we swap the axes, we only call valuator_mask_set for axes that are
    not zero, so we need to unset the axes that became zero when swapped.
    
    Signed-off-by: Paulo Zanoni <paulo.r.zanoni@intel.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8d6dfd13b0c4177305555294218e366a6cddc83f
Author: Paulo Zanoni <paulo.r.zanoni@intel.com>
Date:   Wed Dec 14 15:23:36 2011 -0200

    Fix absolute events with swapped axes
    
    We were correctly swapping the valuator values, but we were not
    calling valuator_mask_unset() when needed, so the cursor kept jumping
    to the edges.
    
    This patch does the swapping before the main "for", so we don't need to
    store unswapped_{x,y} and unswapped_isset_{x,y} even when we don't need
    to swap.
    
    Signed-off-by: Paulo Zanoni <paulo.r.zanoni@intel.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit fed454192ddc4ad94226040c657deb6abea3df88
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Dec 15 08:55:32 2011 +1000

    Use xf86InitValuatorAxisStruct, the touch-specific version was dropped
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit cf93a21df1dd66118d3a1f5a0769d48f317de749
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Tue Nov 29 18:02:58 2011 -0800

    Don't send pointer events for multitouch touchscreen devices
    
    Pointer events will be emulated by the server.
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>

commit fac1a41c75a7c4bfabff34dc8ed1dff2587c6011
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Nov 11 15:57:26 2011 +1000

    Add the required defines to compile against the inputproto
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3175a2a96d448a0b2584a58ab3d05fbebb11fab1
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Nov 2 09:53:34 2011 +1000

    Print to the log if we find multitouch axes.
    
    No real effect on the code, but it helps to have that line in the log when
    searching for driver issues.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5e9b027807cc205dc9c4efbb8360ac4b20317682
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Oct 31 08:58:18 2011 +1000

    Replace 0/1 button values with enums
    
    BUTTON_PRESS is much harder to confuse with a button number than a simple 1.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2ce305129ca94394096f4d697d51eb120de2940b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Oct 26 13:21:18 2011 +1000

    Skip event posting for empty slots.
    
    ABS_MT_SLOT comes before any other events. The following order of events
    is common for protocol B devices (and mtdev):
    
    ...
    EV_SYN
    ABS_MT_SLOT        → posting here means we miss on the position information
    ABS_MT_POSITION_X
    ABS_MT_POSITION_Y
    ABS_MT_SLOT
    ABS_MT_POSITION_X
    ABS_MT_POSITION_Y
    EV_SYN
    
    Store the stot state as SLOT_EMPTY after posting an event (i.e. EV_SYN and
    ABS_MT_SLOT) and then don't post until the next slot/syn event.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9411749f76c31a8054ded62a6fb767c8135b4d4e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Oct 26 13:09:30 2011 +1000

    Replace open_slot/close_slot with a SlotState enum
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 239e972be1f2c6a984dd6c5aecce710d0b866257
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Oct 26 11:14:04 2011 +1000

    Simplify a condition, only the event type differs here
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 6127923fe0d50cb9b9ac4ae0a3876ba6f180137c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Oct 26 10:51:16 2011 +1000

    When resetting the queue, don't reset the touchMask
    
    Otherwise we segfault after the first SYN event
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit fc4f98153c2608389d87e37316036a31fb1021e7
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Oct 26 09:59:34 2011 +1000

    MT axes are counted separately, make sure they're initialized too.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit fabee66bcc7260ec50c3091be3f9b503eea65e61
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Oct 25 15:06:38 2011 +1000

    0 is the value for "unknown/unlimited" number of touches
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 91d90a79593369ba1079d06a75f09ceaa9143768
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Oct 25 14:55:47 2011 +1000

    Use mtdev API to allocate/free mtdev structs
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c1b89bda12c1897120bace941625cfa27e547458
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Oct 25 14:52:26 2011 +1000

    Remove duplicate line
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 907b7cad3fd892ca3349cd18e9ccdc5659027b40
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Thu Dec 2 18:01:41 2010 -0500

    Ensure touchpad events are always processed with MT
    
    Without this change, an MT touchpad in relative mode could end a touch
    while not resetting the oldMask used to calculate relative values. This
    fix allows a Magic Trackpad to behave as a relative mode device again.
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>

commit c9a2b4e9ce9b15e57241184df78c72ec8f6a4705
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Mon Nov 8 14:35:02 2010 -0500

    Use MTDev for multitouch devices
    
    MTDev translates all multitouch devices to the slotted evdev protocol.
    This provides a clean and uniform interface and reduces message handling
    inside the input module and X.
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>

commit e18abd0049421a98e61c15c2d56cfe2821cf4739
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Mon Nov 8 11:08:01 2010 -0500

    Add experimental XI 2.1 multitouch support
    
    This multitouch addition only supports slotted MT evdev protocol
    devices. Support must be enabled at configure time using
    --enable-multitouch.
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>
    
    Amendments: XI_TouchMotion -> XI_TouchUpdate, rename mtMask to mt_mask
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 683a55e504f4fc2d1c847c54986439a0c61b2f20
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Oct 25 09:59:50 2011 +1000

    Use a new "Virtual Device" boolean property to mark virtual devices
    
    Use udev to check for the device's sysfs path, if it contains LNXSYSTM it's
    a kernel-emulated device. This property can then be used to determine if
    there are any real devices connected, allowing the desktop environment to
    e.g. turn off the touchpad whenever there's a mouse attached.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a9cdb6590cdf72917cdfeb17e2fcc6a110b2c7d1
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Nov 11 07:31:02 2011 +1000

    Move misplaced #endif caused by smooth-scrolling merge
    
    Bad conflict resolution in xf86-input-evdev-2.6.0-30-g745fca0
    
    Reported-by: Sebastian Glita <glseba@yahoo.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit dd000dd4fa118529809632e610a0a439d7467096
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Nov 9 16:04:06 2011 +1000

    Bump to 2.6.99
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 745fca03a20117583bc18c7134583311ff52c29c
Merge: eede8cc b450efd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Nov 9 16:01:48 2011 +1000

    Merge branch 'smooth-scrolling'
    
    Conflicts:
    	src/evdev.c
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b450efdf95999cad08de23ce069f04a66bdae24b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Aug 19 11:15:09 2011 +1000

    Support smooth scrolling on REL_WHEEL, REL_HWHEEL and REL_DIAL
    
    Automatic smooth scrolling setup for these axes, with REL_WHEEL and REL_DIAL
    both mapping into vscrolling. REL_WHEEL is the preferred axis.
    
    Mouse wheel emulation is not yet updated for smooth scrolling.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Daniel Stone <daniel@fooishbar.org>

commit eede8ccffc1a831f4de89403edc8dffd52494e8b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Oct 25 15:43:38 2011 +1000

    Don't crop long value from EvdevBitIsSet.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>
    Reviewed-by: Jeremy Huddleston <jeremyhu@apple.com>

commit 2aba790ed3acc3ece5e56dac088e0a0a4a04b45d
Author: Jools Wills <jools@oxfordinspire.co.uk>
Date:   Sun Oct 30 23:19:21 2011 +0000

    emuThird: Use xf86SetIntOption, not xf86SetBoolOption for integer values
    
    Signed-off-by: Jools Wills <jools@oxfordinspire.co.uk>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 49693892ce35e95674fbb3d2a067c8fa0227da87
Author: Max Schwarz <Max@x-quadraht.de>
Date:   Mon Oct 17 21:01:22 2011 +0200

    type-safe inline functions for bitmask manipulation
    
    We can't use BitIsSet/SetBit from the server (inputstr.h) since they
    operate on byte arrays. EvdevSetBit is added in preparation for the
    "smooth-scrolling on wheel emulation" patch.
    
    Signed-off-by: Max Schwarz <Max@x-quadraht.de>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 070f30e08956e7fa8b7f9ca6b94fee3ef39caa1e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Aug 15 11:34:12 2011 +1000

    Exit axis labelling if axes are neither rel nor abs
    
    No actual effect since labels_len is always 0 anyway but let's make the
    return more explicit.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ffe35b6c2566fc2a3f418185a61a12c7f377affd
Author: Terry Lambert <tlambert@chromium.org>
Date:   Fri Jul 15 17:23:20 2011 -0700

    xf86-input-evdev: Return proper default for unknown values in pInfo->device_control.
    
    Signed-off-by: Terry Lambert <tlambert@chromium.org>
    Reviewed-by: Stephane Marchesin <marcheu@chromium.org>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5069e053354ad6adfcbb08c962bff93b607dec3d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri May 27 16:20:03 2011 +1000

    Remove unused misc_label and val
    
    evdev.c: In function 'EvdevInitAxesLabels':
    evdev.c:2192:11: warning: variable 'misc_label' set but not used
    [-Wunused-but-set-variable]
    obsolete with 880ad1e19afd83ac115948b67d4049e16cb12df0
    
    emuWheel.c: In function 'EvdevWheelEmuPreInit':
    emuWheel.c:252:10: warning: variable 'val' set but not used
    [-Wunused-but-set-variable]
    obsolete with b0737bdbd1f6e601eb4984b6f4cb49279190984c
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Daniel Stone <daniel@fooishbar.org>

commit 0b9fad23a3d464ac064521d0e29f036b0ffdc9b8
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri May 27 16:17:12 2011 +1000

    Print abs axes ranges on verbosity 6.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Daniel Stone <daniel@fooishbar.org>

commit b79776cf8caa2b8db2984177661698da862befa6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jun 15 10:22:39 2011 +1000

    Require server 1.10
    
    We require ABI 12.2 in the driver, enforce it through pkg-config.
    Technically ABI 12.2 is first available in 1.9.99.902 but 1.10 looks so much
    nicer.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Daniel Stone <daniel@fooishbar.org>

commit a52cd1cab2ae84442758de5155c5ec1417a7d16d
Author: Daniel Kurtz <djkurtz@google.com>
Date:   Tue Jun 14 18:09:00 2011 +0800

    Set prop_product_id undeletable
    
    prop_invert was accidentally being set undeletable twice.
    
    Signed-off-by: Daniel Kurtz <djkurtz@google.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit eaf202531f2bb2b3da6d4769769f76da5489ae68
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jan 31 14:11:44 2011 +1000

    Export device node as property.
    
    There is currently no mapping between XI devices and physical devices other
    than what can be extracted by parsing the Xorg logfile. Add new property
    "Device Node" to the driver to export the open device file.
    
    Server 1.11 and later standardises on this property name.
    
    The client is responsible for detecting if the device is on the same host
    and converting the data into a more useful format (e.g. sysfs path).
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 74151b3c52d989208c6ec8acadadd9bcf063bcc5
Author: Peter Korsgaard <jacmet@sunsite.dk>
Date:   Tue May 24 09:44:05 2011 +0200

    Handle touchscreens without BTN_TOUCH
    
    Some touchscreens (like the Lumio crystaltouch in single touch mode) send
    BTN_LEFT rather than BTN_TOUCH:
    
    Input driver version is 1.0.1
    Input device ID: bus 0x3 vendor 0x202e product 0x5 version 0x111
    Input device name: "LUMIO Inc LUMIO CrystalTouch ver 1.1C"
    Supported events:
      Event type 0 (Sync)
      Event type 1 (Key)
        Event code 272 (LeftBtn)
        Event code 273 (RightBtn)
        Event code 274 (MiddleBtn)
      Event type 2 (Relative)
        Event code 9 (Misc)
      Event type 3 (Absolute)
        Event code 0 (X)
          Value    650
          Min        0
          Max     4095
        Event code 1 (Y)
          Value   3221
          Min        0
          Max     4095
      Event type 4 (Misc)
        Event code 4 (ScanCode)
    Testing ... (interrupt to exit)
    Event: time 1305882024.934011, type 4 (Misc), code 4 (ScanCode), value 90001
    Event: time 1305882024.934017, type 1 (Key), code 272 (LeftBtn), value 1
    Event: time 1305882024.934029, type 3 (Absolute), code 0 (X), value 270
    Event: time 1305882024.934034, type 3 (Absolute), code 1 (Y), value 1513
    Event: time 1305882024.934039, type 2 (Relative), code 9 (Misc), value 1
    
    This causes evdev to handle these device as a mouse rather than a
    touchscreen, which naturally doesn't work very well. We already internally
    translate BTN_TOUCH as BTN_LEFT, so accept this kind of devices as
    touchscreens by checking for devices with BTN_LEFT, absolute X/Y and NO
    relative X/Y axes.
    
    Signed-off-by: Peter Korsgaard <jacmet@sunsite.dk>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e9d96e87acbd79b22837ac4b225ceb0bd0e1942e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 18 12:20:19 2011 +1000

    Add a property to toggle function key mode
    
    On some keyboards, the multimedia function keys are overlaid with the F
    keys. This property enables clients to switch the primary mode of these F
    keys between function keys and multimedia keys.
    Some keyboards provide an Fn key to toggle between the modes. This is
    hardware-specific and may or may not work on any given keyboard device.
    
    The current imlementation is only hooked up to apple keyboards.
    The kernel provides a tweak to enable/disable.
    
    /sys/module/hid_apple/parameters/fnmode
        0 .. keyboard sends Fx keys, Fn disabled
        1 .. keyboard sends multimedia keys, Fn toggles to function keys
        2 .. keyboard sends function keys, Fn toggles to multimedia keys
    
    If fnmode is on 0, we force it to 2.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Michel Dänzer <michel@daenzer.net>

commit bb15bac149411a2066eca6ddd50e2ca2cc38f7c8
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 18 12:20:00 2011 +1000

    Export product/vendor ID through a property.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Daniel Stone <daniel@fooishbar.org>

commit 7611d2fc7357c44f56fed174d90681d5128f99e3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 18 12:19:24 2011 +1000

    Move invert variable to the block it is used in.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Daniel Stone <daniel@fooishbar.org>

commit ebe41bfba77ba9c95d990d47d5e8f5a8a4f7477e
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Fri Apr 15 12:14:03 2011 -0400

    Copy out of proximity values into current values selectively
    
    Otherwise, an event that causes us to go into proximity with some new
    valuator values will retain some old valuator values from when last in
    proximity. This change ensures that all values posted while out of
    proximity are accounted for.
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 68a6a18fc2fe1d95c9196c1948a27f9e95029bec
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Mon Apr 4 09:40:14 2011 -0400

    Ensure all known valuator values are stored when out of proximity
    
    The current code overwrites *all* the stored axis values with whatever
    came in from evdev. Evdev is a stateful protocol, so it only sends us
    updates to the axis values that have changed. We need to only update
    the values that have changed.
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit eeacd3e5a8bbd797776f27e18d8ed68aa95a8823
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Mon Apr 4 09:40:13 2011 -0400

    Ensure events are posted when entering into proximity
    
    Fixes LP: #736829 (https://bugs.launchpad.net/bugs/573006)
    
    Re-fixes old X.Org Bug 29645
    <http://bugs.freedesktop.org/show_bug.cgi?id=29645>
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5708e384942a7257257fbae8b1d64548fd6559a0
Author: Simon Thum <simon.thum@gmx.de>
Date:   Sun Mar 20 15:49:48 2011 +0100

    rename valuator init functions
    
    Since the mode of valuators (no longer?) bears a relation to the device class
    actually initialized, this naming was quite misleading.
    
    Signed-off-by: Simon Thum <simon.thum@gmx.de>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 41111ce1efc6181b8da042c5b01f01cdf92315be
Author: Rami Ylimäki <rami.ylimaki@vincit.fi>
Date:   Tue Mar 8 11:23:47 2011 +0200

    Remove constness of device filename to avoid warning when freed.
    
    A warning from free() can be avoided by casting the constness away
    from its argument pointer or by not declaring the pointer as const in
    the first place.
    
    Signed-off-by: Rami Ylimäki <rami.ylimaki@vincit.fi>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b4c47d5f9454a708a5ab161c015646f2ca6e1ac3
Author: Rami Ylimäki <rami.ylimaki@vincit.fi>
Date:   Tue Mar 8 11:23:46 2011 +0200

    Release leaked device identifier on input device disconnect.
    
    Signed-off-by: Rami Ylimäki <rami.ylimaki@vincit.fi>
    Reviewed-by: Erkki Seppälä <erkki.seppala@vincit.fi>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 50193a0dd35b6f54499fb76ab68f615237cc51f9
Author: Rami Ylimäki <rami.ylimaki@vincit.fi>
Date:   Tue Mar 8 11:23:45 2011 +0200

    Release leaked XKB options on input device disconnect.
    
    Currently the XKB options duplicated in EvdevAddKeyClass are never
    released. For example, connecting and disconnecting a bluetooth
    keyboard repeatedly causes a steadily growing memory leak.
    
    Signed-off-by: Rami Ylimäki <rami.ylimaki@vincit.fi>
    Reviewed-by: Erkki Seppälä <erkki.seppala@vincit.fi>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0049cce4d0691f055dfe9059e4c0c4ad30301db6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Feb 11 13:31:52 2011 +1000

    Use Absolute/Relative as argument to xf86Post*
    
    xf86Post* takes an int for the is_absolute parameter. Since the XI protocol
    spec requires Relative to be 0 and Absolute to be 1, use those instead to
    make the code easier to read.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d9001a6be9d86a5f30549af9fbb02a466f4b0709
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jan 26 12:11:00 2011 +1000

    Add third button emulation.
    
    New properties:
    "Evdev Third Button Emulation" → switch on/off
    "Evdev Third Button Emulation Timeout" → timeout until event is delivered
    "Evdev Third Button Emulation Button" → phys button to be emulated
    "Evdev Third Button Emulation Threshold" → move threshold before emulation
    is cancelled
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Tested-by: Benjamin Tissoires <tissoire@cena.fr>

commit 22db196815b813ff1c4806dd4cbb06788763d6b6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jan 31 13:39:46 2011 +1000

    Static atoms don't need to be initialized to 0.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 54ac2306b83434a014e941e25a5286a592e74351
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jan 31 12:07:48 2011 +1000

    Replace xf86Msg() with xf86IDrvMsg().
    
    The latter provides a standardised message format in the form of
        driver name: device name: message
    
    making it easier to grep for driver messages in the log.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 768c25a99b2f4ec07993eb15a0f05a5e22b5c695
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Mon Jan 24 11:49:05 2011 -0500

    Add support for masked valuators
    
    With the X server now supporting masked valuators for XI2, enable
    support in X evdev.
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b5c9f41b2b6c680b7c44eadef8da855b1d9adcb7
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Sat Jan 22 16:40:49 2011 -0500

    Switch to "goto" logic for error handling when adding classes
    
    This will be necessary for the addition of multitouch functionality.
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8bc4be3048754b9c751cd98f5a5b46cf59a56f3a
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Sat Jan 22 16:40:48 2011 -0500

    Remove support for X input ABI < 12.2
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 30c3645e20e945b0f8b7dc624748948464be606e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jan 11 12:46:40 2011 +1000

    evdev 2.6.0
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3b52fe2ea4a934a8d87aacd185593beb01f8f273
Author: Chase Douglas <chase.douglas@canonical.com>
Date:   Wed Jan 5 10:09:55 2011 -0500

    Print out error messages when failing to init devices
    
    Signed-off-by: Chase Douglas <chase.douglas@canonical.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 540a4cce9071fce183c941ded35e7e8fb8f3507e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jan 5 09:04:56 2011 +1000

    evdev 2.5.99.903
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit bed25600f66db245b895a48d6edca30568ca7559
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Dec 23 12:13:16 2010 +1000

    Don't update first_val and num_val if we don't have data (#32480)
    
    For touchpads, rel_queued may be on (due to abs to rel conversion) but the
    delta for x/y is 0/0 on the first touch. Hence, we don't have any valuators
    to post. The current results in a num_vals of -15 and a subsequent segfault
    when the data is posted to the server.
    
    Start with a last valuator of -1, so that we know if we have at least one to
    post.
    
    X.Org Bug 32480 <http://bugs.freedesktop.org/show_bug.cgi?id=32480>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit 9aea1c5fa09c25ad83bcf2fd4ee4bd853d889e5e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Dec 21 10:53:06 2010 +1000

    Add use_proximity bit for BTN_TOOL handling.
    
    Touchpads send garbage data between BTN_TOOL_FINGER and BTN_TOUCH. This
    leads to cursor movement towards invalid positions (bottom left corner,
    usually).
    
    Add a new flag "use_proximity" as a delimiter for BTN_TOUCH handling. If
    unset, the actual proximity bits are ignored, no proximity events are sent
    and BTN_TOUCH is used for the tool handling.
    
    Example event stream for synaptics:
    
    Event: time 1292893041.002731, -------------- Report Sync ------------
    Event: time 1292893041.015807, type 1 (Key), code 330 (Touch), value 0
    Event: time 1292893041.015812, type 3 (Absolute), code 0 (X), value 4283
    Event: time 1292893041.015813, type 3 (Absolute), code 1 (Y), value 4860
    Event: time 1292893041.015815, type 3 (Absolute), code 24 (Pressure), value 23
    Event: time 1292893041.015817, type 3 (Absolute), code 28 (Tool Width), value 5
    Event: time 1292893041.027537, -------------- Report Sync ------------
    Event: time 1292893041.038854, type 3 (Absolute), code 0 (X), value 1
    Event: time 1292893041.038857, type 3 (Absolute), code 1 (Y), value 5855
    Event: time 1292893041.038859, type 3 (Absolute), code 24 (Pressure), value 1
    Event: time 1292893041.038861, type 3 (Absolute), code 28 (Tool Width), value 5
    Event: time 1292893041.038864, -------------- Report Sync ------------
    Event: time 1292893041.062432, type 3 (Absolute), code 24 (Pressure), value 0
    Event: time 1292893041.062435, type 3 (Absolute), code 28 (Tool Width), value 0
    Event: time 1292893041.062437, type 1 (Key), code 325 (ToolFinger), value 0
    Event: time 1292893041.062438, -------------- Report Sync ------------
    
    Reported-by: Dave Airlie <airlied@redhat.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 0c987a929dd4c98d4a80d8b7f75286902eb572f2
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Dec 21 10:45:11 2010 +1000

    Revert "Don't count BTN_TOUCH as tool. (#29428)"
    
    Synaptics devices send garbage between BTN_TOUCH and BTN_TOOL_FINGER. By
    switching to use this as proximity data now, the pointer is reset to the
    garbage data position (usually around 1/5855).
    
    This reverts commit 899218e18120918138f6d7420465763422d5b3b7.
    
    Reported-by: Dave Airlie <airlied@redhat.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 242a01eb0f2f9b56fb6d6f0b41fc6a899cadb857
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Dec 21 10:40:45 2010 +1000

    Rename proximity to in_proximity.
    
    No functional change, just making it a bit more obvious to read.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Dan Nicholson <dbn.lists@gmail.com>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 7415953b9afac3221d1bb834aadcc7c1917366fd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Dec 21 10:44:14 2010 +1000

    Fix grammar typo in comment.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1ced7ec7e23c57c0e1aaddeb3c113e67a5cb7341
Author: Peter Korsgaard <jacmet@sunsite.dk>
Date:   Fri Dec 10 16:16:59 2010 +0100

    evdev: rename EvdevCacheCompare() to EvdevCache()
    
    Since 59056e656c64 (Remove the reopen timer logic) from last year,
    EvdevCacheCompare() is only used for caching ioctl values and not for
    comparing, so remove the unused compare logic and rename the function
    to EvdevCache().
    
    Signed-off-by: Peter Korsgaard <jacmet@sunsite.dk>
    Reviewed-by: Benjamin Tissoires <benjamin.tissoires@enac.fr>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1c5ad6f8a0f098da89aa88102f424c667addf376
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Dec 8 12:40:49 2010 +1000

    evdev 2.5.99.902
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 6fd1d0860e71c644fa72b4b40872e0ced671726c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Dec 6 11:41:11 2010 +1000

    Return error codes from EvdevOpenDevice()
    
    The server's behaviour is to stop adding new devices when a BadAlloc occurs
    on any device (on the assumption that new devices won't magically have more
    memory). Change EvdevOpenDevice() to return an error code of BadValue when
    it fails (and thus to the server) to prevent other devices being ignored
    because of one misconfigured one.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Daniel Stone <daniel@fooishbar.org>

commit 31ba99e9edd28ff81437e0167c5322b9f619c52a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Nov 19 14:27:09 2010 +1000

    evdev 2.5.99.901
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a4aefca2ed52e675e6151a0fb0742a9e19565a41
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Oct 25 11:05:18 2010 +1000

    Reshuffle to avoid the need for XI86_CONFIGURED.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Benjamin Tissoires <tissoire@cena.fr>

commit 20d7a0a4aab64232712186811ae55c40d2b7d161
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Oct 25 10:38:21 2010 +1000

    Input API 12 requires a valuator mode for each axis.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Benjamin Tissoires <tissoire@cena.fr>

commit 5e26ba8641809addc63e783e1cefac0f8524b020
Author: Nikolai Kondrashov <spbnick@gmail.com>
Date:   Wed Oct 20 23:31:30 2010 +0400

    Extend button mapping to full ranges
    
    Extend button code to number mapping to cover full BTN_MOUSE and BTN_MISC
    ranges, including undefined codes.
    
    This extends mapping introduced with 0367e387 to the following:
    
            1       BTN_LEFT        BTN_0       BTN_TOUCH
            2       BTN_MIDDLE      BTN_1       BTN_STYLUS
            3       BTN_RIGHT       BTN_2       BTN_STYLUS2
    
            8       BTN_SIDE        BTN_3
            9       BTN_EXTRA       BTN_4
            10      BTN_FORWARD     BTN_5
            11      BTN_BACK        BTN_6
            12      BTN_TASK        BTN_7
            13      0x118           BTN_8
            14      0x119           BTN_9
            15      0x11A           0x10A
            16      0x11B           0x10B
            17      0x11C           0x10C
            18      0x11D           0x10D
            19      0x11E           0x10E
            20      0x11F           0x10F
    
    This should fix https://bugs.freedesktop.org/show_bug.cgi?id=30336
    
    Signed-off-by: Nikolai Kondrashov <spbnick@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 71dd18f72889ef6998a1bd699630da583dcb775a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Oct 19 10:22:55 2010 +1000

    Rename CountBits to EvdevCountBits.
    
    Avoid name collision with the server.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Benjamin Tissoires <tissoire@cena.fr>
    Reviewed-by: Chase Douglas <chase.douglas@canonical.com>

commit c3e49f2b95d3e40f97d6bffdaf8a6c036093fa91
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Oct 20 10:33:39 2010 +1000

    Use an array for the proximity bits.
    
    Instead of two lists that need to be kept in sync, just store the bits in an
    array and run through them.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Benjamin Tissoires <tissoire@cena.fr>
    Reviewed-by: Daniel Stone <daniel@fooishbar.org>

commit b06d3ffdcdb14978201af5b24a7292ee73b65318
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Oct 20 10:20:26 2010 +1000

    Rename abs/rel/prox to abs_queued/rel_queued/prox_queued.
    
    Mainly to avoid confusing between pEvdev->prox and pEvdev->proximity and to
    better express what these fields are actually holding.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Benjamin Tissoires <tissoire@cena.fr>
    Reviewed-by: Daniel Stone <daniel@fooishbar.org>

commit 3646371eefae63678876f45daa0eea2ac522f2e2
Author: Benjamin Tissoires <tissoire@cena.fr>
Date:   Sat Oct 16 20:20:31 2010 +0200

    Add the names of the valuators for the multitouch properties
    
    Thoses definitions have been included in the kernel and in the X server.
    However, the evdev driver has not been updated accordingly.
    
    Without these definitions, the multitouch axes are not correctly labelled.
    
    Signed-off-by: Benjamin Tissoires <tissoire@cena.fr>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b48f4c41c0d3386bba3e9d8fa3da91f18aae190b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Oct 11 09:33:28 2010 +1000

    Add proximity support.
    
    When one of the tools comes into proximity, queue up a proximity event and
    send it accordingly.
    
    Includes special handling for tablets that do not send axes with tools
    (#29645)
    
    Some tablets send axis values, then EV_SYN, and in the next event the
    BTN_TOOL_PEN/BTN_TOUCH, etc. For these tablets, the cursor doesn't move as
    coordinates while not in proximity are ignored.
    
    Buffer coordinates received while out-of-proximity and if we get a proximity
    event without other coordinates, re-use the last ones received.
    
    X.Org Bug 29645 <http://bugs.freedesktop.org/show_bug.cgi?id=29645>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>
    Reviewed-by: Benjamin Tissoires <tissoire@cena.fr>

commit 185ad42078a3bcb423b83e41ebeddbb7541fe26c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Sep 8 10:47:34 2010 +1000

    Rename evdev->tool to evdev->proximity.
    
    evdev doesn't care about the actual tool used, only that it is used as an
    indicator for proximity. Rename the field accordingly to make the code more
    obvious to read.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Chris Bagwell <chris@cnpbagwell.com>

commit 7282e3ac6c3b23cce927271fb9ca34b2acd36fd3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Sep 8 11:30:14 2010 +1000

    When posting buttons, post absolute valuators if we have them.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Benjamin Tissoires <tissoire@cena.fr>

commit c504852aa27239a57445ca1de013b5bfefa68276
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Sep 8 11:29:11 2010 +1000

    Fix valuator offset when posting absolute motion events.
    
    If first_v was not zero, the values passed to xf86PostMotionEventP were
    wrong.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Benjamin Tissoires <tissoire@cena.fr>

commit 4bbf9c9125db51394870c86413fe18a0c8ec7068
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Sep 8 11:28:27 2010 +1000

    Don't pass pointers around to first_v and num_v.
    
    We only use them as values, no need for the addresses.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Benjamin Tissoires <tissoire@cena.fr>

commit 684426a9d2b4850ae80c824d4afe1e95875eee21
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Sep 8 10:59:12 2010 +1000

    De-duplicate event queue access.
    
    Factor out access to the next queue element in a static function to be
    reused for button and key presses.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Benjamin Tissoires <tissoire@cena.fr>

commit 9664e5a48723e7085fc3ece2aa13f8696f631a3d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Oct 6 10:58:17 2010 +1000

    Remove refcnt initialization from InputDriverRec.
    
    Removed from the server with
    commit 6130170e7e9b64c611ee942ec3455dd1a185193d
    Author: Adam Jackson <ajax@redhat.com>
    Date:   Sat Sep 18 06:41:35 2010 -0400
    
        xfree86: Remove unused refcounting from input drivers
    
    And given that it was unused, we don't need to ifdef it.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0367e3871f02993b4ce04873d6e40df16fb0a202
Author: Nikolai Kondrashov <spbnick@gmail.com>
Date:   Thu Sep 2 18:09:13 2010 +0400

    Clean up button code to number mapping
    
    Now BTN_MOUSE, BTN_MISC and BTN_DIGI button ranges are all mapped to the
    same lower numbers including first three, corresponding to the LMR mouse
    buttons. Like this:
    
        1       BTN_LEFT        BTN_0       BTN_TOUCH
        2       BTN_MIDDLE      BTN_1       BTN_STYLUS
        3       BTN_RIGHT       BTN_2       BTN_STYLUS2
    
        8       BTN_SIDE        BTN_3
        9       BTN_EXTRA       BTN_4
        10      BTN_FORWARD     BTN_5
        11      BTN_BACK        BTN_6
        12      BTN_TASK        BTN_7
        13                      BTN_8
        14                      BTN_9
    
    This streamlines the button mapping under the assumption that these ranges
    don't generally appear in a single device simultaneously. If they do appear,
    they will simply report overlapping button numbers.
    
    Signed-off-by: Nikolai Kondrashov <spbnick@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 617a09e298768d0a1d33cb6b367410455489e8b8
Author: Nikolai Kondrashov <spbnick@gmail.com>
Date:   Tue Sep 7 10:38:20 2010 +1000

    Add BTN_TOUCH/STYLUS/STYLUS2 support.
    
    These three buttons are mapped into buttons 1/2/3, respectively.
    Overlapping range with BTN_LEFT/MIDDLE/RIGHT, assuming that these
    ranges don't generally appear in a single device simultaneously.
    
    Signed-off-by: Nikolai Kondrashov <spbnick@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b83515485b739451b6cde29c7e6f5c900175eaf9
Author: Tim Yamin <plasm@roo.me.uk>
Date:   Tue Sep 7 10:31:02 2010 +1000

    SwapAxes should rescale raw values when enabled
    
    Current implementation assumes that X & Y axes have the same min and max
    values. If they don't, you'll end up with funny behaviour if SwapAxes is
    turned on.
    
    Signed-off-by: Tim Yamin <plasm@roo.me.uk>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 009d442aa347cea15d07ceaec955a2f69f247364
Merge: 10493de 4964c61
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Sep 1 13:04:29 2010 +1000

    Merge branch 'input-api' of git://people.freedesktop.org/~whot/xf86-input-evdev

commit 10493de96e905b831e14bd510f2af1b8da3d2be6
Author: Nikolai Kondrashov <spbnick@gmail.com>
Date:   Tue Aug 31 11:31:07 2010 +0400

    Improve dumb tablet detection
    
    Improve dumb tablet detection by checking if BTN_STYLUS or BTN_STYLUS2
    (first or second pen barrel button) is present when BTN_TOOL_PEN is not
    found.
    
    This enables detection of tablets without explicit tool proximity reporting.
    These include at least four UC-Logic tablet models: WP4030U, WP5540U,
    WP8060U and PF1209, on which many Genius and Trust models are based.
    
    Signed-off-by: Nikolai Kondrashov <spbnick@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 829facd516d90f92187b78ccf6d921a1b1671990
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Aug 31 14:09:46 2010 +1000

    Bump to 2.5.99.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit fbafe59420f128b6264feeb115bbcbc1c933f611
Author: Nikolai Kondrashov <spbnick@gmail.com>
Date:   Wed Aug 25 00:39:45 2010 +0400

    Fix comments about BTN_TOOL_PEN.
    
    Fix incorrect usage of BTN_DIGI instead of BTN_TOOL_PEN in comments.
    Fix forgotten pEvdev->digi reference.
    
    Signed-off-by: Nikolai Kondrashov <spbnick@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 990540fa1905b11403d5c25345c428c5bc9ed126
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Aug 23 10:34:36 2010 +1000

    evdev 2.5.0
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b8945e61eb97265fdccace8411b8b33d3d56be13
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Aug 23 10:27:35 2010 +1000

    man: don't reference README.mouse
    
    No real reason to refer to the mouse driver's readme.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 97dc45b769c9a4dfa61782d7ce491df8ebaed3dc
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Aug 19 12:50:25 2010 +1000

    evdev 2.4.99.901
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ec6cb31cc47eed3ccba4c906ca6c54b99136e9eb
Author: Bartosz Brachaczek <b.brachaczek@gmail.com>
Date:   Tue Aug 10 22:31:37 2010 +0200

    evdev: Initialize valuators array. (#24737)
    
    The array needs to be filled with zeros, otherwise we may end up sending
    it with random values if non-zero values aren't in one row (which is the
    case for A4Tech X-750F which sends REL_MISC events without a reason).
    
    X.Org Bug 24737 <http://bugs.freedesktop.org/show_bug.cgi?id=24737>
    
    Signed-off-by: Bartosz Brachaczek <b.brachaczek@gmail.com>
    Tested-by: Bartek Iwaniec <hash87@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ed47c7f33e315f163a6aebeb3e1c8947004576fd
Author: Bartosz Brachaczek <b.brachaczek@gmail.com>
Date:   Tue Aug 10 22:31:00 2010 +0200

    evdev: Revert "Set all valuators for relative motion events (#24737)"
    
    It isn't necessary to post zero-deltas to X Server. In order not to post
    uninitialized "v" array we should rather simply initialize it.
    
    This reverts commit c1f16a4f59a584ab4546c2f16e20b06703042057.
    
    Signed-off-by: Bartosz Brachaczek <b.brachaczek@gmail.com>
    Tested-by: Bartek Iwaniec <hash87@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 899218e18120918138f6d7420465763422d5b3b7
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Aug 9 13:01:11 2010 +1000

    Don't count BTN_TOUCH as tool. (#29428)
    
    Devices that don't have a tool but BTN_TOUCH simply have the tool always on.
    Devices that have a tool other than BTN_TOUCH set this tool before BTN_TOUCH
    is emitted anyway.
    
    X.Org Bug 29428 <http://bugs.freedesktop.org/show_bug.cgi?id=29428>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 4964c61f4b248e9eb16e8eadb5f5d0b6410b6b84
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jul 22 11:32:08 2010 +1000

    Return BadMatch for already configured devices.
    
    PreInit can now return different error codes. Return BadAlloc for alloc
    failures and BadMatch if the device was already configured or the cache
    comparison/probe failed.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 92e8dc49611398c8a9659b244645530cd26736fe
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jul 22 10:57:02 2010 +1000

    Use the new input API (changed PreInit function prototype).
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e0e4b7d89b20ab9997a2eeb17dc7381ecafa31e3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jul 22 10:51:54 2010 +1000

    Move private init down.
    
    No real change, preparation for new input API.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d2c11d36a05e18936e39f7aa592c15b254aff1de
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jul 22 10:51:12 2010 +1000

    Use pInfo->options instead of dev->commonOptions.
    
    No real change, preparation for new input API.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2f636402d882c775497e88c1f74477c4f6e9521d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jul 22 10:40:01 2010 +1000

    Add ifdefs for pre ABI 12 support.
    
    The server doesn't provide these defines anymore, define them here for
    future use. To be purged whenever we drop support for the current server.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3d3565c069558b9d1e8e0e86332415731b88b11d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jul 22 10:38:58 2010 +1000

    Remove usage of XI86_POINTER_CAPABLE and XI86_KEYBOARD_CAPABLE.
    
    XI86_KEYBOARD_CAPABLE was write-only, both in the driver and the server.
    XI86_POINTER_CAPABLE was write-only in the server and can be emulated with
    has_abs_axes and has_rel_axes.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 421585fda6ce67c209d43952109dda056ee40941
Author: Alex Warg <alexander.warg@os.inf.tu-dresden.de>
Date:   Wed Jun 30 10:33:46 2010 +1000

    Fix out-of-bounds access if more than MAX_VALUATORS are present. (#28809)
    
    The functions EvdevAddRelClass and EvdevAddAbsClass do out of bounds
    accesses to vals and old_vals arrays in the EvdevRec structure if there are
    more than MAX_VALUATORS axes reported by the kernel.
    
    X.Org Bug 28809 <http://bugs.freedesktop.org/show_bug.cgi?id=28809>
    
    Signed-off-by: Alex Warg <alexander.warg@os.inf.tu-dresden.de>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8697811f56160146981f2364d6e154b2c57f388e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jun 22 14:40:13 2010 +1000

    man: some minor fixes to man page.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b06bffdc979eb7d1ebf10680bc9b11baf9bd34a0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jun 11 10:01:08 2010 +1000

    Add myself to Authors in man page.
    
    git blames me for about half the driver now, I guess that's enough
    justification ;)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9410e452d26aeb81fb6068ab83ffdcd5aca32f67
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Thu May 27 21:56:47 2010 -0400

    config: use AC_PROG_INSTALL now supplied by XORG_DEFAULT_OPTIONS
    
    It depends on util-macros 1.8
    The existing statement can now be removed from the configuration file.
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit 516e538da4c866dde12d747095fa1779fd4275c0
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Thu May 27 20:51:47 2010 -0400

    config: upgrade to util-macros 1.8 for additional man page support
    
    Use MAN_SUBST now supplied in XORG_MANPAGE_SECTIONS
    The value of MAN_SUBST is the same for all X.Org packages.
    
    Use AC_PROG_SED now supplied by XORG_DEFAULT_OPTIONS
    The existing statement can now be removed from the configuration file.
    
    Use Automake $() for variables in Makefile.am
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit 1f38e1bc1174a66980d4a7e8e0a36aef938625df
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Sat Jun 12 09:59:06 2010 -0400

    COPYING: update and refactor the Copyright notices
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit 456579ba30edbda8182cc8a7f6347e591d191bd0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jun 1 10:20:25 2010 +1000

    Bump to 2.4.99
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 21a2ac818e75ef918d320ce1e88b6263e68e598d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri May 28 09:47:17 2010 +1000

    Disable middle mouse button emulation by default.
    
    The AUTO feature was the default, MB emulation was on until a middle mouse
    button was pressed. MB emulation however results in a delay of the first
    press, causing minor annoyances to the users and being generally confusing
    when the behaviour before a button press is different to after a button
    pres.
    
    Disable the feature by default instead. There's not a lot of two-button mice
    around anymore though and the inability to detect two-button mice makes for
    non-deterministic detection of when the emulation should be on.
    
    Middle button emulation can be enabled with a configuration snippet:
    
    Section "InputClass"
            Identifier "middle button emulation"
            MatchIsPointer "on"
            Option "Emulate3Buttons" "on"
    EndSection
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Daniel Stone <daniel@fooishbar.org>

commit 4c216242404d749b9ae8ec181146689f89119cb4
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 20 12:40:13 2010 +1000

    Remove libc wrappers for malloc, calloc and free.
    
    Evdev is Linux-only, and we've had the above calls for quite a while now.
    Plus, now that the server has removed them they generate _a lot_ of warnings
    otherwise.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Jamey Sharp <jamey@minilop.net>

commit 6e244b109861d6f602066cac8b766a55a5016c63
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 20 12:38:19 2010 +1000

    Move mode declaration, it's not const either.
    
    What we're getting back from xf86SetStrOption is a strdup'd string, not
    const, especially given that we free it a few lines down.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e7c301563a4b1718d2fc0066c1b3125404e3060f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 20 14:24:05 2010 +1000

    Move opening the device into a separate function.
    
    Re-use from EvdevOn and PreInit.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ffc2c9961f5fb099b85a97550a30a854420ee773
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 20 11:54:56 2010 +1000

    Move checks for calibration, inversion and axis swap to EvdevProbe.
    
    Keyboard devices don't need these checks.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7c01cff1faede468efddf2c66c9ca85022585244
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 19 15:37:01 2010 +1000

    Move EVIOCGRAB into a static func.
    
    This is in preparation of some major rework, there are no functional
    changes.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e6e20c1b3e5977830a2b78046c0a8c49e38746fd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 19 15:09:29 2010 +1000

    Move error handling in PreInit down to the end.
    
    Just have one exit path instead of different ones. Guards are in place to
    avoid freeing/deleting something that shouldn't be.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Jamey Sharp <jamey@minilop.net>

commit b27d03b248e36ec7a674113baa494b82e3ad728b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 19 14:55:32 2010 +1000

    Comment odd EVIOCGRAB behaviour and reshuffle conditions a bit.
    
    The reason for this rather weird approach is to ungrab immediately after
    getting a successful grab. Evdev shouldn't be hogging the device if nothing
    is done with it.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Jamey Sharp <jamey@minilop.net>

commit ba78428ed50685fd89ef4f35143a9b3f2b1ac0f6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 19 14:52:29 2010 +1000

    Remove support for kernel 2.4.
    
    It's been 6 years since 2.6, I doubt evdev would even work on 2.4 right now.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Jamey Sharp <jamey@minilop.net>
    Reviewed-by: Dan Nicholson <dbn.lists@gmail.com>

commit 041a1f246a10951ca5c0fc34b0c88c4762c076bf
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Mon May 10 21:42:35 2010 -0400

    config: AC_PROG_SED is required explicitly.
    
    It sets the SED env variable with an appropriate sed program path
    It still works on some platform when not explicity called.
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit 44b80d177f57a5d697402e0bbb1c3bf77d5f39e6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 6 11:10:45 2010 +1000

    Update a stale comment about the use of pEvdev->tool.
    
    Including some typo fixes in the same comment.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7bbbce9a834f2549168b63d1c5993440ef325f87
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Apr 29 10:06:24 2010 +1000

    Read the device resolution from the kernel.
    
    For earlier kernels, use the previous hardcoded resolution in place.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Julien Cristau <jcristau@debian.org>

commit 35b6085bf8feb9e6d3d3020db868a6e285dec38a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Apr 28 10:41:06 2010 +1000

    config: remove AH_TOP autoheader statement.
    
    Include it in evdev.h instead.
    xorg-server.h is required to define the right datatype sizes on 64 bit,
    hence ensure that evdev.h is the first included in each file.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Gaetan Nadon <memsize@videotron.ca>

commit 539d67505cdb36018bd0e5ef01bd78939eafaadb
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Thu Apr 22 10:50:55 2010 +1000

    Revert "config: remove AH_TOP autoheader statement"
    
    The changed location of xorg-server.h had some side-effects.
    See Bug 27768 <https://bugs.freedesktop.org/show_bug.cgi?id=27768>
    
    This reverts commit 9dbace89bee55a001e794ccf3ff36e3afeda4715.
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a77dea1caa5aa632adad10028ed86544b4bb65e1
Merge: 993e011 5fb1e84
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Apr 20 16:31:09 2010 +1000

    Merge branch 'master' of git://gitorious.org/omcfadde/xf86-input-evdev

commit 5fb1e841eb26f6223504e46dacfc40c2e510f72d
Author: Oliver McFadden <oliver.mcfadden@nokia.com>
Date:   Tue Apr 20 06:59:58 2010 +0300

    evdev: EvdevProbe: check ioctl() return value and warn on failure.
    
    Called function "ioctl" whose return value should be checked (checked 10
    out of 11 times)
    
    Signed-off-by: Oliver McFadden <oliver.mcfadden@nokia.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a4f2d12cd8fbd19d13a184c45817d7539cb7e3be
Author: Oliver McFadden <oliver.mcfadden@nokia.com>
Date:   Tue Apr 20 05:48:33 2010 +0300

    evdev: ioctl() may return a negative value therefor use a signed integer.
    
    Signed-off-by: Oliver McFadden <oliver.mcfadden@nokia.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 6b5c0401e2b8fe1637f937739e822a33206ef1ac
Author: Oliver McFadden <oliver.mcfadden@nokia.com>
Date:   Tue Apr 20 05:37:39 2010 +0300

    evdev: leaked_storage: free memory allocated from the xf86Option code.
    
    Signed-off-by: Oliver McFadden <oliver.mcfadden@nokia.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 993e011b91d318dcb8df76799e5102a20060a169
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Sat Apr 17 18:42:29 2010 -0400

    man: Use Autoconf provided $(AM_V_GEN)$(SED)
    
    Enables silent rule and use platform appropriate version of sed.
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit 2d5e922a6daacf5d6e7f93ff072842a278ceed42
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Sat Apr 17 18:23:48 2010 -0400

    include: EXTRA_DIST is not required for header files.
    
    The sdk_HEADERS is sufficient as the "sdk" prefix
    matches the "dir" suffix in the "sdkdir" variable.
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit 41a38ec88608a829dc175cece79f3100671c9e84
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Sat Apr 17 18:18:55 2010 -0400

    config: require macros 1.4, fix warnings, m4 quotings and layout
    
    Fix some m4 quoting
    Fix some autoconf warnings
    remove AC_PROG_CC as it overrides AC_PROG_C_C99 from XORG_DEFAULT_OPTIONS
    Regroup statements per section
    Add comments
    Upgrade X.Org macros to 1.4 for INSTALL file copying
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit b31c00efeaa0e3c75c0ab35458aaa322719a823f
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Sat Apr 17 15:11:43 2010 -0400

    config: optional extension check for inputproto not required
    
    The check should be in PKG_CHECK_MODULES permanently.
    
    The XORG_DRIVER_CHECK_EXT will add inputproto to PKG_CHECK_MODULES
    only if the extension is available. By definition, this extension
    is always available and the evdev driver cannot function without it.
    
    This is evidenced by the absence of XINPUT conditional code.
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit b48dcfa3f22575840a377380fbe98e5e05e400c9
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Thu Apr 15 13:27:14 2010 -0400

    config: replace deprecated INCLUDES with AM_CPPFLAGS
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit 44baa36b9904f2afdfd00769a2d15a5eb630059e
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Thu Apr 15 13:22:31 2010 -0400

    config: refactor and comment the sdkdir distcheck workaround
    
    Seperate legitimate sdkdir usage from distcheck workaround.
    Comment this non obvious workaround.
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit 7fa5982d477351f7e4b825234bfa248363d3d183
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Thu Apr 15 13:13:45 2010 -0400

    config: remove unrequired AC_HEADER_STDC
    
    Autoconf says:
    "This macro is obsolescent, as current systems have conforming
    header files. New programs need not use this macro".
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit fe8d0fa11a1ffaf219cc66ac3c509fdc844025bd
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Thu Apr 15 13:12:49 2010 -0400

    replace deprecated AM_CONFIG_HEADER with AC_CONFIG_HEADERS
    
    Regroup AC statements at the top.
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit 09b918db86febb8a25c0e497f1629cd245c71975
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Thu Apr 15 13:10:58 2010 -0400

    config: update AC_PREREQ statement to 2.60
    
    Unrelated to the previous patches, the new value simply reflects
    the reality that the minimum level for autoconf to configure
    all x.org modules is 2.60 dated June 2006.
    
    ftp://ftp.gnu.org/gnu/autoconf/autoconf-2.60.tar.gz
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit 9dbace89bee55a001e794ccf3ff36e3afeda4715
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Thu Apr 15 13:09:05 2010 -0400

    config: remove AH_TOP autoheader statement
    
    The generated config.h does not need to include xorg-server.h
    for the content it provides.
    Add #include <xorg-server.h> in .[hc] files as needed.
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit aaf65e7bfacd9501c4475a579d92c3bc60409893
Author: Paulo Ricardo Zanoni <pzanoni@mandriva.com>
Date:   Wed Apr 14 17:12:27 2010 -0300

    Don't set pEvdev->rel for mouse wheel events
    
    This way we won't get empty MotionNotify events when the mouse wheel is
    used.
    
    Signed-off-by: Paulo Ricardo Zanoni <pzanoni@mandriva.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8eede7ea8d3e3bc3a3b0d48c89df3c5f40041ef7
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Apr 8 16:49:01 2010 +1000

    Use X_PROBED instead of X_INFO for probed values.
    
    No functional changes, only the log output differs now.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Fernando Carrijo <fcarrijo@yahoo.com.br>

commit 1936632cb0b777e54cef9dd58df9060155d0643e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Apr 6 10:31:16 2010 +1000

    evdev 2.4.0
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0dc931e1acee6ea3afd032be887f85ce1121f325
Author: Simon Thum <simon.thum@gmx.de>
Date:   Tue Mar 16 16:00:21 2010 +0100

    move feedback initialization up
    
    This allows the backend to propery initialize the feedback from options,
    as it works with most other drivers. This is the hacky equivalent of
    fixing the initialization of pointer acceleration, which would require
    changes to most drivers however.
    
    Signed-off-by: Simon Thum <simon.thum@gmx.de>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d525b48a2ffeeb63fd248e21324e33156ed61ed0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 15 11:08:05 2010 +1000

    When labeling a device as touchpad, only check for LMR buttons.
    
    Touchpads that have physical buttons have either LMR or BTN_TOOL_FINGER.
    Other buttons in the range evdev recognises shouldn't be taken into account
    here - they skew the detection towards touchpads and away from touchscreens.
    
    Fedora Bug 571639
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Simon Thum <simon.thum@gmx.de>

commit 801778c3106fc7e409369b4500253a38be6a5795
Author: Oliver McFadden <oliver.mcfadden@nokia.com>
Date:   Thu Feb 25 07:11:21 2010 +0200

    emuMB: default to disabled mouse button emulation for touchscreens.
    
    Because touchscreens only use one button (see EvdevProcessKeyEvent())
    EvdevMBEmuFilterEvent() never calls EvdevMBEmuEnable(..., FALSE) to
    disable emulation. This results in touchscreen devices incurring a delay
    of Emulate3Timeout (typically 50 ms.)
    
    Default to MBEMU_DISABLED for touchscreen devices (unless overwritten by
    Xorg.conf.)
    
    Signed-off-by: Oliver McFadden <oliver.mcfadden@nokia.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 99505011d124bef00acffb6ab07f6b765f5870b7
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Feb 18 19:01:51 2010 +1000

    man: fix man page formatting for option EmulateWheel.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit fd036680c210266ba535b0204cac38e503371398
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Thu Feb 11 10:08:07 2010 -0500

    config: move CWARNFLAGS from configure.ac to Makefile.am
    
    Compiler warning flags should be explicitly set in the makefile
    rather than being merged with other packages compiler flags.
    
    Signed-off-by: Gaetan Nadon <memsize@videotron.ca>

commit e81cd935cfff18d3c387eed3e8083977c19c92f0
Author: Andrej Gelenberg <andrej.gelenberg@udo.edu>
Date:   Tue Jan 12 11:22:16 2010 +0100

    Implement XSetDeviceMode request handler
    
    Implement XSetDeviceMode request handler for evdev.
    Devices with absolute axes can be switched in relative
    mode or absolute mode. Devices with relative axes
    can be switched only in relative mode. Other devices
    return BadMatch, cause they have no valuators and
    don't report motion events.
    
    New option "Mode" force devices with absolute axes
    to work in relative or absolute mode.
    
    Need xinputproto.
    
    Signed-off-by: Andrej Gelenberg <andrej.gelenberg@udo.edu>

commit 0b5844ce677a99110730ac885fc990c4b8f4bfa9
Author: Alan Coopersmith <alan.coopersmith@sun.com>
Date:   Fri Jan 15 15:10:55 2010 -0800

    Update Sun license notices to current X.Org standard form
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@sun.com>

commit d6beb16be26df65cd65eaeb146fde0d355521535
Author: Dima Kogan <dkogan@cds.caltech.edu>
Date:   Sat Dec 5 02:05:19 2009 -0800

    allow wheel emulation to work with absolute-position devices
    
    Signed-off-by: Dima Kogan <dkogan@cds.caltech.edu>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2f5a0fb6988809a91c4e6821aaed46ba27c9855c
Author: Dima Kogan <dkogan@cds.caltech.edu>
Date:   Sat Dec 5 02:08:32 2009 -0800

    removed unnecessary static declarations
    
    Signed-off-by: Dima Kogan <dkogan@cds.caltech.edu>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1b0df04abe329433658c95debdafdf1714173814
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Dec 1 15:44:39 2009 +1000

    Fix up BTN_TOUCH handling for non-button tablets.
    
    BTN_TOOL_* is treated as tool, just like before. BTN_TOUCH on the other hand
    may need to be treated as a button left press. This again requires a button
    class.
    
    Tested on an HP Touchsmart and a Wacom tablet.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2ca24a16f08095f35d5610f16e202c525b3075e9
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Dec 1 14:16:10 2009 +1000

    Only init the calibration property for absolute devices.
    
    Relative devices can't be calibrated anyway so why bother.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7b285a802b8ccddd1edcf40ab345c4a96bcdf43c
Author: David Woodhouse <dwmw2@infradead.org>
Date:   Tue Dec 1 00:14:54 2009 +0000

    Report initial calibration parameters.
    
    Where an initial calibration is provided through the Calibration option
    to the driver, it wasn't being exposed in the 'Evdev Axis Calibration'
    property. Remedy that...
    
    Signed-off-by: David Woodhouse <David.Woodhouse@intel.com>
    Acked-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f187badb71554a73bf9ca30ce75c9d166e688f03
Author: David Woodhouse <dwmw2@infradead.org>
Date:   Tue Dec 1 00:12:36 2009 +0000

    Swap axes before applying touch screen calibration.
    
    When the SwapAxes option is set, the X and Y axes in calibration should
    be labelled as the user perceives them -- not as the kernel sends them.
    
    Currently, we apply the X-axis calibration to the X-axis of the input,
    and then do the axis swapping so we've actually applied the X-axis
    calibration to what the user sees as the Y-axis.
    
    This patch changes the order of the operations, so that the axes are
    swapped before the calibration is applied.
    
    Signed-off-by: David Woodhouse <David.Woodhouse@intel.com>
    Acked-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0e9d75ba68d648f38ea5850f910867c9fc908d07
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Nov 27 14:29:52 2009 +1000

    Fix a comment, EV_CNT is available since 2.6.24
    
    Introduced in the kernel as 2.6.23-6147-g7b19ada.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3a6d27b83dbc69e42f289d7249bfa92328b69676
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Mon Nov 23 09:25:05 2009 -0500

    Makefile.am: add ChangeLog and INSTALL on MAINTAINERCLEANFILES
    
    Now that the INSTALL file is generated.
    Allows running make maintainer-clean.

commit 886e303af1434d5af8db6938e873baf399261105
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Wed Oct 28 14:41:40 2009 -0400

    INSTALL, NEWS, README or AUTHORS files are missing/incorrect #24206
    
    Automake 'foreign' option is specified in configure.ac.
    Remove from Makefile.am

commit 3d23ef4888a75b42a95e117db0811e98693f8d09
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Wed Oct 28 14:09:09 2009 -0400

    INSTALL, NEWS, README or AUTHORS files are missing/incorrect #24206
    
    Add missing INSTALL file. Use standard GNU file on building tarball
    README may have been updated
    Remove AUTHORS file as it is empty and no content available yet.
    Remove NEWS file as it is empty and no content available yet.

commit c0473e4921f3c3beec59abefb63180cba4d168df
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Mon Oct 26 12:54:20 2009 -0400

    Several driver modules do not have a ChangeLog target in Makefile.am #23814
    
    The git generated ChangeLog replaces the hand written one.
    Update configure.ac to xorg-macros level 1.3.
    Use XORG_DEFAULT_OPTIONS which replaces four XORG_* macros
    Update Makefile.am to add ChangeLog target if missing
    Remove ChangeLog from EXTRA_DIST or *CLEAN variables
    This is a pre-req for the INSTALL_CMD

commit afc9e917656508fc3277b7d39e5ab436cf0542f4
Author: Gaetan Nadon <memsize@videotron.ca>
Date:   Thu Oct 22 12:34:16 2009 -0400

    .gitignore: use common defaults with custom section # 24239
    
    Using common defaults will reduce errors and maintenance.
    Only the very small or inexistent custom section need periodic maintenance
    when the structure of the component changes. Do not edit defaults.

commit c1f16a4f59a584ab4546c2f16e20b06703042057
Author: Bartosz Brachaczek <b.brachaczek@gmail.com>
Date:   Fri Nov 13 00:18:00 2009 +1000

    Set all valuators for relative motion events (#24737)
    
    We should process all the deltas reported by a relative motion device,
    otherwise some devices such as A4Tech X-750F or similar may trigger a
    situation when the `v` array contains random values (it isn't
    initialized anywhere) and later we process them and in effect the mouse
    cursor "jumps" on the screen.
    I'm not sure why, but we also must be sure that the `first` and `last`
    variables reflect the axis map, otherwise the mouse cursor "jumps" on
    the screen when clicking mouse buttons in some rare cases reported by
    Bartek Iwaniec on Bugzilla. That's why a simple initialization of the
    `v` array with zeros isn't sufficient.
    
    X.Org Bug 24737 <http://bugs.freedesktop.org/show_bug.cgi?id=24737>
    
    Signed-off-by: Bartosz Brachaczek <b.brachaczek@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a0f7f34dc5effc5822c618bfbf3a0872669c30ad
Author: Dmitry Torokhov <dmitry.torokhov@gmail.com>
Date:   Mon Nov 2 23:11:55 2009 -0800

    Relax checks when reopening devices
    
    When checking whether we are dealing with the same device as before
    when we try to reopen it evdev should not require exact match of
    entire keymap. Users should be allowed to adjust keymaps to better
    match their hardware even after X starts. However we don't expect
    changes in [BTN_MISC, KEY_OK) range since these codes are reserved for
    mice, joysticks, tablets and so forth, so we will limit the check to
    this range.
    
    The same goes for absinfo - limits can change and it should not result
    in device being disabled.
    
    Also check the length of the data returned by ioctl and don't try to
    compare more than we were given.
    
    [peter: moved the key comparison below the led+abs comparison]
    
    Signed-off-by: Dmitry Torokhov <dtor@mail.ru>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 11669d82790fd7c94c44c0d487d3fa5e203528e9
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Nov 2 13:57:18 2009 +1000

    Fix drag-lock property handler for multiple draglock buttons.
    
    Parsing of the values was wrong. Given an input of 1 2 3 4, button 1 sets
    the lock for button 2 and button 3 sets the lock for button 4.
    
    This also means we need to return BadMatch if the property isn't a multiple
    of 2.
    
    Red Hat Bug 524428 <https://bugzilla.redhat.com/show_bug.cgi?id=524428>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9cbffda91009001ab6aab84efd2ffb4e35561958
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Oct 22 15:13:02 2009 +1000

    Forward keycodes > 255
    
    The server doesn't handle them yet but eventually it should learn.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 59056e656c6475816ab45b2798bd4d4466482f6a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Oct 13 14:51:49 2009 +1000

    Remove the reopen timer logic.
    
    This logic was needed in older kernels that sometimes gave error messages
    after coming back from resume (2.6.27 release kernels). I haven't seen any
    log files that needed this reopen timer in a long time, suggesting that need
    for it is gone.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit aa6399fdb9ec970e205b1efb336338ac870d2bcf
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Oct 19 11:40:24 2009 +1000

    evdev 2.3.0
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1d86f5dec16beaf9391f320d7702cc59e9486bf4
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Oct 15 11:13:47 2009 +1000

    Convert IgnoreAbsolute/RelativeAxes options into trinary state.
    
    The Xen Virtual Pointer device exports both absolute and relative axes from
    the kernel device. Which coordinates are used is a run-time decision and
    depends on the host-specific configuration.
    0a3657d2ee62f4086e9687218cb33835ba61a0b3 broke these devices, and they are
    now unusable out-of-the-box as there is no configuration to cover them.
    
    This patch converts the IgnoreAbsoluteAxes and the IgnoreRelativeAxes
    configuration options into a trinary state.
    1. If unset, configure the device as normal by trying to guess the right
       axis setup.
    2. If set to true, ignore the specific axis type completely (except for
       wheel events).
    3. If set to false, explicitly 'unignore' the axis type, alwas configuring
       it if it is present on the device. This setting introduces seemingly
       buggy behaviour (see Bug 21832)
    
    1. and 2. replicate the current driver behaviour.
    The result of 3. is that is that if a device has absolute axes and the
    options set to false, both axes will be initialized (absolute last to get
    clipping right). This requires axis labelling priorty to switch from
    relative first to absolute first.
    
    Relative events are forwarded into the server through the absolute axes,
    the server scales this into the device absolute range and everyone is happy.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit fbd86e2530f3f69f397d3bae9ad87cf8e2d14221
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Oct 15 10:52:27 2009 +1000

    Fix copy/paste typo in comment.

commit 9ea1f9a6954c8dceee17076f10ff0f82f042de88
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Oct 13 10:49:46 2009 +1000

    Fix typo, use uppercase like the other messages
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 57b54ee3995f2f678ef359e7663cad517a8b2433
Author: Oliver McFadden <oliver.mcfadden@nokia.com>
Date:   Mon Oct 12 16:32:51 2009 +0300

    evdev: Support the "Calibration" string option.
    
    Originally based on a patch from Daniel Stone, this commit allows for
    the calibration factors to be set either from Xorg.conf or via HAL.
    
    Previously the only way was via the properties interface.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f2dc0681febd297d95dae7c9e3ae19b771af8420
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Oct 6 19:09:33 2009 +1000

    Finalize the middle button emulation when a read error occurs (#23048)
    
    If a read error occurs, remove the block and wakeup handlers for middle
    mouse button emulation. Otherwise, they'll still be around after the device
    has been reopened and overwritten with the new ones created by EvdevOn. Once
    this happened, future removal of the device can lead to a server crash.
    
    X.Org Bug 23048 <http://bugs.freedesktop.org/show_bug.cgi?id=23048>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3fa49dfcab9081787840ed6bb9451cb73f65e248
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Oct 8 14:26:41 2009 +1000

    evdev 2.2.99.2
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 941391ca34a7537542f0bb894fc0f02e200165b4
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Sep 30 12:05:17 2009 +1000

    Add explicit options to ignore relative or absolute axes.
    
    The X server cannot deal with devices that have both relative and absolute
    axes. Evdev tries to guess wich axes to ignore given the device type and
    disables absolute axes for mice and relative axes for tablets, touchscreens
    and touchpad. This guess is sometimes wrong and causes exitus felis
    domesticae parvulae.
    
    Two new configuration options are provided to explicitly allow ignoring an
    axis. Mouse wheel axes are exempt and will work even if relative axes are
    ignored.  No property, this option must be set in the configuration.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Daniel Stone <daniel@fooishbar.org>

commit 2144f7d83426136cc1a9de2fafb302683645c6da
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Sep 30 11:49:21 2009 +1000

    Remove unused has_xy.
    
    has_xy is only ever set, but not used for anything else.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 61b4e88e01f32e976f85e7970a7f5b21fcd84f97
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Sep 21 16:56:28 2009 +1000

    emuWheel: fix signed/unsigned screwup
    
    This patch fixes wheel emulation on buttons other than 0.
    
    Reported-by: Andy Neitzke
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9ee70943ec304b08b8e4651c512a8e65fa13cc9c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Sep 11 09:57:22 2009 +1000

    Require xorg-macros 1.3 and XORG_DEFAULT_OPTIONS
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 415b6ffa958e3103eeb52af4ccd881497169eed4
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Aug 20 11:02:31 2009 +1000

    Only take the driver-internal button mapping to count buttons (#23405)
    
    Regression:
        If a user has multiple buttons mapped to the same button number, the
        number of buttons counted is set to a wrong value.  e.g. a button
        mapping of 1 1 1 for a mouse with three buttons would only initialize 1
        button to the X server.
    
        In the future, the user cannot change this button mapping as the server
        only knows about one button.
    
    The user-supplied button map (option ButtonMapping) shouldn't matter when
    counting the buttons. Only the driver-internal mapping (BTN_0 -> button 1,
    etc.) matters.
    
    X.Org Bug 23405 <http://bugs.freedesktop.org/show_bug.cgi?id=23405>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f4ba2bd785b25fd522967abd7775925d5fded70f
Author: Dima Kogan <dkogan@secretsauce.net>
Date:   Sun Aug 16 23:11:50 2009 -0700

    Allow 0 as wheel emulation button for unconditional scrolling (#20529)
    
    If wheel emulation is on and the emulation button is 0, then any x/y motion
    of the device is converted into wheel events. The devices becomes a
    scrolling-only device.
    
    Signed-off-by: Dima Kogan <dkogan@cds.caltech.edu>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2e5f68754fd5bc4e6b7fa5b95bdd30e2bb4e57fb
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Aug 17 09:41:11 2009 +1000

    Restrict wheel emulation to a single axis at a time.
    
    Wheel emulation works for both horizontal and vertical axes. Thus, if a
    device doesn't move in perfect straight line, scroll events build up on the
    respective other axis.
    
    In some clients, scroll wheel events have specific meanings other than
    scrolling (e.g. mplayer). In these clients, erroneous scrolling events come
    at a high cost.
    
    Thus, if a scroll wheel event is generated for one axis, reset the inertia
    of the other axis to 0, avoiding the buildup of these erroneous scrolling
    events.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8fdb2abb6fe0426cbbfeead2c187092a56792557
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Aug 14 12:59:27 2009 +1000

    man: fix documentation for EVDEV_PROP_WHEEL_BUTTON
    
    0 doesn't disable it, it's still treated like a button number. copy/paste
    error.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ca0fb396f1a4b87be9f8aa7ad066e0b469c9075d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Aug 14 11:00:12 2009 +1000

    evdev 2.2.99.1

commit 7967677789e3ee24733b3514e1ae7a8e12bbc2b5
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Aug 14 09:05:40 2009 +1000

    Treat tablets (BTN_TOOL_PEN devices) differently from touchpads.
    
    The previous checks for BTN_TOOL_FINGER and BTN_TOUCH reported false
    positives for touchpads for most popular tablets.
    As a result, their events were converted to relative events.
    
    Add a new flag EVDEV_TABLET pending presence of BTN_TOOL_PEN and ignore the
    touchpad special casing to report the events as-is.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 36064dca9097df896b4b1b49c9c68775f1728846
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Aug 13 10:27:16 2009 +1000

    Add EvdevPostButtonEvent API to immediately post a button event (#23269)
    
    The wheel emulation code needs this API. When the timer expires, the event
    must be posted immediately, not enqueued onto the internal event queue.
    Otherwise, the emulated middle button press is enqueued only and no event is
    sent until the next physical event (and its EV_SYN) arrives.
    
    Since the timer is triggered outside of the SIGIO and SIGIO is blocked
    during this period anyway, we could also just enqueue the event and flush by
    simulating an EV_SYN. It's easier this way though.
    
    X.Org Bug 23269 <http://bugs.freedesktop.org/show_bug.cgi?id=23269>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Oliver McFadden <oliver.mcfadden@nokia.com>

commit 8bf93709cbcf9f041cd177e929ff46adce8a6b79
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Aug 13 10:16:18 2009 +1000

    Rename parts of the Post API to a Queue API.
    
    Button and key events aren't posted from EvdevPost*Event, they are simply
    enqueued onto the evdev-internal event queue until the next EV_SYN arrives.
    Rename those interfaces from EvdevPost* to EvdevQueue* and leave only those
    that actually post to the server with a matching "*Post*" name.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Oliver McFadden <oliver.mcfadden@nokia.com>

commit 37373a223b2aeef7041c9c0bb99be613789a3125
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Aug 13 10:26:33 2009 +1000

    comment typo fix
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d764dded18c47cec009babc075f2324cba1781ce
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Aug 5 18:57:30 2009 +1000

    Skip check for EVDEV_RELATIVE_EVENTS for wheel events.
    
    This patch fixes a regression introduced with 1f641d75e.
    Wheel axis events are posted as button clicks, a device may have no relative
    axes but it does need to post these button clicks.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f352598e45be86f9e24d9dba88c657f03f3b168e
Author: Michael Witten <mfwitten@gmail.com>
Date:   Tue Aug 4 03:11:49 2009 -0500

    evdev.c: Fix/improve discrimination of rel/abs axes
    
    The relevant comment from evdev.c:
    
    We don't allow relative and absolute axes on the same device. The
    reason is that some devices (MS Optical Desktop 2000) register both
    rel and abs axes for x/y.
    
    The abs axes register min/max; this min/max then also applies to the
    relative device (the mouse) and caps it at 0..255 for both axes.
    So, unless you have a small screen, you won't be enjoying it much;
    consequently, absolute axes are generally ignored.
    
    However, currenly only a device with absolute axes can be registered
    as a touch{pad,screen}. Thus, given such a device, absolute axes are
    used and relative axes are ignored.
    
    The code for initializing abs/rel axes has been abstracted out into
    3 functions, so that initialization in EvdevInit(device) is as easy
    as:
    
        if (pEvdev->flags & (EVDEV_TOUCHPAD | EVDEV_TOUCHSCREEN))
            EvdevInitTouchDevice(device, pEvdev);
        else if (pEvdev->flags & EVDEV_RELATIVE_EVENTS)
            EvdevInitRelClass(device, pEvdev);
        else if (pEvdev->flags & EVDEV_ABSOLUTE_EVENTS)
            EvdevInitAbsClass(device, pEvdev);
    
    Signed-off-by: Michael Witten <mfwitten@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 69d6ff3e01263ce2d52ed18b08f054bf3fdb923c
Author: Oliver McFadden <oliver.mcfadden@nokia.com>
Date:   Sun Aug 2 12:03:04 2009 +0300

    evdev: Use the EvdevPost...Event() functions in the emulation code.
    
    This is similar to commit 1f641d75edba7394201c1c53938215bae696791b.
    
    It provides the same functionality of queuing the (in this case
    emulated) events and waiting until an EV_SYN synchronization event is
    received before posting them to the server.
    
    This preserves the order of events (both real and emulated) and ensures
    that MotionNotify events will always be posted first. It also unifies
    the event posting into a few small functions which improves
    maintainability.
    
    From this point on, you should never use the xf86Post...Event()
    functions in new code, but rather the EvdevPost...Event() versions.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 6f4634111a83808bc52e7e53733cf2d3bab0cccd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jul 30 09:27:27 2009 +1000

    Evdev doesn't require inputproto.
    
    None of the inputproto headers seem to be included anywhere.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1f641d75edba7394201c1c53938215bae696791b
Author: Oliver McFadden <oliver.mcfadden@nokia.com>
Date:   Thu Jul 23 13:19:49 2009 +0300

    evdev: Only send the events at synchronization time.
    
    Instead of just posting the button/key press/release events to the
    server as soon as they arrive, add them to an internal queue and post
    them once we receive an EV_SYN synchronization event.
    
    The motion events are always sent first, followed by the queued events.
    There will be one motion event and possibly many queued button/key
    events posted every EV_SYN event.
    
    Note that the size of the event queue (EVDEV_MAXQUEUE) is arbitrary and
    you may change it. If we receive more events than the queue can handle,
    those events are dropped and a warning message printed.
    
    Tested on my Lenovo T400 using evdev for all input devices; keyboard,
    touchpad, and trackpoint.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2994825665790dc8e35b2944e0d411f3cc9f76fd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jul 20 14:52:34 2009 +1000

    Don't register middle mouse button emulation handlers for keyboards.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9bfd9e8a3683f14860149ae9f842e88828cc0960
Author: Oliver McFadden <oliver.mcfadden@nokia.com>
Date:   Thu Jul 16 18:25:37 2009 +0300

    Coverity Prevent: NO_EFFECT in EvdevWheelEmuSetProperty:
    
    Event unsigned_compare: Comparing unsigned less than zero is never true. "pEvdev->emulateWheel.timeout < 0UL"
    342  	            if (pEvdev->emulateWheel.timeout < 0)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit dcca28a59ce0a2f8a06c559eed493ca43afc20cb
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Apr 29 18:29:58 2009 +1000

    Count REL_DIAL as a scrollwheel during EvdevProbe (#21457)
    
    The Griffin Powermate only has a single axis (REL_DIAL). This axis is
    posted as horizontal scroll wheel, so we need to ensure the scroll wheel
    setup (including ensuring that enough buttons are available) is triggered
    accordingly.
    
    X.Org Bug 21457 <http://bugs.freedesktop.org/show_bug.cgi?id=21457>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit db8b1ca5cffbc48f7d9c5c166489c714ac92ea86
Author: Asbj�rn Sannes <ace@sannes.org>
Date:   Wed Jul 1 09:51:12 2009 +0200

    evdev: Fix spelling of property in man page to match source code. #22571
    
    Signed-off-by: Asbj�rn Sannes <ace@sannes.org>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8cc0d0f285261b0f26d22b5b4eca9ccbd1beeb93
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jun 26 09:59:04 2009 +1000

    Fix absolute axis labelling - mapping must be initialized before the labels.
    
    88eedea281a710008a82f1e6af4bdffd19477f46 added axis labelling to the
    valuator initialization. This requires the axis mapping to be established
    before the absolute axis labels are initialized.
    
    88eedea did this for relative axes, but missed out on the absolute ones. As
    a result, all abs. labels were initialized to "None".
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit aa1609285dfa51570f74671a9f4240bccc1516c2
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jun 26 09:42:36 2009 +1000

    Message "found absolute touchpad" also applies to tablets - fix.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b07ab6ea97b779b26e7ae8326528c262cc9907a1
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jun 26 09:37:29 2009 +1000

    If a device fails to initialize relative axes, init the abs. axes instead.
    
    Some devices have relative axes that don't count (scroll wheels). In this
    case, don't claim we've initialized relative axes, continue with the
    absolute axes instead.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7bc48c666d702e649dc529b5d928b6a8549514c3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jun 23 15:43:16 2009 +1000

    Fix wrong axis label index causing OOB reads/writes.
    
    The atoms array is filled with each axis atom in mapping order (i.e. after
    the driver mapping has been applied). 'axis' OTOH is from 0 to ABS_MAX.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 880ad1e19afd83ac115948b67d4049e16cb12df0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jun 23 14:48:17 2009 +1000

    Initialize the axis labels to 0, not "misc".
    
    If we don't know what an axis label is, then don't initialize it. None is a
    valid label.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 6ab23e4519ed4ce07b745c573ddf544a2a1ee1b2
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jun 18 16:15:16 2009 +1000

    Add missing checks for ABI_XINPUT_VERSION 7.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 88eedea281a710008a82f1e6af4bdffd19477f46
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jun 18 15:33:33 2009 +1000

    Cope with ABI_XINPUT_VERSION 7 - requires button + axes labels.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9a5a4fed3acae87c89694a9ef8bf905ca0d6a6dd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jun 18 15:15:57 2009 +1000

    Split axes and button labels into separate function.
    
    We'll re-use this bit very soon.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0a3657d2ee62f4086e9687218cb33835ba61a0b3
Author: Derek Upham <sand@blarg.net>
Date:   Thu May 21 00:15:28 2009 -0700

    evdev: Prevent driver from processing motion events that it has not configured. #21832
    
    The current implementation initializes itself to support relative
    motion events, or absolute motion events, or neither.  But the
    event-handling code attempts to process all events, no matter what the
    initialization was.  This patch reproduces the flag tests found during
    init, to skip events that the driver doesn't support.
    
    Signed-off-by: Derek Upham <sand@blarg.net>
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit dc2191285e799be891787e1f64d10c1cba271240
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 21 13:30:10 2009 +1000

    Deal with BTN_3 to BTN_9 buttons.
    
    These buttons were previously mapped to 0, i.e. inactive. This patch
    slightly improves things in that the buttons are now mapped to 8+.
    
    Devices that have both BTN_3 and BTN_SIDE (or a similar pair in that
    sequence) have both mapped to the same button number though.
    Devices that have BTN_LEFT, BTN_0, BTN_3 and BTN_SIDE have the last three
    mapped to 8 (and their followers have double-mappings too). We'll fix that
    once we actually see devices affected by this.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 255b9f6bbf374a315750019c6fadc5f82fb7d41d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 21 10:23:37 2009 +1000

    Only initialize the number of buttons we actually have.
    
    This takes into account driver-configured button mappings, i.e. if device
    with one button has this button mapped to 25 through the ButtonMapping
    option, the X server will think the device has result 25 buttons.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit aa117d49a5139bcc453e6ab022b67347464a8acd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu May 21 09:51:57 2009 +1000

    Rename pEvdev->buttons to pEvdev->num_buttons for clarity.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b358f1eb3a4ef8fdee099114d6c70d6ea06eba95
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 20 11:57:01 2009 +1000

    Ensure enough buttons are advertised to pass the button mapping.
    
    Some buttons are mapped to higher button numbers. For example, BTN_0 is
    posted as button 8 if BTN_LEFT is present. On top of that, the
    driver-specific button mapping may map the button to something else again.
    We need to take these mappings into account when counting the number of
    buttons on the device.
    
    Example: A device with BTN_LEFT and BTN_0 and a mapping from 1 -> 7 and 8 ->
    2.
    
    BTN_LEFT is mapped to 1. 1 is mapped to 7. num_buttons is 7.
    BTN_0 is mapped to 8. 8 is mapped to 2. num_buttons remains 7.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 33cc112ca1af377a85cfeb05dfb72f07d3850a95
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 20 11:47:37 2009 +1000

    Up the number of button labels atoms to EVDEV_MAXBUTTONS.
    
    Button labels would smash memory if the device had less than 4 buttons and
    did not advertise a wheel event. In this case the hard-coded wheel button
    labels would write past the atoms[] boundary.
    
    Potential memory smash if a device had a BTN_LEFT and BTN_0, since the
    latter would map to 8, regardless of the the number of actual buttons
    (same with BTN_MIDDLE and BTN_1 or BTN_RIGHT and BTN_2).
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3c43d880f13725a04fcd7c0c8d5978a36208e373
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 20 11:42:35 2009 +1000

    Only label axes and buttons if the device has axes or buttons.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 54628989356793828fcbb5f62a091b962c7da4f9
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed May 13 12:51:52 2009 +1000

    Use xf86DisableDevice instead of the DIX' DisableDevice.
    
    DisableDevice has changed API in xi2, xf86DisableDevice hasn't. So let's use
    this one so we can have one version for master and xi2.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9243d338d1de7df8afb1e254590cd4bf84888c7e
Author: Dan Nicholson <dbn.lists@gmail.com>
Date:   Sun May 10 08:29:21 2009 -0700

    Fix copy-paste error when probing type name
    
    A minor copy and paste error was introduced in 71e9a69e leaving an "if"
    where an "else if" should be. Without this, any device configured as
    XI_TOUCHPAD or XI_TABLET will end up having the type_name reset to
    either XI_TOUCHSCREEN or XI_MOUSE.
    
    Signed-off-by: Dan Nicholson <dbn.lists@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 71e9a69ed68257e5ded26c062a9797de571bb880
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Apr 29 18:03:18 2009 +1000

    Revamp the whole "has_axes" definition.
    
    Since we can now deal with multiple axes, etc. we might as well print it
    properly.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 220e2dfb8f6aa08bd5f59e81c6883c057b945721
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Apr 16 13:23:50 2009 +1000

    Print read errors as X_NONE to avoid mallocs in the server.
    
    Messages of type X_NONE are just passed down to the log files, everything else
    gets the (EE) or (II) prefixed. Since this mallocs, we can't use it in the
    signal handler.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ddc126637404cb3d9356b7698779dcd8849f8718
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Apr 16 12:01:03 2009 +1000

    Pre-allocate the reopen timer so we don't allocate during sigio handling.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 98ecb5233bb3b899bd696a90d2733c6a345676dd
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 6 10:22:25 2009 +1000

    Trigger read error handling if len is <= 0.
    
    Red Hat Bug 494245 <https://bugzilla.redhat.com/show_bug.cgi?id=494245>
    
    Reported-by: David Woodhouse <dwmw2@infradead.org>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 92ca3dc2e759759545c0e0adea4277b3bddb05e5
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 26 13:40:07 2009 +1000

    Fix wrong reference to axis and button label atom list.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3fa28c8acd3aad054f9c74e94c1411654d709dca
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 26 10:11:26 2009 +1000

    Remove test/ directory.
    
    This shouldn't really be part of the driver source, it's better to just have
    it as a separate repository. Code has moved to
    git://people.freedesktop.org/~whot/testdevices.git
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d9809d7edd2be714a15115b990286554e2979fb6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Mar 17 14:08:29 2009 +1000

    Fix jumpy touchpads by updating old_vals only when reported by the device.
    
    Remember whether ABS_X or ABS_Y were reported before the SYN event and only
    update the old_vals[0, 1] if we got data for them.
    Touchpads that reported pressure data before x/y would otherwise update
    old_x/y with bogus values, leading to jumps when the first x/y coordinates
    were actually reported.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b11439a1763b5f210460b492dd4f47e973f90a3a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Mar 17 13:25:58 2009 +1000

    If we have a touchpad, print so, don't claim we're configuring a tablet.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 740dc202f735106532dce581deabe2b95c52759f
Author: Jeremy Jay <dinkumator@gmail.com>
Date:   Mon Mar 16 23:19:54 2009 -0400

    make sure to clear all axis_map entries
    
    don't use uninitialized axis_map entries, ie axis_map[ABS_PRESSURE]
    
    Signed-off-by: Jeremy Jay <dinkumator@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7ac0c4456dc0846f7e09f334a26f9536e20065df
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Mar 17 08:02:00 2009 +1000

    Assume touchscreen/touchpad if we have _either_ ABS_PRESSURE or BTN_TOUCH
    
    Touchpads have pressure or touch and also BTN_TOOL_FINGER.
    Touchscreens have either pressure or touch, but no finger.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b4f6ab126dfc897759559aae7ae32fbc0efe24d8
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 13 13:40:16 2009 +1000

    Move keymap/modifier initialization behind the ABI < 5 ifdefs.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a3ea979c2b70d166d62422b4ba450ce2910389c3
Author: Jeremy Jay <dinkumator@gmail.com>
Date:   Mon Mar 16 08:36:53 2009 +1000

    Set "rel" when converting absolute touchpad coordinates to relative (#20661)
    
    We unset "abs" and convert to relative, but never set "rel" so the events
    don't get posted. This bit got broken in 43dd2a959243877.
    
    X.Org Bug 20661 <http://bugs.freedesktop.org/show_bug.cgi?id=20661>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a7fb654a68a26ad5f019a902312c6b94dbe9c3ea
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Mar 10 15:17:53 2009 +1000

    Restore repeat-filtering for server 1.5 and earlier.
    
    Letting the server deal with key repeats is fine if we have server 1.6. For
    earlier servers, we need to pass on the repeat events (except for modifier
    keys).
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Tested-by: Marty Jack <martyj19@comcast.net>

commit 3f06825a446e317485c2e2d1880c1886684d8742
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 9 09:26:51 2009 +1000

    Bump to 2.2.99.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 31853c39bfae7bb1035485407fd245cd11337d4f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 9 09:29:48 2009 +1000

    Define MAX_VALUATORS if it's missing to allow for builds against 1.5.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2c49e21a815632fc1addd04dde96592237757a2e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 9 09:05:10 2009 +1000

    Check button label before fetching the Atom from the server.  (#20524)
    
    The server doesn't like NULL names, so don't call XIGetKnownProperty for
    labels that don't exist.
    
    X.Org Bug 20524 <http://bugs.freedesktop.org/show_bug.cgi?id=20524>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Tested-by: Peter Henriksson

commit 4361b3efa0da5e85da7f0506c81dba31e59dc897
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 6 08:13:36 2009 +1000

    Fix duplicate wheel button up mapping.
    
    Reported by Simon Thum.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Simon Thum <simon.thum@gmx.de>

commit 281a7b4b88015c768639b7ae960b62f3539f012b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 2 16:27:47 2009 +1000

    evdev 2.1.99.1
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 051cb8b528f6eddddccee44842bcb2152ed0e418
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Feb 26 12:14:20 2009 +1000

    Add support for button labelling.
    
    Buttons 4/5 and 6/7 are hardcoded for wheel buttons.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1abcc881715327614e248e9047c5fbd29a945c03
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Feb 26 10:48:06 2009 +1000

    Rename prop_label to prop_axis_label.

commit c89bbf80be65eb9d0d20871761d22c6d6d76708b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Feb 26 12:14:03 2009 +1000

    Don't double-assign the UKNOWN axis label.
    
    All labels default to unknown anyway.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 178435832f5f6988e58fddc4ffe82ddc032d9dce
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Feb 26 12:09:33 2009 +1000

    If scrollwheels are found, bump the button number by 4 (or up to 7).
    
    Scrollwheel data is always posted as buttons, so we need to advertise at least
    enough buttons to accommodate for 6/7 (horizontal wheel).
    
    Note that this may mean that if you have a device that has scroll wheels and
    axes, but no buttons, it may be interpreted as a mouse.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c9cab83bac32275f6851d2616bb749b3b2621ed6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 24 11:32:40 2009 +1000

    Ignore REL_WHEEL, REL_HWHEEL and REL_DIAL during axis initialisation.
    
    We don't post the events for them anyway, so lets ignore them completely.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 43dd2a959243877c1628a08b4fc6c07c9ae6bac0
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 24 10:36:41 2009 +1000

    Pass on all relative events, not just x/y.
    
    9620fe776 added generic axes support for relativ values, but values from such
    axes didn't get passed on to the server. Fix this.
    
    Note that wheel events are not posted as motion events.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7977947e0df6ea6379dab76805b06be6bdd71947
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Feb 24 10:08:22 2009 +1000

    Reduce the number of read calls in ReadInput.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit 11a56d4a176a2c5b2f8794147d4bafd88477b80b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 24 09:39:01 2009 +1000

    Split ReadInput into ReadInput and ProcessEvent.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 7b0f613c7f1462fc36f1e13968d96e8b8a559be6
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Feb 24 09:34:26 2009 +1000

    Move relative motion and other magic up to EV_SYN processing.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Adam Jackson <ajax@redhat.com>

commit 75af278861dcd96124544d3c2889028578708317
Author: Adam Jackson <ajax@redhat.com>
Date:   Mon Feb 23 16:01:14 2009 -0500

    Open with O_NONBLOCK, and simplify EvdevReadInput to match.
    
    xf86WaitForInput() would call select() with zero timeout to discover if
    more input was ready.  But we know that's always true at least once,
    since we're only ever called from the sigio handler (if silken is
    active) or from the main loop (if it's not and we selected readable).
    With nonblocking IO we can just spin around until we hit EAGAIN, which
    gets us down to n+1 syscalls per event instead of 2n.

commit 4fd9cd2ea81607c17eb39baaad24f09dd55995f2
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Feb 19 10:02:49 2009 +1000

    Revert "Remove useless include directive."
    
    Necessary for builds against 1.6, but let's at least get rid of XKB defines.
    
    This reverts commit aa5dfa1d6ae374479d39f1394b85660e6b6bb881.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 12c287df894c88a1b2badf105ef625c7c67f334d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Feb 18 09:30:17 2009 +1000

    Label axes conditional on actual support.
    
    Server 1.6 has device properties, but not axis labels.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9f1b9aa6eb81087b3df12184eafb104c0e745f41
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Feb 18 09:04:12 2009 +1000

    Accommodate for holes in the ABS label defines.
    
    abs_labels[] has to be aligned with the defines in linux/input.h, but the
    latter does not have continuous range. Pad the holes with
    AXIS_LABEL_PROP_ABS_MISC.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit acb1d557e216d7fa58ef8dbf3182e6604888ae2a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 17 15:08:03 2009 +1000

    Add support for arbitrary relative axis labels.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 6a1f8f463d28c263a73b81b92d9d52a6cd3873cb
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 17 14:54:49 2009 +1000

    Remove superfluous (and duplicate) call to xf86MotionHistoryAllocate.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9620fe7765b340213a552b5656d9d10bbbefd4cb
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 17 14:53:51 2009 +1000

    Add generic axis support for relative axes.
    
    Just query the kernel what axes we actually have, rather than hard-coding x/y.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a1714cac5242e5f8320ed7212efca481351355a2
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 17 14:42:19 2009 +1000

    Add dynamic axis labelling for absolute devices.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5a99ef7ed21ff879b6c55027590733bc7a9c6742
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 16 15:11:20 2009 +1000

    remove duplicate (code > 255) check.

commit 3b22e4703fa712ddb6d14d3a847ecfeac27520b4
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 16 14:48:04 2009 +1000

    man: list the options and properties in alphabetical order.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0de20a8f1b9f80b33081cea20444a05a745cb95e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 16 14:40:45 2009 +1000

    man: Fix two minor typos in man page.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 978384ede7b0832fef8a399efbc3050bb2f212f7
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 16 14:07:30 2009 +1000

    Swap axes after scaling, not before.
    
    If we swap before scaling, we scale with the wrong coordinate range.
    
    Reported by Matt Helsley.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit df7ff12ed230009de895107c40de8f457879d66b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 16 12:00:52 2009 +1000

    CacheCompare before probing the device.
    
    Saves a few duplicate ioctls.
    
    Suggested by Matt Helsley.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit dd2c89ac93535b833ee79e459410f4679c060774
Author: Matt Helsley <matt.helsley@gmail.com>
Date:   Mon Feb 16 11:18:50 2009 +1000

    General axis valuator support.
    
    Instead of x/y and pressure, support any absolute axis that is reported on the
    device. Note that there are still locations that special-case X and Y.
    
    Minor modifications by Peter Hutterer.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 4616c79f6cc6d81c1d9d27efa05ffaf51d521d2b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 16 11:15:25 2009 +1000

    Change cached bitmasks from long to unsigned long.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a31170718d098fd7ce42cf4f6e457a713e39a0c1
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 16 10:48:58 2009 +1000

    Remove unused 'screen' variable from the EvdevRec.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 95099cb0368d76ee139f1442253f26f68d493df9
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 16 10:43:36 2009 +1000

    Log which EVIOCGABS ioctl failed.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c58bae0b77b9e39ab341af994648ca22867271a2
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 16 12:05:45 2009 +1000

    Remove superfluous motion history allocation.
    
    The motion history buffer is allocated during InitValuatorClassDeviceStruct
    anyway.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 32242871f7001e7e995d501a32f350120bad2fd6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 16 08:51:22 2009 +1000

    Remove duplicate MB emu finalization.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit aa5dfa1d6ae374479d39f1394b85660e6b6bb881
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Feb 13 16:24:36 2009 +1000

    Remove useless include directive.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2a6c1d7a605e11189e4539db84b1c4da5707dbc6
Author: Bryce Harrington <bryce@bryceharrington.org>
Date:   Thu Feb 12 17:52:43 2009 -0800

    Add descriptive messages for device-has-changed errs
    
    As can be seen in e.g. bugs 19819 & 20025, it can be unclear what
    exactly caused a given "Device has changed - disabled" error.  This
    patch adds some more specific messages to give a better clue on what
    exactly was seen to have changed.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0f0743e3cfc2f7d288dfec3fba9bc093cbedf537
Author: Dan Nicholson <dbn.lists@gmail.com>
Date:   Mon Feb 2 22:35:20 2009 -0800

    Really fix distcheck
    
    distcheck has an annoying feature where it checks that all files install
    under $prefix. Unfortunately, this conflicts with the desire to install
    headers to the SDK directory. Workaround by passing --with-sdkdir during
    distcheck.
    
    Signed-off-by: Dan Nicholson <dbn.lists@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 095766ebb3afafc4906cb29e22d996dbcd773ad8
Author: Paulo Cesar Pereira de Andrade <pcpa@mandriva.com.br>
Date:   Mon Feb 2 19:47:50 2009 -0200

    Janitor: make distcheck, .gitignore.
    
    Remove non toplevel .gitignore and .cvsignore files.
      The "make distcheck correction" for $(sdkdir) probably has a better
    approach using a "*-hook:" target, or possibly making $sdkdir a
    configure time option that could be set with DISTCHECK_CONFIGURE_FLAGS.

commit 0dbb88c52b057cfdff6116060060841e4fc4abb5
Author: Julien Plissonneau Duquene <julien.plissonneau.duquene@savoirfairelinux.com>
Date:   Mon Feb 2 10:46:52 2009 -0500

    EvdevCacheCompare: ignore changes in current device position
    
    Input devices (especially touchscreens) were disabled when switching
    virtual console back to X because EvdevCacheCompare() thought the device
    was substituted by another while away from X. Actually only the current
    position reported by the device changed from what was in the cache. Fixed
    by ignoring the current position in the comparison.
    
    Fixes bug #19819.
    
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c9281567024ef1e94f2da42f0d701ed69728c355
Author: Peter Breitenlohner <peb@mppmu.mpg.de>
Date:   Fri Nov 21 21:57:41 2008 +0100

    fix manpage formatting
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 07f40a04df28e9ee6318411beb71eedc7cd6e288
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 2 11:00:30 2009 +1000

    Protect against zero-sized property values. #19882
    
    X.Org Bug 19882 <http://bugs.freedesktop.org/show_bug.cgi?id=19882>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e260993b6af0c463bd593a3192d2ba4ee6912fc9
Author: Alan Coopersmith <alan.coopersmith@sun.com>
Date:   Fri Jan 30 20:18:50 2009 -0800

    Add README with pointers to mailing list, bugzilla & git repos

commit dc72e6d8aecbc60900bb3b72978d63495f3f6954
Author: Dan Nicholson <dbn.lists@gmail.com>
Date:   Thu Jan 22 10:15:15 2009 -0800

    Stop hammering XKB defaults
    
    With the new InitKeyboardDeviceStruct, we can just pass the RMLVO we
    want without setting the defaults first.
    
    Signed-off-by: Dan Nicholson <dbn.lists@gmail.com>
    Signed-off-by: Daniel Stone <daniel@fooishbar.org>

commit 1906e4d5c112c25c9d7a736d4924d1005267aba7
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jan 22 09:44:15 2009 +1100

    Reshuffle property initialization.
    
    We don't need axis calibration, etc. on keyboards, so let's do it
    conditionally on actually having axes.
    
    Reported by Simon Thum.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3047c25db24becf475b45d13e03a8badd58dcde6
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jan 22 09:19:16 2009 +1100

    Deal with XINPUT ABI 5.
    
    Some XKB stuff has been removed, so let's deal with it.

commit c158cf2b64034a49e1c95549603b684e21e7511a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jan 21 16:32:27 2009 +1100

    Require XKB.
    
    Welcome to the future.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit dae1a78a521fa2e9fe7d058a66ae9ef7ea5d9471
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jan 20 09:45:44 2009 +1100

    Add automatic axis labeling.
    
    Since we don't support anything but REL/ABS x/y and sometimes pressure this is
    bordering on pointlessness, but once the year of the Linux desktop comes
    around this will be really handy. Or so.
    
    Also, we don't allow changing axis labels, but should eventually rearrange
    them if swapaxis is on.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 263bf04a9d350dddd796f3a21c7b1749647be91c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jan 20 11:46:05 2009 +1100

    Don't print xkb options twice to the log file.
    
    xf86SetStrOption already prints with X_CONFIG anyway, no need to do it again.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c035f3d0f58698d0f1dbeb1be7ad00f0787d3292
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jan 20 09:44:49 2009 +1100

    Register the property handler AFTER setting all the properties.
    
    Otherwise, we add a new property based on a setting in pEvdev, which triggers
    the update handler to change the setting in pEvdev based on the property.
    Truly pointless.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit a7e8af65fca9c38a8c0c24ffc660c06c8d4a0b9b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jan 19 21:23:34 2009 +1100

    Test for pressure BEFORE using has_pressure.

commit 0592d97fbb5a1241ee79397ce9203346d050a9f9
Author: Michael Chapman <mike@very.puzzling.org>
Date:   Fri Jan 9 19:07:10 2009 +1100

    Disable middle mouse button emulation when a middle mouse button event is registered
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 4dfd86b2201b2b19761a1abb3c580cecf0060224
Author: Matt Helsley <matt.helsley@gmail.com>
Date:   Sun Jan 11 18:36:59 2009 -0800

    Fix FOO_MAX off-by-one
    
    In linux/input.h each section's (e.g. ABS) FOO_MAX is the maximum FOO
    value. Recent kernels define FOO_CNT as the maximum number of FOO there
    will ever be. Hence using FOO_MAX to size the bit vectors representing
    the capabilities of an evdev device is off by one.
    
    Define FOO_CNT values for use with Linux kernels which lack them. Use
    FOO_CNT whenever we need to know the number of bits needed -- usually to
    calculate the number of longs needed.
    
    When iterating over the values FOO_MAX still seems appropriate however
    the loop test should include FOO_MAX rather than skip it.
    
    Signed-off-by: Matt Helsley <matt.helsley@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d3fd42d8644310abcae23bbf534f8c445296bcb7
Author: Matt Helsley <matt.helsley@gmail.com>
Date:   Sun Jan 11 18:04:40 2009 -0800

    rename NBITS to NLONGS to reflect its actual meaning
    
    NBITS really convers the number of bits passed as its argument
    into a number of longs. This is somewhat atypical of many
    function-like-macro names. Rename it to NLONGS.
    
    Signed-off-by: Matt Helsley <matt.helsley@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit dd1752ce3ffe9bdfa3e13dc075b7f22750e77fea
Author: Matt Helsley <matt.helsley@gmail.com>
Date:   Sat Jan 10 23:51:22 2009 -0800

    Add pressure valuator
    
    If it's available report pressure as third valuator.
    (Use xf86PostMotionEventP instead of the varargs wrapper.)
    
    Signed-off-by: Matt Helsley <matt.helsley@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 0f0a149067abdd1ed89717de43febe89b2a3490b
Author: Alan Coopersmith <alan.coopersmith@sun.com>
Date:   Fri Jan 9 16:13:09 2009 -0800

    Remove xorgconfig & xorgcfg from See Also list in man page

commit d170cba0cdd8f7a2e500e094f5b21fc33aefb52a
Author: Yan Li <yan.i.li@intel.com>
Date:   Mon Jan 5 16:35:09 2009 +0800

    Fix XkbModel parsing error
    
    Signed-off-by: Yan Li <yan.i.li@intel.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 268038270593aae45e2740ad2151243383743c1d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Dec 19 08:27:47 2008 +1000

    Add dummy test device - simple device that doesn't move at all.
    
    Good for filling up the device list without getting distracted by spurious
    events all the time.

commit 0f36384d0636d6a8d3a8f182be69c72cccd1ff5c
Author: Sascha Hlusiak <saschahlusiak@arcor.de>
Date:   Mon Dec 8 12:32:31 2008 +0100

    Revert "Keyboard: Disable kernel autorepeat"
    
    This reverts commit 6867652c2c8ad563d5655302d94134592b10265b.
    Functionally replaced by commit ece72ce9e97adae23b1932dc1334f63669196d56
    
    Signed-off-by: Daniel Stone <daniel@fooishbar.org>

commit ece72ce9e97adae23b1932dc1334f63669196d56
Author: Sascha Hlusiak <saschahlusiak@arcor.de>
Date:   Mon Dec 8 12:27:34 2008 +0100

    Filter all repeated keys from kernel, because we do softrepeat in server
    
    Discard all repeated events that come from the device. The server will handle
    per-key autorepeat in software.
    
    Signed-off-by: Daniel Stone <daniel@fooishbar.org>

commit 2bf6e29b40f0da2bc417964fd2bd819306e5d3ed
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Wed Nov 26 15:01:57 2008 +1000

    Finalize MB emu (and wakeup handlers) before closing the fd.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@redhat.com>

commit 2bd24649ecbae08b7bd4dacd67d141ae665f8db7
Author: Tibi Nagy <nltibi@gmail.com>
Date:   Mon Nov 24 22:28:44 2008 +0200

    Support keyboards with scroll wheels.
    
    For keyboards, scroll events are reported by the kernel as EV_REL class events
    of REL_WHEEL type. If, during probing, the device is found to support wheel
    events, make sure it is set up as a pointing device, even if it doesn't have
    buttons or doesn't report motion along the X and Y axis so that the scroll
    events can be mapped to mouse wheel buttons (usually buttons 4 and 5).
    
    Signed-off-by: Peter Hutterer <peter.hutterer@redhat.com>

commit 6867652c2c8ad563d5655302d94134592b10265b
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Thu Nov 27 13:24:08 2008 +1100

    Keyboard: Disable kernel autorepeat
    
    We handle autorepeat in software due to per-key repeat and whatnot, so
    disable the kernel's, which just interferes with ours.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 63af314368cec47b6b8266db331f2c820e7a071f
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Mon Nov 17 10:03:11 2008 +1000

    Store device file's minor/major to avoid duplicate devices.
    
    Devices added that use the same min/maj as an already added device are ignored
    by the driver. This way users can have an xorg.conf entry on
    /dev/input/by-id/blahblah and not get the same device added by HAL.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@redhat.com>

commit 4c5c9c111d406e5590429377262b86e91868ef76
Author: Fernando Carrijo <fcarrijo@yahoo.com.br>
Date:   Thu Nov 6 13:20:16 2008 -0500

    Fix error message

commit 4826969f23a0b298da2750c2e23a92b9d91819dd
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Mon Nov 3 13:25:06 2008 +1030

    Add support for axes swapping.
    
    New option: SwapAxes (boolean)
    New property: EVDEV_PROP_SWAP_AXES.
    
    Actual swapping code written by Donnie Berkholz.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@redhat.com>

commit 33eb36f26663c09c873acede1b35e91ef4c64479
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Thu Oct 30 16:55:29 2008 +1030

    Add support for run-time calibration.
    
    Some devices require run-time axis calibration. We can't change the min/max
    ranges once we've initialised the valuator structs though, so in-driver
    run-time calibration is required.
    
    If the property is set, the driver scales from the calibrated range to the
    values reported to the X server (which then may scale to screen coordinates).
    If the property is not set (i.e. zero items) no scaling is performed.

commit d5cf24d3f0075a467e026592bfbb76b207dea8eb
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Wed Oct 29 16:54:16 2008 +1030

    Add test/ directory for uinput-based test devices.
    
    Three test devices provided:
    btn0 .... Provides BTN_0, BTN_1, BTN_2 instead of BTN_LEFT, BTN_MIDDLE,
              BTN_RIGHT.
    abs ..... Provdes x/y absolute axes, jumps between 100/100 and 120/120.
    absrel .. Provides relative x/y axes and absolute x/y axes at the same time.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@redhat.com>

commit 64554e4799a697d37dfd8be480f8eee636b9bea1
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Wed Oct 29 13:50:07 2008 +1030

    Treat BTN_[0-2] as LMR buttons if necessary.
    
    Treat BTN_[0-2] as LMR buttons on devices that do not advertise BTN_LEFT,
    BTN_MIDDLE, BTN_RIGHT (e.g. 3Dconnexion SpaceNavigator).
    
    Otherwise, treat BTN_[0+n] as button 5+n. Note: This causes duplicate
    mappings for BTN_0 + n and  BTN_SIDE + n.
    
    This also fixes a bug where we could end up with negative button numbers after
    trying to map BTN_0.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@redhat.com>

commit b77f9398570fb8eae1fcf50bc3c10c9c390c6bac
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Wed Oct 29 13:28:19 2008 +1030

    Remove obsolete FIXME
    
    xkeyboard-config's maps are perfectly able to cope with evdev now.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@redhat.com>

commit a43ab4999b9cad10f77aa6c703d3c61b754f1fd4
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Tue Oct 28 12:09:26 2008 +1030

    Flush input after re-opening the fd.
    
    Suggested by Julien Cristau.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@redhat.com>

commit af096e8c5d8b425f725a37bf4a98e205e70716e9
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Mon Oct 27 15:54:49 2008 +1030

    emuMB: add EvdevMBEmuOn and call from EvdevOn to register wakeup handlers.
    
    This got broken in b0737bdbd1f6e601eb4984b6f4cb49279190984c, when the
    EmuMBPreInit call was removed from EvdevOn. As a result, VT switching away and
    back wouldn't restore the wakeup handlers and mouse button presses
    disappeared.

commit 12498042fcc08e34aef0117ce84192f59542fd56
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Fri Oct 24 13:09:46 2008 +1030

    Fix axis inversion for absolute coordinates.
    
    If min_x/y was not equal to 0, the inverted calculated range was off and leads
    to inaccessible or out-of-range areas.

commit 0f8fcfccb3251ee3df80d90ae5d7df638722d24e
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Fri Oct 24 09:21:36 2008 +1030

    emulate MB: fix confusing log message.
    
    If we're forcing MB emulation behaviour as per config, then at least state
    whether we're forcing it off or on.
    
    Found by Michel Dänzer.

commit 0ab4c09e504ba3822c5e030732b770140165e725
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Thu Oct 23 14:05:41 2008 +1030

    Silence compiler warning by memsetting the struct properly.

commit d348eb8ce78640363c159e1a4fdbfa9b596fa5bb
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Thu Oct 23 13:22:17 2008 +1030

    MB emulation timeout is stored as Time, make the property 32-bit too.

commit 2c1698fa615a083de7dd647622a302d5de77dc0c
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Wed Oct 22 18:01:58 2008 +1030

    Init ioctl bitmasks to 0, shuts up valgrind too.

commit 8c39302594445ba774ea3fec66417492cc5643e0
Author: Søren Hauberg <hauberg@gmail.com>
Date:   Wed Oct 1 11:06:31 2008 +0930

    Add touchscreen support.
    
    Touchscreens are devices that do not have buttons and only advertise
    BTN_TOUCH. Add a new flag to note the device type.
    
    If BTN_TOUCH is detected, change it to BTN_LEFT and process it normally.

commit f57e8face94c9e6986b35ca2ec231e284b9f58cf
Author: Julien Cristau <jcristau@debian.org>
Date:   Tue Oct 21 19:21:21 2008 +0200

    Fix TestBit() on 64bit
    
    Reported by Albert Damen <albrt@gmx.net>
    X.Org Bug#18150 <http://bugs.freedesktop.org/show_bug.cgi?id=18150>

commit 4912e2aa7f867a86d383010023b8426c881fb3b0
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Thu Oct 16 15:23:06 2008 +1030

    Add option "GrabDevice", don't grab the device by default.
    
    We now have the matching code in the server to set the console to RAW mode and
    don't need to grab the devices anymore.
    
    This is an updated version of e8534d47c8524ac081c2e3e6ebaabe4c6b274a18, which
    was reverted in 6dc41991557fa55a9e2f5aaf0fe40c70a08d41fd.

commit 7243116f55609a2a5f73bb88cf6ad6386c9bbc0b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Oct 16 22:35:42 2008 +1030

    Don't post keycodes > 255.
    
    If we only have keys > 255 we don't set up a key class rec, so don't post
    them. It makes the server unhappy.
    
    Signed-off-by: Julien Cristau <jcristau@debian.org>

commit 0089d931ac5fb290c82908da652b28c8b515d449
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Tue Oct 14 17:02:43 2008 +1030

    Fix "Device reopened after N attempts" message.

commit 0f5a5ac09ebc89e984b72d395475bb9f412e240c
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Tue Oct 14 16:45:44 2008 +1030

    Don't init draglock, etc. if we don't have the required capabilities.

commit 36d68b006d6bb3d41c93888acead73043ca304a1
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Tue Oct 14 16:41:54 2008 +1030

    8-bit properties should use 8-bit storage types...

commit bb1f42168761b928478a9cb066457b525c41ddd9
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Tue Oct 14 16:25:27 2008 +1030

    Don't include the client-side header anymore. xkbstr.h is server SDK.

commit 0405f7b17fb0ce5cadcc6c5aa6eeb61bdacdf9cd
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Tue Oct 14 16:21:00 2008 +1030

    Tidy up evdev.h
    
    This includes shuffling some functions around so we don't need the prototypes
    in evdev.h.

commit 088e0a175a4913bf827c1f7e19de09fdf987d347
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Tue Oct 14 16:14:13 2008 +1030

    Rename DragLockInit to DragLockPreInit, remove superfluous "return".

commit cefedeb205291001e7e47b7516de261dbccce059
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Tue Oct 14 16:12:13 2008 +1030

    Register property handler from within the modules, not the main evdev file.

commit b0737bdbd1f6e601eb4984b6f4cb49279190984c
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Tue Oct 14 16:09:20 2008 +1030

    Clean up program flow - don't call PreInit for "modules" on DEVICE_INIT.
    
    Call the PreInit functions for MB Emulation, wheel emu, and draglock during
    PreInit, not on DEVICE_INIT. This way, we only parse the options once and
    don't overwrite with defaults when coming back from a VT switch.

commit 5f2c8a2dcdf98b39997ee5e7c9a9ace3b640bfa3
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Tue Oct 14 16:01:17 2008 +1030

    Janitor: clean up xf86Msg use, might as well use X_CONFIG directly.

commit ff783fce65a63707555098759692b22147646263
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Tue Oct 14 15:30:20 2008 +1030

    Add property support for ReopenAttempts option.

commit c638aa4a88116a1219cf4941aacd630e070db099
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Tue Oct 14 15:06:40 2008 +1030

    Document properties in man page.

commit b46677e346c33379cac814895641349cbd3b37f2
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Tue Oct 14 15:06:17 2008 +1030

    Document InvertX/Y options.

commit 680b41dc7681cd611ed385af8009489be6071a41
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Mon Oct 13 17:08:22 2008 +1030

    Bump to 2.1.99.

commit 9065d0ccb26d013f26570d29c332bf1c93fabb2d
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Wed Oct 8 16:16:58 2008 +1030

    Remove "Path" option.
    
    Path was just an alias for Device anyway, so we might as well not parse it.
    By now you should be using HAL anyway which fills in Device for you.

commit a9fcce1833f167ed8aa79d4dbfbbc3d6bca2e7fd
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Wed Oct 8 16:15:14 2008 +1030

    Remove parsing of ScreenNumber option.
    
    Was unused anyway, so we might as well not parse it.

commit ab934d840dac8df761691533985a9d998ec5e21e
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Wed Oct 8 16:14:51 2008 +1030

    Janitor: purge unused headers, reshuffle for readability, fix whitespace errors.

commit 6f6ac982951165a6ac77b3e32750c47780ea4990
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Wed Oct 8 14:25:53 2008 +1030

    Add checkonly handling to property handlers.
    
    If checkonly is TRUE, we can only check if applying the value would succeed.
    The value is actually applied if checkonly is FALSE.

commit a2633c807812e6e8ad9c82e2a5940dfbf370aff5
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Wed Oct 8 14:52:13 2008 +1030

    Fix up bad return code in draglock property handler.

commit e6c699dedcd6f3b5db497fe2d226806ca4bbe683
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Wed Oct 8 14:35:12 2008 +1030

    Stricter value checking for property changes.

commit 847eac826286e6202f42b9a2ccc160a232a710a3
Author: Julien Cristau <jcristau@debian.org>
Date:   Sat Oct 11 02:10:48 2008 +0200

    Set pInfo->fd to -1 on DEVICE_CLOSE
    
    This allows the reopen logic to kick in later.
    DEVICE_CLOSE gets called on regen, so without this we'd keep a stale
    file descriptor in pInfo->fd in subsequent sessions.
    
    Debian bug#496101 (http://bugs.debian.org/496101)

commit a196672a6bafd4e7d3a2cca991a2a3bf4bdcd952
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Wed Oct 1 13:58:24 2008 +0930

    Add property support for axis inversion.

commit 3985d423204217a1f072fa6e0145cba547f79a97
Author: Søren Hauberg <hauberg@gmail.com>
Date:   Wed Oct 1 11:07:57 2008 +0930

    Add support for axis inversion.

commit e138e4b79a750e22712802b84bf36a70a929d12f
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Fri Sep 26 10:42:05 2008 +0930

    Install xorg-evdev.pc for clients who need evdev-properties.h

commit 125e2b8ce23b8ceea250ae52ba69cd14af5592f9
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Thu Oct 2 10:56:04 2008 +0930

    Close fd on DEVICE_OFF. (LP #276887)
    
    Leaving the fd open means we still get keyboard events after VT switching
    away. Coming back, some of these events are replayed on the application that
    has the current focus.
    
    Reproduceable:
    1. open terminal, focus.
    2. VT switch away
    3. type something, preferably a password
    4. VT switch back, trigger a mouse event
    5. Observe the X server guessing your password.
    
    Closing the fd on DEVICE_OFF fixes this. Reopen is handled by the reopen
    code introduced with
    
        commit 9930477cbeb4acfd070ae70894d13ffabfc347b8
        Author: Peter Hutterer <peter.hutterer@redhat.com>
        Date:   Tue Aug 26 14:33:40 2008 +0930
    
            Attempt to re-open devices on read errors.
    
    Launchpad Bug 276887
    <https://bugs.edge.launchpad.net/ubuntu/+source/xorg-server/+bug/276887>

commit 91bc0a0ba3c4c941b2b7695b6d4f303fb7128fd9
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Wed Oct 1 13:36:09 2008 +0930

    Remove useless initialization of rc.

commit 4c55186aedd9030ac46654cee18b09173db988e8
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Wed Oct 1 13:58:47 2008 +0930

    Change DragLock atom name - prepend with Evdev.

commit 62069b97d216fb9b4e7db0c60f87ab006ad7011c
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Fri Sep 26 10:57:07 2008 +0930

    Move misplaced #endif

commit 2718a5c56b9f34360738b6525c89ea0af4c368d1
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Fri Sep 26 10:46:47 2008 +0930

    Register property handlers directly, instead of abstracting them.
    
    This removes a left-over from the early device property code where we could
    only have a single handler. Now it's easier to just register the handlers for
    each subsystem (emulate wheel, draglock and MB emulation).

commit 90d1d494f82255b07d07800d8270ad754163b7ab
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Fri Sep 26 13:49:28 2008 +0930

    Cleanup: "valid_vals" should be "vals" now.

commit a77c2622cc7979cea6c1549f1978fae575b76c6c
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Fri Sep 26 13:47:24 2008 +0930

    Add evdev-properties.h file with #defines for all property names.

commit 84a0e39c0dd8bcc80d4f6912562260c1771f311f
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Thu Sep 18 16:44:27 2008 +0930

    Use new property API (no ConfigureDP, less args to ChangeDP)
    
    Return appropriate status codes from property handlers.
    Make properties non-deletable.

commit 73869372212f7afc18e02184f347bcd94ce19d04
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Thu Sep 18 16:47:35 2008 +0930

    draglock: Shut up compiler warning.

commit fcf8375f2b960993686bd08fd4d0e2d8623b4680
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Fri Sep 26 12:53:29 2008 +0930

    Don't require randrproto.

commit 9930477cbeb4acfd070ae70894d13ffabfc347b8
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Tue Aug 26 14:33:40 2008 +0930

    Attempt to re-open devices on read errors.
    
    Coming back from resume may leave us with a file descriptor that can be opened
    but fails on the first read (ENODEV).
    In this case, try to open the device until it becomes available or until the
    predefined count expires. To be safe, we cache the information from the device
    and compare against it when we re-open. This way we ensure that if the
    topology changes under us, we don't open a completely different device. If a
    device has changed, we disable it.
    
    Adds option "ReopenAttempts" <int>

commit 4509ec1daf8a03b261c1fa8aa48b5def3f336aed
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Thu Sep 4 18:22:56 2008 +0930

    Use HAVE_PROPERTIES define instead of GET_ABI_MAJOR for property compilation.

commit a205dfc091e6d7c67e3fa1421fe8a43f5ed40b00
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Fri Aug 22 14:07:17 2008 +0930

    Shut up "unused variable" compiler warnings.
    
    Hide properties behind ifdefs, fake use of "val".

commit 184206e7174dc08239d6a78a1ca912176e3f6229
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Mon Aug 25 17:24:15 2008 +0930

    Wheel emulation: initial values must be char.
    
    parsing int* to char* in XIChangeDeviceProperty means we lose values.

commit 79ff677c52d38f67144f09bd534aaef862946a5e
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Fri Aug 22 09:00:13 2008 +0930

    Init all emulateWheel values, even if EmulateWheel is disabled.
    
    Even if we don't want EmulateWheel, we can at least init everything to usable
    values. This way we only need to toggle "enabled", rather than initialising
    the whole lot before usage.

commit 37e3addf89923bfc1e7ae23b678614f4ca926dcf
Author: Dan Nicholson <dbn.lists@gmail.com>
Date:   Wed Aug 20 18:16:41 2008 -0700

    Add wheel timeout property support
    
    Copied from the wheel inertia property support.
    
    Signed-off-by: Dan Nicholson <dbn.lists@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@redhat.com>

commit e237de0dea9fe24e1c4efc78523bfdd86ed73876
Author: Dan Nicholson <dbn.lists@gmail.com>
Date:   Wed Aug 20 18:16:40 2008 -0700

    Add timeout support for mouse wheel emulation
    
    Support the EmulateWheelTimeout option as the mouse driver does.
    
    Signed-off-by: Dan Nicholson <dbn.lists@gmail.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@redhat.com>

commit 92c6611b6f4495103fccea38dcafc6c6bf18049a
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Mon Aug 18 12:13:15 2008 +0930

    Add property support for drag lock.

commit bd405ddc83b9ad1ceed47f572245fccae598e6bb
Author: Chris Salch <emeraldd.chris@gmail.com>
Date:   Sun Aug 17 12:31:23 2008 -0500

    Adding in DragLockButtons functionality.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@redhat.com>

commit 36d702006d5aace50083ca52b7065d465b497077
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Sat Aug 16 15:33:23 2008 +0300

    Force rules, not model, to be evdev
    
    xkeyboard-config recently changed to a separate ruleset for the evdev
    driver, so match that by only forcing the ruleset, not the model, to be
    evdev.

commit 6dc41991557fa55a9e2f5aaf0fe40c70a08d41fd
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Fri Aug 15 09:23:02 2008 +0930

    Revert "Don't grab devices unless specified through the config options."
    
    Not such a good idea, CTRL+C terminates the server and other issues. Reverting
    for now until a better solution is found, at least this way the driver is
    usable.
    
    See also: http://lists.freedesktop.org/archives/xorg/2008-August/038032.html
    
    This reverts commit e8534d47c8524ac081c2e3e6ebaabe4c6b274a18.

commit e8534d47c8524ac081c2e3e6ebaabe4c6b274a18
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Thu Aug 14 13:38:50 2008 +0930

    Don't grab devices unless specified through the config options.
    
    Grabbing event devices stops in-kernel event forwarding, most notably rfkill
    and the "Macintosh mouse button emulation" device. Let's not do that.
    
    Option "GrabDevice" forces grabbing the device.

commit 555f5a7cbf3c980c436c205e9b23a78f3e19bdfe
Author: Chris Salch <chrissalch@letu.edu>
Date:   Fri Aug 8 15:56:27 2008 +0930

    Filter wheel events before middle mouse button emulation.
    
    The Emulate3Button needs to be the last filter function, otherwise the timeout
    code causes it to hijack button presses for the first 3 buttons.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@redhat.com>

commit 134829d911c698704595014ba402516ae9a2f36c
Author: Peter Hutterer <peter.hutterer@redhat.com>
Date:   Thu Aug 7 17:34:54 2008 +0930

    Simplify the property handler registration.
    
    Instead of having separate handlers for each property, just handle all of them
    in one handler for emuMB, and one handler for emuWheel.

commit 4e121b297ee0a9b179f8188926564fb8b2c3f6c8
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Aug 7 16:57:06 2008 +0930

    Add EVDEV_MAXBUTTONS instead of checking against 32.
    
    Numbers are so lame, defines are all the rage now I've heard.

commit 9793de81373bb78b9ddbb2487e0af5d2ddd0b246
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Aug 7 16:53:51 2008 +0930

    Expose wheel emulation through device properties.
    
    Don't enable wheel emulation with 0 inertia - bad things happen.

commit a9d72b40fbe178fa4fbb9d0e7c02dc6c5250969a
Author: Chris Salch <emeraldd.chris@gmail.com>
Date:   Wed Aug 6 22:08:13 2008 -0500

    Adding mouse wheel emulation code.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c1f7f8c3d22ecae7839f82ea8b584069f54f1f5e
Author: Adam Jackson <ajax@redhat.com>
Date:   Thu Aug 7 09:21:26 2008 +0930

    Print a warning if a keycode exceeds the range accepted by the server.
    
    Keycodes over 255 are silently ignored in the server. The least we can do is
    put a warning in the logs.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 40e1474d84c09d93197ac5db34a88e654386e68f
Author: Chris Salch <emeraldd.chris@gmail.com>
Date:   Mon Aug 4 20:19:47 2008 -0500

    Adding a function to map button events to button numbers.
    
    Remove code duplication, let the mapping function hand us the actual button
    event to be passed up to the server.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d9097df01b01afaf946fa04fca8ae8ab7108ff21
Author: Julien Cristau <jcristau@debian.org>
Date:   Mon Aug 4 09:16:53 2008 +0930

    Actually close the fd on DEVICE_CLOSE (bug#16948)
    
    Fixes file descriptor leak.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5c074af5a9abba138023e3bc6954d1062f7c36dd
Author: Julien Cristau <jcristau@debian.org>
Date:   Wed Jul 30 10:40:47 2008 +0200

    Print the device name when we get a read error

commit 72551662a09eedf696508aaacf6aa02c0254e4de
Author: Michel Dänzer <michel@tungstengraphics.com>
Date:   Tue Jul 29 10:06:07 2008 +0200

    xf86-input-evdev: Fix EVIOCGBIT ioctl usage on big endian platforms.
    
    With this fix, on my PowerBook HAL hotplugging correctly detects my USB mouse,
    and no longer thinks keyboards have random numbers of mouse buttons. :)
    
    The LONG_BITS and NBITS macro definitions are stolen from xf86-input-synaptics.
    
    Signed-off-by: Michel Dänzer <michel@tungstengraphics.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 53e7525744cd7c47707c7339f0b771f59f99b97c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jul 21 18:15:35 2008 +0930

    Add support for ButtonMapping option.

commit 5d13259a5ddab31dbb2158975c8ccbb1f3c99046
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Jul 21 13:10:06 2008 +0930

    Guard property changes against ABI_XINPUT < 3.

commit 2b7edaa4ab88e192d7285d39b4834d1e535b94d0
Author: Julien Cristau <jcristau@debian.org>
Date:   Sun Jul 20 11:33:37 2008 +0200

    Fill up the version info
    
    Report correct versions instead of
    "compiled for 0.0.0, module version = 1.0.0"

commit bf0d81011e19a8bb5bbd80c6b496c8ae257b4f2c
Author: Peter Hutterer <whot@possum.(none)>
Date:   Mon Jul 14 13:06:32 2008 +0930

    Don't enable the device if the grab failed with ENODEV.
    
    After suspend/resume, sometimes the device doesn't come back up on the same
    node. Since we do not call PreInit for the device (which would detect this
    situation), we continue to try to read a nonexisting file, spamming the log
    file with "Read Error".

commit ef4bb69c1a64e784fef1c758ee439372ba329b0a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jul 10 19:32:22 2008 +0930

    Add .gitignore file.

commit d1818ef2066d7e526e0f64fffd41e06061ceb017
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jul 8 16:37:42 2008 +0930

    Add support for device properties, currently MB emulation and timeout.

commit a9223edcd869288cf6e90f2214e607db510c7027
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jul 10 16:55:21 2008 +0930

    Clean out configure.ac
    
    We're not building with or without XInput. Same with xkb.

commit ec23c6b2f550f2679226da907c1d022295d453f1
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jul 3 15:01:32 2008 +0930

    Remove static ChangeLog, autogenerate as part of make dist.
    
    Hook taken from xserver's Makefile.am

commit 18d70d796fe68116907d86fc27ed77528a51ff1d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jul 3 14:50:45 2008 +0930

    Update COPYING with the correct copyright info.
    
    Fix up licence of emuMB.c, was using Red Hat instead of "The authors", but
    this code wasn't contributed by RH anyway.

commit 37b854cb643fa9c5087eccdd1b6ba940d5413bf9
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jul 3 14:45:41 2008 +0930

    Remove stale comments.
    
    Ctrl+Alt+Backspace works, I'm using it daily.
    CapsLock doesn't repeat, otherwise we wouldn't have Bug 16318.

commit 8c06093191761f9bd2f3c5eb0b57d7b9feca70bc
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Jul 3 14:44:52 2008 +0930

    Remove EvdevConvert, nobody calls it now anyway.
    
    Conversion is now done in the DIX.

commit 0830676a0ce3618eae9cf4c072998c16e164c687
Author: Ander Conselvan de Oliveira <ander@mandriva.com.br>
Date:   Thu Jun 26 14:36:58 2008 -0300

    Mice with a lot of buttons (e.g. Logitech MX1000) generate button events greater than BTN_TASK.
    
    Signed-off-by: Peter Hutterer <peter@cs.unisa.edu.au>

commit 1cf7b8f7ee224d823d94ea65458f5269a1a77d2e
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Sat Jun 28 17:50:26 2008 +0930

    Count buttons at probe and print to log.
    
    We don't really do anything with the number other than print it since I'm sure
    that half the mice don't report the correct number anyway (especially with the
    wheel button mapping). But having a bit more debug info is good.

commit 826e6e7dd408659af9a1751ed16e437db8c8dc34
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Sun Jun 22 17:52:40 2008 +0930

    Bump to 2.0.99.

commit 5a0ea39b79b27b7c3117661a21e7ab5eba3c9b24
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Sat Jun 21 16:42:12 2008 +0930

    No need to finalize MB emulation after EvdevProbe anymore.
    
    Follow-up to 76800bfa75807e49398380b902f6c0f547cd4c0e.

commit 373e13ae353d1e0022f8821adc528ebc5411d47d
Author: Simon Munton <simon@munton.demon.co.uk>
Date:   Sat Jun 21 10:19:07 2008 +0930

    Close file descriptor if EvdevProbe fails.
    
    Signed-off-by: Peter Hutterer <peter@cs.unisa.edu.au>

commit 76800bfa75807e49398380b902f6c0f547cd4c0e
Author: Keith Packard <keithp@keithp.com>
Date:   Fri Jun 20 18:20:55 2008 -0700

    Enable middle button emulation at DEVICE_ON instead of DEVICE_INIT.
    
    This ensures that the middle button emulation is re-enabled after VT switch,
    otherwise the block handler that deals with the timeouts would not get
    re-registered.
    
    Signed-off-by: Keith Packard <keithp@keithp.com>

commit 04003a98a9ca1b4b0c32d319fab07ee7afc83c75
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Tue Jun 17 14:01:49 2008 +0930

    evdev 2.0.0

commit 0443fb430f2481c1f0d0d83730a9145b5794f559
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Tue Jun 17 13:59:15 2008 +0930

    Shut up compiler warning "implicit declaration of function 'xf86Msg'"

commit 998f52010f92dc79f2ace6048a2f3fd600a97582
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Thu Jun 12 11:23:10 2008 +0930

    Finalize MB emulation if EvdevProbe fails.
    
    This avoids segfaults when HAL is restarted behind our backs. Also, only init
    MB emulation when the device actually has a button.

commit de07c04f5c2874b8e407913c3121e715e46653d2
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Wed Jun 11 11:24:07 2008 +0930

    evdev 1.99.4
    
    1.99.3 had a nasty bug, so here's a quick update.

commit 01355b9d4b3ed92da42f90fb69384eb22cdcb3d9
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Wed Jun 11 11:19:04 2008 +0930

    If Emulate3Buttons is specified in the config, don't auto-deactivate it.
    
    Default setting is still "on" until middle button is pressed.  If the options
    is however explicitly stated in the config file, it takes the value from the
    config file, no matter if a middle button is present.

commit 9591dc1f6cc89208805b120eabd055e8dabd3e40
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Wed Jun 11 10:36:00 2008 +0930

    Remove wakeup handlers when device is closed.
    
    Less SIGABRTs are less exciting, but sometimes boredom is what we want.

commit 08ba40b2532bd61b60c9cf994b21300f596f7ebd
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Jun 10 17:35:33 2008 -0400

    evdev 1.99.3

commit 39dc453691804648f34dbd856bd7e66cfdc59d66
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Tue Jun 10 22:48:01 2008 +0930

    Disable middle mouse button emulation when a real middle MB event is detected.
    
    Devices may report middle mouse buttons even if they don't have one (PS/2
    devices just don't know any better), so we can't be sure until we see the
    event.

commit e8887435ac065ec3071b2d8bf0895e8cb196ec3d
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Tue Jun 10 15:55:40 2008 +0930

    Enable middle-mouse button emulation.
    
    Ported from xf86-input-mouse, with a few cleanups.

commit b0f6987ee6b133e28f3af18da62cfb5ca79fbe07
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Tue Jun 10 22:41:43 2008 +0930

    Plug a memory leak, we allocated pEvdev twice, dropping the first memory area.

commit fec73e1418a4da1b64496faca27b06fef0aa5206
Author: Sven Wegener <swegener@gentoo.org>
Date:   Sat Jun 7 13:01:22 2008 +0200

    evdev: Port b4a5a204 "Fix pointer crossing screen bug." to current master branch
    
    The commit b4a5a204 fixed an issue, where we can't move the pointer to
    other screens and this happens in current master branch again. This commit
    ports the old commit to the current master branch.
    
    Signed-off-by: Sven Wegener <swegener@gentoo.org>
    Signed-off-by: Peter Hutterer <peter@cs.unisa.edu.au>

commit da112737eb109dc263169e820b7ef903b7f8624f
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Sun Jun 8 00:12:03 2008 +0930

    Check for XINPUT ABI < 3 (corrected version)
    
    Thanks to Sven Wegener for pointing out the incorrect previous version.

commit d40125ea8c2ce6ec0f98bdc0655f79aa7274152e
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Sun Jun 8 00:09:40 2008 +0930

    Revert "Check for XINPUT ABI, parameters of InitValuatorClassRec have changed."
    
    GetMotionEvents() doesn't exist, led to compile errors with servers pre-MPX
    merge. Thanks to Sven Wegener for pointing this out.
    
    This reverts commit 42422d8f69e6806e1adfd93017cac064a75041c7.

commit 42422d8f69e6806e1adfd93017cac064a75041c7
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Mon May 26 19:17:19 2008 +0930

    Check for XINPUT ABI, parameters of InitValuatorClassRec have changed.

commit 15e0091f0b4b0d7dff29da143d405255a1c3bc12
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Wed May 21 16:48:32 2008 +0930

    Fail if the device cannot be grabbed during the probe.
    
    If the grab fails, this is most likely a sign that the device has been grabbed
    already (probably by a device specified in xorg.conf). So let's not add the
    device to the server's input device list, since it won't generate events
    anyway.
    
    Exception: keyboards and kernel 2.4 are not affected.

commit d45f315845e19a720af25dc5f6c8a4c654c6e225
Author: Adam Jackson <ajax@redhat.com>
Date:   Wed May 21 15:05:10 2008 -0400

    evdev 1.99.2

commit a4a7003f7c82ddf05d3aa88fa40698058648dbf6
Author: Dan A. Dickey <dan.dickey@savvis.net>
Date:   Tue May 20 10:57:06 2008 +0930

    Fix a trivial bug in testing for absolute axes.
    
    Signed-off-by: Peter Hutterer <peter@cs.unisa.edu.au>

commit 3e0dc9945d795cfd51ffe176100fa9416b6d3c4d
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Mon May 19 08:36:20 2008 +0930

    Shut up two compiler warnings.

commit ff6251a2bd347eef7b3cd80825e84d983eeecfd3
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Mon May 19 08:24:55 2008 +0930

    Remove unused EvdevOpts and EvdevOptions.
    
    In the mouse driver, these options are only used if XFree86LOADER is
    undefined. configure.ac in the xserver forces said define to 1 if we're
    building the xfree86 DDX, so I don't see the point of having them around.
    Especially since they weren't used in evdev anyway.

commit e9222a828582e560f9c3a29f0d3d9e1e46d973bd
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Sun May 18 11:04:43 2008 +0930

    man: Option "Path" is supported in the code, add it to man page.

commit 8b7738457feef13e1fab88bb30c94093dd8bfcc5
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Wed Apr 30 18:10:08 2008 +0930

    Don't allow relative and absolute axes on the same device.
    
    This is a bit of a mess. The MS Optical Desktop 2000 registers both relative
    and absolute axes on the same device (the mouse). The absolute axes have a
    valid min/max range for x/y and thus overwrite the x/y relative axes in the
    server (no, this is not a server bug). And I wouldn't be surprised if other
    devices have similar issues.
    
    Since the device only sends relative events after that, the mouse is
    essentially restricted to the min..max range of 0..255. The server simply
    doesn't do unrestricted relative axis and restricted absolute axis on the same
    device (not for the same axis numbers anyway).

commit 1b9deb8e7e50a905f94a371ab0aa39e09a703052
Author: Sascha Hlusiak <saschahlusiak@arcor.de>
Date:   Tue Apr 1 17:24:13 2008 +0200

    Add XK_Meta_L and XK_Meta_R to list of modifiers
    
    Stopps meta/super key from autorepeating

commit 0ec391f51cef4550daef041110ed93699089bea3
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Fri Mar 28 17:45:05 2008 +0200

    Keyboard: Don't allow arbitrary keymap settings
    
    Pretty much dead code anyway.

commit f77410e1f97d394e98c854fd174f712666b0544c
Author: Adam Jackson <ajax@redhat.com>
Date:   Fri Mar 14 11:15:01 2008 -0400

    Map REL_DIAL to REL_HWHEEL.
    
    Some Microsoft mice have this wrong.  And it seems like a sensible thing
    to do anyway.

commit d28c2e1efba9fd3e79d9dfecf23cdbded30b93f5
Author: Adam Jackson <ajax@redhat.com>
Date:   Wed Mar 12 13:54:10 2008 -0400

    Filter out repeat events for mouse buttons.
    
    Not many mice do this, but some do, Apple Mighty Mouse in particular, and
    it makes click-and-drag pretty much impossible to use.
    
    Arguably we should filter _all_ repeat events from the kernel and handle
    synthesizing them in the server.

commit 697e850a6387cf1e0a0a35ca8c694804a6c2427f
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Mar 11 19:07:58 2008 -0400

    Fix middle/right button munging.
    
    Don't do this in the button map.  That's writeable by clients, which means
    they have the chance to get it wrong.  Just swap right and middle around
    in event dispatch before you get to the user's map.

commit 87037b9953ebd47e9dbd99b3653050517aa490ff
Author: Adam Jackson <ajax@redhat.com>
Date:   Mon Mar 10 17:16:38 2008 -0400

    Force xkb_model to be "evdev".
    
    Or at least, refuse to recognise the config option.  It's nonsensical to
    use a model of something other than evdev, and it'll just break if you try.

commit 71f4eaec7713643a7e2d07e27b9afeabd6f1ce02
Author: Dan Nicholson <dbn.lists@gmail.com>
Date:   Sun Mar 9 14:46:56 2008 -0700

    Fix cut-and-paste errors in xkb alternate spellings code
    
    Fixes 2b334d6b69d7dde5d553c638e134ebdf974749f3.

commit 72083976127a1ff15f79b0316570a947e6dd2b42
Author: Adam Jackson <ajax@redhat.com>
Date:   Sun Mar 9 16:15:14 2008 -0400

    Fix cut-and-paste error in abs-to-rel translation.

commit c250f843833b1aac3732ca97af5b1c0076996598
Author: Adam Jackson <ajax@redhat.com>
Date:   Sun Mar 9 15:54:27 2008 -0400

    Fix the default XKB rules to be "base" instead of "xfree86".

commit 2b334d6b69d7dde5d553c638e134ebdf974749f3
Author: Adam Jackson <ajax@redhat.com>
Date:   Sun Mar 9 15:53:40 2008 -0400

    Handle the alternate spellings of the xkb options.

commit 9773dac6238b64cab1d42b2231097b23058c44ee
Merge: 11cf9c9 1a0bc8e
Author: Adam Jackson <ajax@redhat.com>
Date:   Sat Mar 8 20:18:02 2008 -0500

    Merge branch 'evdev-2.0-branch'
    
    This resets to before the ad-hoc input hotplug state, ports that to
    current server ABI, adds input hotplug integration, and re-adds support
    for absolute coordinate events and XKB.  Several other small fixes were
    cherry-picked from the new 1.2 branch.

commit 1a0bc8e64a9ba6e8647b5908673b57710518f6c2
Author: Adam Jackson <ajax@redhat.com>
Date:   Sat Mar 8 20:01:15 2008 -0500

    Force maximum keycode to be 255
    
    Even though we don't have keycodes for anything above 127, make sure our
    map always covers up to 255.  This ensures that the keycode range never
    changes.
    
    Spiritually cherry-picked from a9e87f29ccdadebb0742317bb57d66eaaca4b593
    and 6db4a9fb84f828f745202c3fddc58d389fca220b.

commit 6271494faa4c45f4fa10509f72e0515f2cef36c6
Author: Adam Jackson <ajax@redhat.com>
Date:   Sat Mar 8 19:54:44 2008 -0500

    Add absolute coordinate event support.
    
    There are two major classes here, touchscreens and touchpads.  Touchpads
    are logically more like relative devices, in that your initial touch
    should not warp the cursor.  So attempt to detect touchpads (via the
    existence of BTN_TOUCH) and translate absolute events from those devices
    to relative motion.

commit f5bfc7ec3c132276ab7152b283f75387ee656ec2
Author: Adam Jackson <ajax@redhat.com>
Date:   Sat Mar 8 16:52:17 2008 -0500

    Nuke the keyboard bell code.
    
    It did nothing, and the core won't invoke it anymore anyway.

commit bf0848ec8e1ab45cb72fc8da0cc5dc47eefd0760
Author: Adam Jackson <ajax@redhat.com>
Date:   Sat Mar 8 16:37:42 2008 -0500

    Re-add XKB support.
    
    Almost entirely taken from a patch I did ages ago in bug #3912, with
    slight cleanups, and with the KcCGST options removed as per evdev 1.x.

commit f1445feac77af65098eef1c2d86ae067d81fc6cb
Author: Adam Jackson <ajax@redhat.com>
Date:   Sat Mar 8 16:09:47 2008 -0500

    Parse Option "Path" as well as Option "Device".
    
    The hotplug core passes Path not Device.  With this change, hotplugging
    works.

commit ad5bdcb50f511b1cd3bd0118d2b1f4fe58c4ab72
Author: Adam Jackson <ajax@redhat.com>
Date:   Fri Mar 7 20:29:58 2008 -0500

    Ignore button events above BTN_TASK for now.

commit bb36ca65c64d1d863f8fa4e6f058a384fbc80eb0
Author: Adam Jackson <ajax@redhat.com>
Date:   Fri Mar 7 19:43:07 2008 -0500

    Support the new DIX motion history API
    
    Spiritually cherry-picked from 036b457c1b3f7d2d174da890cb8598d907181f8e

commit 40a1e1439c120d791a2f106293f4a712c452fcc5
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Sun Jul 9 18:08:50 2006 +0100

    remove XFree86LOADER usage
    Build evdevModuleData, et al, unconditionally.

commit 946beb16f8002e8f52af082d424aac74e6fd34a9
Author: Adam Jackson <ajax@redhat.com>
Date:   Fri Mar 7 19:09:35 2008 -0500

    Unlibcwrap.

commit 305f90d37ad200063589c5ecf946474a09f0349b
Author: Adam Jackson <ajax@redhat.com>
Date:   Fri Mar 7 19:06:14 2008 -0500

    Branch for evdev 2.0

commit 11cf9c92c0d31d1058ec6c013b7126bd8909beba
Author: Sascha Hlusiak <saschahlusiak@arcor.de>
Date:   Mon Mar 3 13:40:52 2008 +0200

    Updated manpage to reflect current state
    
    Large parts of the manpage were obsolete and confused users. Current state should reflect all available driver options. Some details are still missing.

commit 7f1e8146d4b13929a86a4b80f783a720c1b5573a
Author: Sascha Hlusiak <saschahlusiak@arcor.de>
Date:   Wed Feb 20 20:41:08 2008 +0100

    More accurate error messages on device open fail.
    
    The message "cannot open input pEvdev" resulted in a lot of bug reports of confused users that did not
    supply a device path. Now we tell them when it is missing or print out a reason when device open fails.

commit 8ae4d17ca3fb9ec06b16df5c737cd9021453a020
Author: Sascha Hlusiak <saschahlusiak@arcor.de>
Date:   Tue Feb 19 22:49:51 2008 +0100

    Let kernel autorepeat pass when set on default values
    
    xorg-server won't generate soft autorepeat, when interval/delay are at default of 40/660 (see xkb/ddxCtrls.c:
    XkbDDXUsesSoftRepeat). When we hit the defaults, we let the kernel autorepeat pass, if we differ, we swallow them all
    and let the server figure out autorepeat in software.

commit 134ce2e493882ce411d17ea97ebb243a7d574144
Author: Sascha Hlusiak <saschahlusiak@arcor.de>
Date:   Tue Feb 19 21:12:36 2008 +0100

    Set repeat_delay and repeat_interval to default values
    
    Set ctrls->repeat_delay and ctrls->repeat_interval so that keys will be automatically repeated in software.

commit 10e7c3fbdf4e94c212c0807844721064e7490729
Author: Sascha Hlusiak <saschahlusiak@arcor.de>
Date:   Tue Feb 19 21:09:13 2008 +0100

    Filter all incoming repeated key events
    
    Not just filter modifiers but every repeated key, because the software implementation will take care of what key to
    repeat and what not. Otherwise the kernel's autorepeated keys interfere with the software generated ones.

commit f766404fd94851ea8b3cedc5c7336a5524b7a7ae
Author: Sascha Hlusiak <saschahlusiak@arcor.de>
Date:   Tue Feb 19 21:05:49 2008 +0100

    Don't inform kernel evdev driver about autorepeat change
    
    We do autorepeat in software now. Informing the kernel would change the autorepeat speed on virtual terminals, which is
    probably not wanted so we leave the settings untouched.

commit d032d3c8b40e152cc0fd8409f910f23559873aaf
Author: Vinay Bondhugula <vinayb@vmware.com>
Date:   Tue Jan 29 22:15:22 2008 -0800

    Clear EV_ABS_V_USE_TOUCH for devices without a touch button
    
    VMware's absolute pointing device does not have a pressure/touch button.
    Although evdev correctly recognizes this, it sets "use_touch" for X and Y axes
    regardless of the touch button. This patch clears the USE_TOUCH flag for the X
    and Y axes if the device does not have a touch button.

commit 5adbc6b98ca1da9a426528ce0df64a992feff3bd
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Tue Jan 29 14:07:49 2008 +1030

    Initialise b_map_data to correct size. Bug #13991
    
    X.Org Bug 13991 <http://bugs.freedesktop.org/show_bug.cgi?id=13991>

commit eeb3727004327bc4d83192a7956c1835b3bd6161
Author: Julien Cristau <jcristau@debian.org>
Date:   Fri Nov 9 00:38:54 2007 +0100

    Don't flush buttons on init (bug#12630)

commit fa15e909933252d5cc0a2a272506effbcf21d6f9
Author: Peter Samuelson <peter@p12n.org>
Date:   Thu Oct 11 07:27:30 2007 +0200

    Fix one additional typo in evdev.man (axis named BRAKE, not BREAK).

commit 12a27693b9bb41b9222c5c2256815d225ee75929
Author: Peter Samuelson <peter@p12n.org>
Date:   Thu Oct 11 00:09:40 2007 +0200

    evdev.man minor fixes
    
    * Use \- (ASCII dash) instead of - (hyphen), where appropriate
    * Use a roff escape instead of a UTF-8 character.
    * Consistent use of quote characters.
    * Consistent use of typographic conventions:
      italic "n" in place of "<N>" or "integer" or "number",
      bold for option names, bit maps, etc.
    
    Debian bug #446118

commit 1c40c7db188bc9030aaf256004b914815e821940
Author: James Cloos <cloos@jhcloos.com>
Date:   Mon Sep 3 05:52:08 2007 -0400

    Add *~ to .gitignore to skip patch/emacs droppings

commit e2be2ffa473583b98b93a319163bb54eb5d83ed6
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Wed Aug 1 00:02:33 2007 +0300

    Options: Accept differently-named options
    
    Take some differently-named options for device and the XKB options.  These
    should really be better-handled, but eh.

commit e86aab93c56ad72f3798169ea94dc6b91dab6ab6
Author: Brice Goglin <Brice.Goglin@ens-lyon.org>
Date:   Thu Jul 26 18:31:58 2007 +0200

    Multiple typos in evdev.man
    
    Reported by "A. Costa" <agcosta@gis.net> in
    http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=432063

commit c69f4bd5707093a4f998c3fad508f466edbe8334
Author: Tiago Vignatti <vignatti@c3sl.ufpr.br>
Date:   Fri Jun 15 01:35:29 2007 -0300

    Clean up a little bit the code.

commit 64677ecc76d6eae530960b714712921e1bb9d4a7
Author: Tiago Vignatti <vignatti@c3sl.ufpr.br>
Date:   Fri Jun 15 01:33:49 2007 -0300

    Remove inotify things.

commit 08a09682f5b6d43181e98bc72782e2b2eec180e5
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Wed Jun 13 11:05:07 2007 -0400

    Update version using PACKAGE_VERSION_*.

commit 9c9a47210a6c7146f29fd6d05b6f46955a3bee5a
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Jun 12 11:59:16 2007 -0400

    Move the mode option handling to the Init stage.
    (Sorta ugly placement wise, but the other segfaults.)

commit 2d2c4804f925505e737c2c812687f47840218c93
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Mon Jun 11 09:08:24 2007 -0400

    evdev.c:
    
        Set and use the X mode control, letting XInput see it properly.
    
        Kill some cruft.
    
    evdev.h:
    
        Set and use the X mode control, letting XInput see it properly.
    
    evdev_axes.c:
    
        Set and use the X mode control, letting XInput see it properly.
    
    evdev_key.c:
    
        Remove some cruft, the bell func can be NULL now, so do so.
    
        Don't bother looking for keys above 0xF7 until we can actually do
        something with them.

commit 6b97bf7a4eaa34ebde4ac7250f660da5bab8164d
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Wed Jun 6 05:00:29 2007 -0400

    Handle default remapping around existing button targets better.

commit 5c6b3dd86feef58ccf43a710624404031df72f2c
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Wed Jun 6 04:42:51 2007 -0400

    Move MapButtons_t closer to where it's used.

commit f15636ac529481a9d83e0250ff89690296f96a3d
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Wed Jun 6 04:41:54 2007 -0400

    Wheel mice work again!
    (Old configs don't.)
    
    evdev.c:
    
        Add EvdevParseMapToButton and EvdevParseMapToButtons to evdev_map_parsers.
    
        Add EvdevParseMapOption to search through evdev_map_parsers.
    
        Fix up EvdevTokenize to handle the evdev_option_token_t changes.
    
        EvdevAxesNew0 after BtnNew0 instead of before now.
        (This isn't the right fix.)
    
    evdev.h:
    
        EVDEV_MAXBUTTONS -> BTN_MAX.
    
        Redid evdevBtnRec with the new mapping goodness.
    
        Removed v_min and v_max from evdevAbsRec.
    
        Reworked evdev_option_token_t, no union, no is_chain.
        If it's a chain, it still has a string, but the chain pointer is set.
    
        EvdevParseMapToButton, EvdevParseMapToButtons, and EvdevParseMapOption.
    
    evdev_axes.c:
    
        Kill off EvdevAxesMapButton, a variant lives in evdev_btn.c now.
    
        Changes for the evdev_option_token_t changes.
    
        Use EvdevParseMapOption instead of repeating the contents twice.
    
        Disable EV_ABS_V_INVERT for the moment. (Better fix maybe needed.)
    
    evdev_btn.c:
    
        s/Ptr /Rec */g
    
        EvdevMapButton and parser.
    
        EvdevMapButtons and parser.
    
        Nuke EvdevBtnCalcRemap as a whole.
    
        Move everything but the alloc to New1 from New0.
    
        New mapping code, same guts os the axes mapping code even.

commit 276685fa1dfc7c2d78178173545df3e28bc82544
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Jun 5 23:55:50 2007 -0400

    Fix REL mode.
    
    Make buttons mostly work again. (Short term fix.)
    
    NOTE: Wheel to button remapping is still missing!

commit 27a86f81683794c1f7cd3bc6d474898ff69a7b6e
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Jun 5 23:19:59 2007 -0400

    Update the copyright notices for me to include 2007.
    
    Finish merging copyright notices. (evdev_key.c was missed.)

commit 26dbf38041ebe67e7ab399a6746684a404ea2121
Merge: 2943558 9eb546e
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Jun 5 23:14:46 2007 -0400

    Merge branch 'master' of git+ssh://git.freedesktop.org/git/xorg/driver/xf86-input-evdev
    
    Conflicts:
    
    	src/evdev.h

commit 294355842ba9fb3cb3bbd7bfd60c9ca3ce704475
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Jun 5 23:12:58 2007 -0400

    Alright, this is a really big commit that breaks stuff.
    
    evdev.h:
    
        Switch to flags in the abs and rel structs.
    
        Add the axes struct, and defines.
    
        Rework the abs and rel structs, moving stuff to the axes struct and moving
        everything to the new mapping handling.
    
        Add the structs and function declarations for the new tokenization stuff,
        parsing stuff, and mapping stuff.
    
    evdev.c: Add EvdevTokenize, and the evdev_map_parsers list.
    
    evdev_axes.c:
    
        Basicly a full rewrite, big, messy.
    
        We now use a completely different mapping setup for axes, and mapping to
        buttons is currently missing.
    
        However we now handle ABS_CALIB and ABS_AREA, including rotation in both
        rel and abs modes.
    
    evdev_btn.c:
    
        Disable lots of code and break things horribly, we compile but we don't
        work very well.
    
        Fixing this is next on my todo list.

commit 9eb546e0e00be30ac6e767b196b17651df2e3d96
Author: Kristian Høgsberg <krh@redhat.com>
Date:   Tue Jun 5 18:26:07 2007 -0400

    Fix header file #ifdef guard.

commit daf926081d1524a8d4980578d5254c42c2791462
Author: Kristian Høgsberg <krh@redhat.com>
Date:   Tue Jun 5 18:24:33 2007 -0400

    Merge copyright notices.

commit c22c955c482df9a7645662023b6d1cf0f33aff15
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Tue Apr 24 23:20:43 2007 +0930

    Disable and remove the device when a read error occurs.

commit f87c44b90cb48a846160b16ff910545f5a659d15
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Apr 24 07:44:26 2007 -0400

    Try harder to make unplugging work.

commit 23309b334c1fe892f7afa735d04569e210497dc3
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Apr 24 07:34:53 2007 -0400

    Kill some more unused bits.

commit 1716ec88bbc980507aa7afeb133b552f77a91a01
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Apr 24 07:34:25 2007 -0400

    Handle driver removal cleanly, we now xfree everything we Xcalloc.
    
    NOTE: Someone needs to check for memory leaks, I'd be willing to bet
    a fair bit that we've got tons in the mouse and xkb code, but.

commit 246812bfbcd856ac0dea237cdbe252706fe17688
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Apr 24 07:01:54 2007 -0400

    Remove the evil xf86ActivateDevice declaration, don't need it anymore.
    
    Fix the crash on device unplug.
    
    NOTE: We still don't properly get rid of ourselves.

commit a0ea7363f51ff6c2bb81006b7220b7daa9ee9221
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Apr 24 06:49:11 2007 -0400

    Remove all of evdev_brain.c and all callers.
    
    Remove the non-functional 2.4 kernel compiling compatibility.
    
    Remove the XInput 1.4+ SendCoreEvents/DontSendCoreEvents define replacements.
    
    Remove evdevDriver, some stuff from evdevDevice, all users.
    
    NOTE: This WILL BREAK all existing configurations.
    
    NOTE: Device read failure segfaults, don't unplug stuff.

commit 3c4a96fbd851e46830fe82570d04e191bae5e8e3
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Apr 24 06:12:14 2007 -0400

    Updated configure to 1.2.0, no changes yet.
    
    This branch is the great xserver input-hotplug rewrite, consider it unstable
    but usable with the 'current' (as of this commit) git xserver.
    
    (Once it's more done that is.)
    
    NOTE: This branch will _not_ remain source or binary compatable with
    pre-input-hotplug xservers, you have been warned.

commit ba65c34068a836ae393565a6a8260a4e96709816
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Mon Apr 23 10:08:48 2007 +0930

    Remove driver from list if no device is associated any more.
    
    This effectively stops the driver from hotplugging new devices. Devices have
    to be added with the dbus hotplugging events.

commit 9644a4afbfd8ac4cb51facf0409f73f55743d8a3
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Thu Apr 19 15:40:25 2007 +0930

    Remove direct call to DEVICE_INIT, ActivateDevice() takes care of that.

commit d37ba205bba0be782e3cd02ca7cedb98a304482d
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Thu Apr 19 15:38:26 2007 +0930

    Add some documentation to evdev.c and evdev_brain.c.

commit 9875e2f7f96c6bfc4f01fffc7e1127724bbd0b7d
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Thu Apr 19 11:28:13 2007 +0930

    ActivateDevice() before EnableDevice() in EvdevNew.

commit 6db4a9fb84f828f745202c3fddc58d389fca220b
Author: Peter Hutterer <peter@cs.unisa.edu.au>
Date:   Sun Mar 25 15:40:26 2007 +0930

    Key: Remove duplicate of keycode 0x6f, remove index 0xf8 to get a
    maxKeyCode of 255. This way keycode range is in sync with core keyboard range.

commit a9e87f29ccdadebb0742317bb57d66eaaca4b593
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Wed Mar 21 12:19:48 2007 +0200

    Key: Force maximum keycode to be 255
    Even though we don't have keycodes for anything above 127, make sure our
    map always covers up to 255.  This ensures that the keycode range never
    changes.

commit b4a5a20476f7bc77d54a860d7cdd81c223bdb81f
Author: Tiago Vignatti <vignatti@c3sl.ufpr.br>
Date:   Wed Feb 14 19:23:21 2007 -0200

    Fix pointer crossing screen bug. Possibly the others input drivers must update
    this on the same manner.

commit 24f9e67a8f9729fa7cb10f0479a3be9c16c5d13a
Author: Philip Langdale <philipl@fido2.homeip.net>
Date:   Sat Feb 10 22:17:01 2007 -0800

    Stop caching the screen size for scaling.
    
    Do be able to correctly scale absolute inputs, the actual
    screen size must be used as this changes when the screen
    resizes.

commit d8d8f114caece4c26c777ae6eee57e66b1f499e7
Author: root <root@agamemnon.b5>
Date:   Wed Jan 17 19:27:40 2007 -0500

    For reasons related to handling pathological remapping cases, and
    differences between HID and X, pretend a middle button exists
    whenever a right button exists.

commit ebb30a554fe084a50c7281defea80c38bc1b0ddd
Author: root <root@agamemnon.b5>
Date:   Sat Jan 13 07:33:49 2007 -0500

    Fix a bug where we potentially wrote garbage events when LEDs change.
    
    Support setting keyboard repeat rate/period.

commit 3d8bb262e42b1c5442aebb4048c71b4dc8ce24a0
Author: root <root@agamemnon.b5>
Date:   Thu Jan 11 22:42:19 2007 -0500

    Handle swapping of right and middle buttons better in some odder cases.

commit 987c6b1597f184e035c3ecef15a776f7c64cd4fe
Author: root <root@agamemnon.b5>
Date:   Thu Jan 11 22:41:23 2007 -0500

    No more call to xf86OSRingBell in any cases,
     maybe do some conditional stuff later.

commit 8155e49e76aa2d1d953fb71ead6a5c3110f3d80c
Author: root <root@agamemnon.b5>
Date:   Mon Jan 8 08:59:44 2007 -0500

    Pad out button_names so we can loop over things more sanely.
    
    Support for ignoring the existance of buttons,
    and for not telling X about them.
    
    By default don't tell X about tools and touch as buttons.
    TODO: Revisit this choice later.

commit e1fe72e7fe663a479a5be1b5e16ecbba52f511a8
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Sat Dec 16 01:42:18 2006 +0200

    bump to 1.1.5

commit 9f3be57929048950ad0e03cfef44b5336c38aab3
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Wed Dec 6 18:50:15 2006 +0200

    Makefile.am: make ChangeLog hook safer
    Make ChangeLog hook as safe as possible.

commit 5a5457e69c719980334cb662e5abcb77cd09bc7a
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Thu Nov 2 03:42:57 2006 +0200

    bump to 1.1.4

commit 3fc70342aaba5f95d01b6e51164ae207532fa8f4
Merge: 1a8cea3 ef01c2e
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Thu Nov 2 03:42:14 2006 +0200

    Merge branch 'input-hotplug'

commit 1a8cea3dc4d8336b61a071a52479e71d7dd619d4
Merge: 51d21a3 4c72fb7
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Thu Nov 2 03:42:13 2006 +0200

    Merge branch 'master' of git+ssh://git.freedesktop.org/git/xorg/driver/xf86-input-evdev

commit ef01c2ef65fa64cb213dc3adfa30c75635d1fe03
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Thu Nov 2 03:41:48 2006 +0200

    key: use os bell-ringing function
    Use the OS bell-ringing function to ding the bell.

commit 036b457c1b3f7d2d174da890cb8598d907181f8e
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Wed Oct 25 02:22:46 2006 +0300

    support new DIX motion history API
    Use the DIX motion history if we have ABI version 1 or higher.

commit 79eb7dcac8cdbecc07be08737388a8a6574e3d76
Merge: d7f686b 63f7edf
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Tue Oct 17 11:32:39 2006 +0300

    Merge branch 'input-hotplug' of git+ssh://git.freedesktop.org/git/xorg/driver/xf86-input-evdev into input-hotplug

commit d7f686bfa3e773cfc7740c707da9fc64196e143c
Merge: ec09e0d 4c72fb7
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Tue Oct 17 11:31:58 2006 +0300

    Merge branch 'master' of git+ssh://git.freedesktop.org/git/xorg/driver/xf86-input-evdev into input-hotplug

commit ec09e0d55dd14164cc46a68a71d439cc550df063
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Sun Oct 15 19:37:46 2006 +0300

    brain: call xf86DeleteInput when removing device
    Call xf86DeleteInput from evdevRemoveDevice, so it also gets removed from
    xf86InputDevs in the DDX.

commit 4c72fb7b769b78cfa2b4cc39eb03fdacd2b5039c
Author: Adam Jackson <ajax@benzedrine.nwnk.net>
Date:   Fri Oct 13 18:25:10 2006 -0400

    Bump to 1.1.3

commit 77cbbc20b60fd564f8add39bfb840c85d5cad51d
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Sun Oct 8 16:14:12 2006 +0300

    key: remove usage of OS keyboard layer for bell
    Right now, bell is a no-op.

commit 5c5ef3fbd6eb0b668139df3ff5eda67766e86dcd
Author: Drew Parsons <dparsons@debian.org>
Date:   Fri Oct 6 10:56:24 2006 +1000

    m68k support (thanks Geert Uytterhoeven for the inotify codes).

commit a96b048e560782399a98c57cad255df778471ea1
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Mon Oct 2 17:50:55 2006 -0400

    Make some debugging messages optional.
    
    Correctly handle emulating relative mode from absolute data in the case where
    we do not get X and Y data at the same time on touching.

commit d8ea40dc4a78a6197d474d806ac5367dae83655a
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Mon Oct 2 17:49:20 2006 -0400

    Use XORG_VERSION_CURRENT in the module version struct.

commit ab65184d472614d2664e6cd7bca2d6dbc28fad07
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Sun Sep 10 06:47:15 2006 -0400

    Fix compilation.

commit 63f7edf7862032221e25de3c59fee1158d616597
Merge: 7b91f92 771eee9
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Jul 25 16:00:44 2006 -0400

    Merge branch 'master' of git+ssh://git.freedesktop.org/git/xorg/driver/xf86-input-evdev into input-hotplug

commit 771eee968282e308d997adfa78bd39e7429d2c1c
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Sun Jul 23 22:40:51 2006 -0400

    Replace the old two buffer approach to handling rel emulation of abs axes,
    should help with some of the reported jitter problems.

commit e4681504487151553894ae0d513b9e833d2597d1
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Fri Jul 21 14:38:12 2006 -0400

    fix InitValuatorClassDeviceStruct call
    I don't know how the last parameter got there.  Sorry.

commit fa03de438ea0ae0f07424235f4972e73ff88ef17
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Wed Jul 19 23:06:23 2006 -0400

    Move the axis to button map code back into the rel code.
    
    This might solve some problems, but should at least prevent some odd behavior.

commit 7b91f9277afb4bd9e557f9600bd92c68dd2435c9
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Wed Jul 19 19:45:27 2006 -0400

    pass maxval correctly to xf86InitValuatorAxisDeviceStruct
    Pass a maxval of -1 (i.e., fill this in appropriately), rather than 0 (0).

commit 7defeb0aefb216d203b495a53a6d1d505f7dece4
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Wed Jul 19 19:43:08 2006 -0400

    pass number of axes to InitValuatorClassDeviceStruct
    This is now required with the input-hotplug server.

commit 1cb568c0a6c18ec62ebb89ca21a22a77c78cad24
Author: Daniel Stone <daniel.stone@nokia.com>
Date:   Wed Jul 19 19:41:54 2006 -0400

    prune device list on DEVICE_CLOSE
    Remove a device from the device list when we get DEVICE_CLOSE.

commit dc88668839f4613d60526aa78aed3e74eebe64ad
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Thu Jul 13 11:59:25 2006 -0400

    Split the New functions so that structs can be allocated and buttons
    detected, and then stuff that depends on _other_ areas.
    (Specificly, axes and btn have a circular dependency on which one has to
    run first, this solves that.)
    
    Add button names, and a way to get a button number from a name.
    
    Add a function for checking to see if a button exists, takes the number from the previous function.
    
    Change the (unused) state array of pointers in the button struct to an array of pointers to functions for callback.
    
    Implemented the 'touch' feature, on by default if BTN_DIGI_TOUCH exists,
    won't, in rel mode, process x/y data unless it's down, and is used to
    try and make 'pick up stencil, move to other side of digitizer, set back
    down' not jump to the other side of the screen in rel mode.
    (This doesn't work as well as it could, but I'm fairly sure that it's
    due to the quality of the absolute input device I'm using, but feedback
    would be really nice.)
    
    FIXME: Update the manpage for this.

commit 090d43acf315283effe8a1c858cac8167ebe4d08
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Jul 11 16:47:15 2006 -0400

    Update the .gitignore files to remove some more noise.

commit 1b9a9599a4df85b0e925086d12bd48626b09bb45
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Jul 11 16:44:43 2006 -0400

    Rename .cvsignore to .gitignore.

commit f7a9c74fbccd79bf406b0afc41237303642b75c2
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Jul 11 16:42:41 2006 -0400

    Grab the ChangeLog generation rule from libX11.

commit 9cb7c3dbad1a4afdb84c338e83f597455022dcdc
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Jul 11 12:48:10 2006 -0400

    (Hope this works.)
    Remove the ChangeLog file, as the entire contents can be gotten via 'git log'.

commit eba5ea8d5a19f2b1984cbf20c95d22e243f19567
Author: Zephaniah E. Hull <warp@agamemnon.b5>
Date:   Tue Jul 11 03:08:30 2006 -0400

    Set pInfo->fd to -1 when we close it in EvdevProc.

commit 51d21a369416bb0a45a2894e83a1cb092cc307d8
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Sun Jul 9 18:08:50 2006 +0100

    remove XFree86LOADER usage
    Build evdevModuleData, et al, unconditionally.

commit 4645247d45b1653c56d8c99d5685960159e464be
Author: Adam Jackson <ajax@nwnk.net>
Date:   Thu Jun 22 21:16:44 2006 +0000

    MIPS support. (Joshua Kinard)

commit 57a7f2844108072bf03c9f82baf92e3447d18fbe
Author: Adam Jackson <ajax@nwnk.net>
Date:   Fri Jun 2 19:39:52 2006 +0000

    Fix an obvious bogon to avoid crashing on absolute axis setup.

commit 1b03250797daa0ac98323a9f43e895dd0b5c7761
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Mon May 15 22:47:23 2006 +0000

    Hopefully fix the bitops stuff to actually _work_.

commit e9c60da89a9c55b81b2dedcf6ee3d1aefb4ff591
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Sun May 14 11:55:50 2006 +0000

    Tweak credits and references.
    Change the longs to unsigned longs in the bitfields.
    Cleanup our includes.
    Stop pulling in asm/types.h and asm/bitops.h.
    Conditionally define the stuff that used to come from the above, including
        our own test_bit, set_bit and clear_bit.
    Change the longs to unsigned longs in the bitfields.
    Change the longs to unsigned longs in the bitfields.
    Use the bitop defines in evdev.h properly.
    Change the longs to unsigned longs in the bitfields.
    Change the longs to unsigned longs in the bitfields.
    Use the bitop defines in evdev.h properly.
    Change the longs to unsigned longs in the bitfields.
    Use the bitop defines in evdev.h properly.
    Add HPPA/HPPA64 entries. (Thanks to Fabio M. Di Nitto
        <fabbione@ubuntu.com>)

commit eca922bd95fbcf09dd0839e571dc30263c94172f
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Sun Apr 30 21:39:08 2006 +0000

    xf86-input-evdev v1.1.2
    Bugzilla #6734 <https://bugs.freedesktop.org/show_bug.cgi=6734> Apply patch
        from Philip Langdale which causes us to make sure that O_NONBLOCK is
        set on the inotify device.

commit f75aadfd628db727e6732c2f0df0c17e75bdeda6
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Sat Apr 15 13:01:36 2006 +0000

    xf86-input-evdev v1.1.1

commit cffc51e04aba0090dfb663d2927117318b5ea00c
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Fri Apr 14 07:01:37 2006 +0000

    evdevAbsRec: Remove the scale bool, rename scale_x and scale_y to scale[2].
        evdevAxesRec: Make btnMap an int array instead of a Card8 array.
    Make abs support and non-core stuff actually work.
    Relative emulation for abs mode is still a bit broken, but that's far less
        critical.
    How many buttons we've registered is configuration information, not an
        error message.

commit c968040cde4e1a7c73332701008f6abfb1fa3ab3
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Sun Apr 9 00:41:42 2006 +0000

    Remove a debugging message.
    Actually, well, _work_. Note, abs support still segfaults, I'll debug it
        after I've slept. But I should get it tomorrow.

commit 880879015bf1eec49d374274d644ba015a6a4610
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Sat Apr 8 21:55:17 2006 +0000

    Dropped the xorg-xserver 1.0.99.901 requirement. (Things were tweaked to
        mostly work for older servers again.)
    Close the device properly on read errer.
    Minimal inotify support, not ideal yet, but...
    Minimal inotify support, not ideal yet, but...
    Minimal inotify support, not ideal yet, but...

commit c97fdb44493e55f3456222855293016a596ff56e
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Sat Apr 8 17:23:06 2006 +0000

    Remove evdev_abs.c and evdev_rel.c. Added evdev_axes.c.
    Change the calls to refer to EvdevAxes instead of Abs and Rel. Include
        mipointer.h. (Fixes a compile error.) Remove an unused variable from
        EvdevReadInput.
    Removed evdev_abs.c and evdev_rel.c, added evdev_axes.c. Added count to rel
        and abs. Moved btnMap from rel to the new axes. Shuffle some includes,
        and include stdarg.h.
    Removed.
    New, a mix of rel and abs that should actually work in the rel case.
    Rearrange include order. btnMap was moved from being part of rel to being
        part of axes.
    Removed.
    Rearrange include order.
    Rearrange include order.
    NOTE: This commit has been compile tested, not run tested.
    I have some other changes to make before I can do more heavy testing.

commit ad4d62e1d318c629f994883e3b9926627bec16f0
Author: Adam Jackson <ajax@nwnk.net>
Date:   Fri Apr 7 17:30:27 2006 +0000

    Unlibcwrap. Bump server version requirement. Bump to 1.1.0.

commit e9a6f6d1a0b5cf6f7dc4fb122f6d28cbf3929960
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Fri Mar 31 18:11:52 2006 +0000

    Fix the fd pointer leak reported by primer. (Not the same patch.)
    Disable the undocumented xkb guts options in the key driver. (Requested by
        Daniel Stone.)

commit 05b56eeb5c74aebe81de7550c41546d7d6f3fb0c
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Thu Mar 16 13:09:19 2006 +0000

    Switch from my own globbing function to fnmatch.
    Detect keys numbered higher then buttons. Remove the (depreciated since
        long before xkb support was added to evdev) XkbKeymap option.

commit a3149dc44a36a46cc117a2fde43ee348a2371304
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Thu Mar 16 13:05:04 2006 +0000

    Update to include all the new device matching options.

commit 9972f2b1c77eefe5fb6a2ba7baacaf6b273228a8
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Mon Feb 27 13:22:35 2006 +0000

    Don't leave keys in the down state when we get turned off. (VT switching,
        getting unplugged, that sort of stuff.)

commit 94cb4aa1f8caf1ba141ab0839c9eb0b2b5357470
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Mon Feb 27 10:48:40 2006 +0000

    Better error reporting if the read fails.
    Work properly if we're defining entirely by capability maps.

commit 47482dad76ab74c0b5c9e8d455f04935651173ec
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Fri Feb 24 13:44:56 2006 +0000

    Compile with -Wall now. Add evdev.h to the sources so that make distcheck
        gets it.
    Bugzilla #5943 <https://bugs.freedesktop.org/show_bug.cgi=5943> Make sure
        we include errno.h.
    Reduce EVDEV_MAXBUTTONS to 96.
    Split up evdevStateRec into a struct with pointers to new structs for btn,
        abs, rel, and key.
    New structure type for handling the device capability bitmaps.
    Add device bits and struct input_id to evdevDeviceRec.
    Add matching device bits, struct input_id, and pass number to
        evdevDriverRec.
    Prototype for evdevGetBits from evdev_brain.c.
    Conversion for the evdevStateRec split.
    Remove the errno.h include, it's in evdev.h for now.
    Move the bit getting from the drivers to here, into evdevDeviceRec.
    Fix a rare case of fd leakage.
    Add several new (and somewhat ugly) device matching options: <map>Bits:
        Where map is one of ev, key, rel, abs, msc, led, snd, or ff. In the
        format of '+0 +3 -1-2 ~5-10', requires bits 0 and 3 be set, bits 1 and
        2 to not be set, and at least one bit in the range of 5 to
    10 be set. bustype, vendor, product, and version: Simple integer options
        for matching the struct device_id fields, must be 0 (the default) or
        the exact value you wish to match against. pass: Bounded to 0-3,
        devices are matched to the first matching entry found, order for
        multiple matching entries in the same pass is undefined, but it starts
        with pass 0 and goes to pass 3.
    Adaptation for the evdevStateRec split and the change in capability bitmap
        handling.
    Add evdevGetBits to fill the new evdevBitsRec struct type.
    Lots of somewhat ugly code for matching by capability bits.
    Split out of evdevRescanDevices to smaller handling functions. The new
        design should be better if I decide to handle arbitrary Device fields
        again.
    Adaptation for the evdevStateRec split and the change in capability bitmap
        handling.
    Handle all buttons, no button compression at this time, however we reorder
        things so that BTN_MOUSE comes before BTN_MISC, somewhat evily.
    Support for the new btn->state[] array of int pointers.
    Adaptation for the evdevStateRec split and the change in capability bitmap
        handling.
    Adaptation for the evdevStateRec split and the change in capability bitmap
        handling.
    I really hope I didn't miss any changes.

commit 739a0f51b07bd3fdccc156358bf9fca302477042
Author: Lars Knoll <lars@trolltech.com>
Date:   Fri Feb 24 12:14:32 2006 +0000

    include errno.h to make it compile.

commit 763edd37305e789bcc31746e5ea41f4df9d0b2a4
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Mon Feb 20 09:18:56 2006 +0000

    Bugzilla #5950 <https://bugs.freedesktop.org/show_bug.cgi=5950> Possible
        (maybe) fix for bug #5950. Though, I'm not convinced and still don't
        see how this bug could be happening, especially if this doesn't do it.

commit c6dbf89d9d40fcbce72493404ea02b7e7957513f
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Sun Feb 19 19:11:04 2006 +0000

    Add bell support.

commit 28ee08ef0810ad48c612280838be3e952c41971d
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Fri Feb 17 01:17:41 2006 +0000

    Bugzilla #5914 <https://bugs.freedesktop.org/show_bug.cgi?id=5914> Stupid
        little bug, properly handle wheels on 3 button mice.

commit e7d4e6b11eb4cc026e91fd561fda24d9cf19adc4
Author: Zephaniah E. Hull <warp@aehallh.com>
Date:   Tue Feb 14 14:57:37 2006 +0000

    Bugzilla #5696 <https://bugs.freedesktop.org/show_bug.cgi?id=5696> Slightly
        updated version of the patch listed. Basicly a rewrite of the driver,
        with a few pieces of the old. XKB support, proper device matching,
        basic absolute pointer support. Lots more, will require some user
        config changes.

commit edbe44da9ae05469d28502af585cd2259d57d104
Author: gravity <gravity>
Date:   Mon Jan 9 05:19:26 2006 +0000

    Add evdev manpage

commit 6808674886a13c866bfeeb3ca5f3b8db72e3d5ca
Author: Kevin E Martin <kem@kem.org>
Date:   Wed Dec 21 02:29:56 2005 +0000

    Update package version for X11R7 release.

commit 5ae3abc1b3fda25d60a207c08b510c3a4f8c0148
Author: Adam Jackson <ajax@nwnk.net>
Date:   Mon Dec 19 16:25:50 2005 +0000

    Stub COPYING files

commit c58133445ee112901ea69023cac7afb3ca8d8064
Author: Kevin E Martin <kem@kem.org>
Date:   Thu Dec 15 00:24:14 2005 +0000

    Update package version number for final X11R7 release candidate.

commit b82e57a082662311cc47abbfc6a15b358be539d6
Author: Kevin E Martin <kem@kem.org>
Date:   Tue Dec 6 22:48:29 2005 +0000

    Change *man_SOURCES ==> *man_PRE to fix autotools warnings.

commit f56f4462f605348f90387308c028f622a5585231
Author: Kevin E Martin <kem@kem.org>
Date:   Sat Dec 3 05:49:30 2005 +0000

    Update package version number for X11R7 RC3 release.

commit 36fc29d0103707676b3d1ddfb3700457812779f8
Author: Kevin E Martin <kem@kem.org>
Date:   Fri Dec 2 02:16:05 2005 +0000

    Remove extraneous AC_MSG_RESULT.

commit 27690c112a2a890e7b556e51bbc5a42864671fc4
Author: Adam Jackson <ajax@nwnk.net>
Date:   Tue Nov 29 23:29:55 2005 +0000

    Only build dlloader modules by default.

commit a8ca6bc2d461288928f8ec907fb3dd40dc1642ca
Author: Alan Coopersmith <Alan.Coopersmith@sun.com>
Date:   Mon Nov 28 22:04:06 2005 +0000

    Change *mandir targets to use new *_MAN_DIR variables set by xorg-macros.m4
        update to fix bug #5167 (Linux prefers *.1x man pages in man1 subdir)

commit 753e3320afd033122c9186382866ad8334bc7b7f
Author: Eric Anholt <anholt@freebsd.org>
Date:   Mon Nov 21 10:49:03 2005 +0000

    Add .cvsignores for drivers.

commit abcef337586d3862323ea5f77803a369d28aa90b
Author: Kevin E Martin <kem@kem.org>
Date:   Wed Nov 9 21:15:11 2005 +0000

    Update package version number for X11R7 RC2 release.

commit e7fa7d71e5c341027b6bfe47d8c6356d6ed7e92e
Author: Kevin E Martin <kem@kem.org>
Date:   Tue Nov 1 15:08:49 2005 +0000

    Update pkgcheck depedencies to work with separate build roots.

commit f8c131fff1a2adcb772aa5808559e93df2d442c3
Author: Kevin E Martin <kem@kem.org>
Date:   Wed Oct 19 02:48:00 2005 +0000

    Update package version number for RC1 release.

commit b543623997a1a7eda5c681bd431778e0a8da1347
Author: Kevin E Martin <kem@kem.org>
Date:   Tue Oct 18 15:46:36 2005 +0000

    Do the following to make the drivers pass distcheck:
    - Only define EXTRA_DIST when there are actually man pages to be processed
    - Add missing man pages to keyboard and ati drivers EXTRA_DIST

commit efcacda000e3020cf1c5348aec8e19f68f268a4b
Author: Alan Coopersmith <Alan.Coopersmith@sun.com>
Date:   Tue Oct 18 00:01:51 2005 +0000

    Use @DRIVER_MAN_SUFFIX@ instead of $(DRIVER_MAN_SUFFIX) in macro
        substitutions to work better with BSD make

commit 1d4cfdd373207d685c89e240c611a0197bce18ec
Author: Adam Jackson <ajax@nwnk.net>
Date:   Mon Oct 17 22:57:27 2005 +0000

    More 1.7 braindamage: define EXTRA_DIST in terms of @DRIVER_NAME@ instead
        of indirectly

commit ae0f10570960fc87c566d9084c7a3e78b05ce5ce
Author: Alan Coopersmith <Alan.Coopersmith@sun.com>
Date:   Mon Oct 17 00:08:55 2005 +0000

    Use sed & cpp to substitute variables in driver man pages

commit ce0cafa1151841b46dedce616472cf5f38ffde83
Author: Adam Jackson <ajax@nwnk.net>
Date:   Fri Sep 23 22:32:23 2005 +0000

    Bug #3913: Suppress kernel-generated repeat events for chording keys.

commit 7d5839eb992e0a217b8368762cab80fa7a15faa2
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Thu Aug 18 09:03:38 2005 +0000

    Update autogen.sh to one that does objdir != srcdir.

commit 88befc6f4b58a0353984a85a46c0107c8a3a4067
Author: Søren Sandmann Pedersen <sandmann@daimi.au.dk>
Date:   Wed Aug 10 14:07:22 2005 +0000

    Don\'t lose existing CFLAGS in all the input drivers and some of the video
        drivers

commit 8c4fcc1acdbd9e27e8e039c333f5abf77f81e6cf
Author: Kevin E Martin <kem@kem.org>
Date:   Fri Jul 29 21:22:40 2005 +0000

    Various changes preparing packages for RC0:
    - Verify and update package version numbers as needed
    - Implement versioning scheme
    - Change bug address to point to bugzilla bug entry form
    - Disable loadable i18n in libX11 by default (use --enable-loadable-i18n to
        reenable it)
    - Fix makedepend to use pkgconfig and pass distcheck
    - Update build script to build macros first
    - Update modular Xorg version

commit b446f59cc56494f1d3052c587ab9e3bfee89cd48
Author: Adam Jackson <ajax@nwnk.net>
Date:   Thu Jul 28 01:48:14 2005 +0000

    Yet more 2.4 build fixes, this time for BTN_TASK.

commit f745d59b6c03aec59b5f4c8d0f279296270f0b72
Author: Kristian Høgsberg <krh@redhat.com>
Date:   Mon Jul 25 16:07:34 2005 +0000

    Handle BTN_TASK too (#3859).

commit 0656b4a517b41c047830553d412bc2575f537d46
Author: Kevin E Martin <kem@kem.org>
Date:   Wed Jul 13 20:03:21 2005 +0000

    Make the module dir configurable

commit d1dd2dfe4d49cae4b813c83301b3bddadd704e85
Author: Kevin E Martin <kem@kem.org>
Date:   Wed Jul 13 02:20:59 2005 +0000

    Update all input drivers to pass distcheck

commit 29621860ab38f318d8b19551391ac7997b8af2de
Author: Adam Jackson <ajax@nwnk.net>
Date:   Tue Jul 12 06:15:08 2005 +0000

    Build skeletons for input drivers. Should basically work.

commit 74021126a6e5e9075025911cb9c0b5273f70fda2
Author: Adam Jackson <ajax@nwnk.net>
Date:   Mon Jul 11 02:37:59 2005 +0000

    Prep input drivers for modularizing by adding guarded #include "config.h"

commit 672f8cd6616cd8cf97e9d01b4c408d9c59f09a7f
Author: Adam Jackson <ajax@nwnk.net>
Date:   Sun Jul 3 00:06:01 2005 +0000

    Add some build compatibility for 2.6 linux systems with 2.4 kernel headers
        installed. Allow the use of evdev for mice on 2.4 kernels.

commit 0145e216a7321011dc3bef7f9a0833ffbb61b953
Author: Adam Jackson <ajax@nwnk.net>
Date:   Sat Jun 25 21:17:01 2005 +0000

    Bug #3626: _X_EXPORT tags for video and input drivers.

commit df1b2f476dde1f6cbc13e9731d772a42baf97adb
Author: Adam Jackson <ajax@nwnk.net>
Date:   Wed May 11 00:13:15 2005 +0000

    Bug #968: Grab the event device used by the evdev driver to avoid weird
        issues when input goes to multiple places. Restrict building the evdev
        driver to 2.6 kernels since EVIOCGRAB didn't exist in 2.4.

commit 319e1b28a37c3b5511f0cf8ab627f9e4f0924634
Author: Kristian Høgsberg <krh@redhat.com>
Date:   Tue Jan 18 20:18:09 2005 +0000

    Handle horizontal wheel events and move mapping of extra buttons up so they
        don't overlap the wheel buttons. Patch from Alan Swanson (#968).

commit 4ada85ef11c56d5d998a4187d5ed1c557b7098bd
Author: Adam Jackson <ajax@nwnk.net>
Date:   Fri Jan 14 17:14:07 2005 +0000

    Build fixes for static server.

commit bdd94f37b31f78ebd2b13e7d263e8ee0dbbb0fb3
Author: Kristian Høgsberg <krh@redhat.com>
Date:   Wed Jan 12 20:15:52 2005 +0000

    Add new evdev input driver. This driver uses the linux input layer directly
        and can handle both mice and keyboards.
    Convert this to UTF-8 again. The ChangeLog should be kept in UTF-8.
